//
// ------------------------------------------------------------------------------------
//
// Entity_MyOrder.pas -- This entity class unit for table "MyOrder". 
//
//                          Generated by QuickBurro V4.0.0.0 Entity Classes Generator
//
//                          Generate time: 2011-04-17 23:33:19
//
//                          Copyright (C) Jopher Software Studio, 2006-2010
//
// ------------------------------------------------------------------------------------
//

unit Entity_MyOrder;

interface

uses
  SysUtils, Classes, db, DBClient, 
{$IFDEF UNICODE}
AnsiStrings,
{$ENDIF}
  DBAccessor, QBParcel, Entity_MyOrderDetail;

type
  TMyOrder = class(TPersistent)

  Private
    ff_OrderId: Integer;
    ff_OrderDate: String;
    ff_CustomerName: String;
    ff_Saler: String;
    ff_AllMoney: Double;
    ff_MyOrderDetail_List: TMyOrderDetailList;

    class function CreateCds: TClientDataset;

  public
    Property f_OrderId: Integer read ff_OrderId write ff_OrderId;
    Property f_OrderDate: String read ff_OrderDate write ff_OrderDate;
    Property f_CustomerName: String read ff_CustomerName write ff_CustomerName;
    Property f_Saler: String read ff_Saler write ff_Saler;
    Property f_AllMoney: Double read ff_AllMoney write ff_AllMoney;
    Property f_MyOrderDetail_List: TMyOrderDetailList read ff_MyOrderDetail_List write ff_MyOrderDetail_List;

    constructor Create;
    destructor Destroy; override;
    class function ReadFromCds(aCds: TClientDataset): TMyOrder;
    procedure LoadAppertains(DBA: TDBAccessor);
    function SaveToCds(Cds: TClientDataset): Boolean;
    class function ReadFromDB(DBA: TDBAccessor; Condition: String): TMyOrder;
    function DeleteFromDB(DBA: TDBAccessor; Condition: String): boolean;
    function InsertToDB(DBA: TDBAccessor): boolean;
    function UpdateToDB(DBA: TDBAccessor; Condition: String): boolean;

  end;

  TMyOrderList = class(TList)

  public    
    constructor Create;
    destructor Destroy; override;
    class function ReadFromDB(DBA: TDBAccessor; Condition: String = ''; OrderBy: String = ''): TMyOrderList;
    class function ReadFromCDS(Cds: TClientDataset): TMyOrderList;
    function SaveToCds(aCds: TClientDataset): boolean;
    function SaveToFile(FileName: String; DataFormat: TDataPacketFormat): boolean;
    function LoadFromFile(FileName: String): boolean;
    function SaveToStream(aStream: TMemoryStream; DataFormat: TDataPacketFormat): boolean;
    function LoadFromStream(aStream: TMemoryStream): boolean;
    function SaveToParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
    function LoadFromParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
    
  end;

implementation

{ TMyOrder }

//
// Create client dataset for the table...
class function TMyOrder.CreateCds: TClientDataset;
begin
  Result:=TClientDataset.Create(nil);
  with Result do
     begin
        with FieldDefs.AddFieldDef do
           begin
              Name:='OrderId';
              DataType:=ftInteger;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='OrderDate';
              DataType:=ftString;
              Size:=10;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='CustomerName';
              DataType:=ftString;
              Size:=32;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='Saler';
              DataType:=ftString;
              Size:=16;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='AllMoney';
              DataType:=ftFloat;
           end;
        CreateDataSet;
     end;
  Result.Open;
end;

//
// Create an instance...
constructor TMyOrder.Create;
begin
  inherited;
  ff_OrderId:=0;
  ff_OrderDate:='';
  ff_CustomerName:='';
  ff_Saler:='';
  ff_AllMoney:=0.0;
  ff_MyOrderDetail_List:=TMyOrderDetailList.Create;
end;

//
// Destroy an instance...
destructor TMyOrder.Destroy;
begin
  If ff_MyOrderDetail_List<>nil then
     ff_MyOrderDetail_List.free;
  inherited;
end;

//
// Current Record to an object...
class function TMyOrder.ReadFromCds(aCds: TClientDataset): TMyOrder;
begin
  if (not aCds.active) or (aCds.RecordCount<=0) then
    begin
      Result:=nil;
      exit;
    end;
  Result := TMyOrder.Create;
  with Result do
    begin
      f_OrderId := aCds.FieldByName('OrderId').AsInteger;
      f_OrderDate := Trim(aCds.FieldByName('OrderDate').AsString);
      f_CustomerName := Trim(aCds.FieldByName('CustomerName').AsString);
      f_Saler := Trim(aCds.FieldByName('Saler').AsString);
      f_AllMoney := aCds.FieldByName('AllMoney').AsFloat;
    end;
end;

//
// Load the appertain properties...
procedure TMyOrder.LoadAppertains(DBA: TDBAccessor);
begin
  if ff_MyOrderDetail_List<>nil then
     ff_MyOrderDetail_List.free;
  ff_MyOrderDetail_List:=TMyOrderDetailList.ReadFromDb(DBA,'OrderId='+Inttostr(ff_OrderId),'');
end;

//
// Object to Current Record...
function TMyOrder.SaveToCds(Cds: TClientDataset): Boolean;
begin
   try
     Cds.edit;
     Cds.FieldValues['OrderId']:=ff_OrderId;
     Cds.FieldValues['OrderDate']:=ff_OrderDate;
     Cds.FieldValues['CustomerName']:=ff_CustomerName;
     Cds.FieldValues['Saler']:=ff_Saler;
     Cds.FieldValues['AllMoney']:=ff_AllMoney;
     Cds.post;
     result:=true;
   except
     result:=false;
   end;
end;

//
// Export class function...
class function TMyOrder.ReadFromDB(DBA: TDBAccessor; Condition: String): TMyOrder;
var
  SqlCommand: String;
  Cds: TClientDataset;
begin
  Result := nil;
  Cds:=TClientDataset.Create(nil);
  SqlCommand := 'SELECT * FROM [MyOrder] WHERE '+condition;
  if not DBA.ReadDataset(SqlCommand,Cds) then
     begin
       Cds.Free;
       exit;
     end;
  Result:=ReadFromCds(Cds);
  Result.f_MyOrderDetail_List:=TMyOrderDetailList.ReadFromDb(DBA,'OrderId='+Inttostr(Result.f_OrderId),'');
  Cds.Free;
end;

//
// Insert to database method...
function TMyOrder.InsertToDB(DBA: TDBAccessor): boolean;
var
  Cds: TClientDataset;
  i,j: integer;
begin
  Cds:=TMyOrder.CreateCds;
  try
     Cds.Append;
     Cds.FieldValues['OrderId']:=ff_OrderId;
     Cds.FieldValues['OrderDate']:=ff_OrderDate;
     Cds.FieldValues['CustomerName']:=ff_CustomerName;
     Cds.FieldValues['Saler']:=ff_Saler;
     Cds.FieldValues['AllMoney']:=ff_AllMoney;
     Cds.Post;
  except
     Cds.Free;
     Result:=false;
     exit;
  end;
  Result:=DBA.AppendRecord('[MyOrder]',Cds);
  if result then
     for i:=0 to ff_MyOrderDetail_List.Count-1 do
        begin
           if not TMyOrderDetail(ff_MyOrderDetail_List.items[i]).InsertToDB(DBA) then
              begin
                 result:=false;
                 break;
              end;
        end;
  Cds.Free;
end;

//
// Update to database method...
function TMyOrder.UpdateToDB(DBA: TDBAccessor; Condition: String): boolean;
var
  Cds: TClientDataset;
  tmpstr: string;
  i,j: integer; 
begin
  Cds:=TMyOrder.CreateCds;
  try
     Cds.Append;
     Cds.FieldValues['OrderId']:=ff_OrderId;
     Cds.FieldValues['OrderDate']:=ff_OrderDate;
     Cds.FieldValues['CustomerName']:=ff_CustomerName;
     Cds.FieldValues['Saler']:=ff_Saler;
     Cds.FieldValues['AllMoney']:=ff_AllMoney;
     Cds.Post;
  except
     Cds.Free;
     Result:=false;
     exit;
  end;
  Result:=DBA.UpdateRecord('[MyOrder]',Condition,Cds);
  if result then
     begin
        tmpstr:=trim(Condition);
        delete(tmpstr,1,length('OrderId')+1);
        if ff_MyOrderDetail_List.Count>0 then
           Result:=TMyOrderDetail(ff_MyOrderDetail_List.items[0]).DeleteFromDB(DBA,'OrderId='+tmpstr);
        if result then
           for i:=0 to ff_MyOrderDetail_List.Count-1 do
              begin
                 if not TMyOrderDetail(ff_MyOrderDetail_List.items[i]).InsertToDB(DBA) then
                    begin
                       result:=false;
                       break;
                    end;
              end;
     end;
  Cds.Free;
end;

//
// Delete from database method...
function TMyOrder.DeleteFromDB(DBA: TDBAccessor; Condition: String): boolean;
var
   SqlCommand,tmpstr: String;
   i: integer; 
begin
  SqlCommand:='DELETE FROM [MyOrder] WHERE '+condition;
  result:=DBA.ExecuteSQL(SqlCommand,false,(not DBA.InTransaction),tmpstr);
  if result then
     begin
        tmpstr:=trim(Condition);
        delete(tmpstr,1,length('OrderId')+1);
        for i:=0 to ff_MyOrderDetail_List.Count-1 do
           begin
              if not TMyOrderDetail(ff_MyOrderDetail_List.items[i]).DeleteFromDB(DBA,'OrderId='+tmpstr) then
                 begin
                    result:=false;
                    break;
                 end;
           end;
     end;
end;


{ TMyOrderList }

//
// Create an instance...
constructor TMyOrderList.Create;
begin
  inherited Create;
end;

//
// Destroy a TMyOrderList instance...
destructor TMyOrderList.Destroy;
var
  I: Integer;
  Obj: TObject;
begin
  for I := 0 to Count - 1 do
     begin
        Obj := Items[I];
        Obj.Free;
     end;
  inherited;
end;

//
// Create a TMyOrderList instance from remote table...
class function TMyOrderList.ReadFromDB(DBA: TDBAccessor; Condition: String; Orderby: String): TMyOrderList;
var
  SqlCommand: String;
  Cds: TClientDataset;
  TmpObj: TMyOrder;
begin
  Result := TMyOrderList.Create;
  Cds:=TClientDataset.Create(nil);
  if Condition='' then
     begin
        SqlCommand := 'SELECT '
                    +'[OrderId],'
                    +'[OrderDate],'
                    +'[CustomerName],'
                    +'[Saler],'
                    +'[AllMoney]'
                    +' FROM [MyOrder]'
     end
  else
     begin
        SqlCommand := 'SELECT '
                    +'[OrderId],'
                    +'[OrderDate],'
                    +'[CustomerName],'
                    +'[Saler],'
                    +'[AllMoney]'
                    +' FROM [MyOrder] WHERE '+Condition;
     end;
  if Orderby<>'' then
     SqlCommand:=SqlCommand+' ORDER BY '+Orderby;
  if not DBA.ReadDataset(SqlCommand,Cds) then
     begin
        Cds.Free;
        exit;
     end;
  Cds.First;
  while not Cds.Eof do
     begin
        TmpObj := TMyOrder.ReadFromCDS(Cds);
        Result.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
end;

//
// Create a TMyOrderList instance from CDS...
class function TMyOrderList.ReadFromCDS(Cds: TClientDataset): TMyOrderList;
var
  TmpObj: TMyOrder;
begin
  Result := TMyOrderList.Create;
  Cds.First;
  while not Cds.Eof do
     begin
        TmpObj := TMyOrder.ReadFromCDS(Cds);
        Result.Add(TmpObj);
        Cds.Next;
     end;
end;

//
// Save to ClientDataset...
function TMyOrderList.SaveToCds(aCds: TClientDataset): boolean;
var
  TmpObj: TMyOrder;
  i: integer;
  ok: boolean;
  Cds: TClientDataset;
begin
  Cds:=TMyOrder.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['OrderId']:=TmpObj.f_OrderId;
           Cds.FieldValues['OrderDate']:=TmpObj.f_OrderDate;
           Cds.FieldValues['CustomerName']:=TmpObj.f_CustomerName;
           Cds.FieldValues['Saler']:=TmpObj.f_Saler;
           Cds.FieldValues['AllMoney']:=TmpObj.f_AllMoney;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        aCds.data:=Cds.Data;
        Result:=true;
     end
  else
     Result:=false;
  Cds.Free; 
end;

//
// Save data to a file...
function TMyOrderList.SaveToFile(FileName: String; DataFormat: TDataPacketFormat): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrder;
  i: integer;
  ok: boolean;
begin
  Cds:=TMyOrder.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['OrderId']:=TmpObj.f_OrderId;
           Cds.FieldValues['OrderDate']:=TmpObj.f_OrderDate;
           Cds.FieldValues['CustomerName']:=TmpObj.f_CustomerName;
           Cds.FieldValues['Saler']:=TmpObj.f_Saler;
           Cds.FieldValues['AllMoney']:=TmpObj.f_AllMoney;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        try
           Cds.SaveToFile(String(FileName),DataFormat);
        except
           ok:=false;
        end;
     end;
  Cds.Free;
  result:=ok;
end;

//
// Load data from a file...
function TMyOrderList.LoadFromFile(FileName: String): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrder;
  ok: boolean;
begin
  self.Clear;
  Cds:=TClientDataset.Create(nil);
  try
     Cds.LoadFromFile(String(FileName));
     ok:=Cds.Active;
  except
     ok:=false;
  end;
  if not ok then
     begin
        cds.Free;
        result:=false;
        exit;
     end;
  cds.First;
  while not cds.Eof do
     begin
        TmpObj := TMyOrder.ReadFromCDS(Cds);
        Self.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
  result:=true;
end;

//
// Save data to a memorystream...
function TMyOrderList.SaveToStream(aStream: TMemoryStream; DataFormat: TDataPacketFormat): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrder;
  i: integer;
  ok: boolean;
begin
  Cds:=TMyOrder.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['OrderId']:=TmpObj.f_OrderId;
           Cds.FieldValues['OrderDate']:=TmpObj.f_OrderDate;
           Cds.FieldValues['CustomerName']:=TmpObj.f_CustomerName;
           Cds.FieldValues['Saler']:=TmpObj.f_Saler;
           Cds.FieldValues['AllMoney']:=TmpObj.f_AllMoney;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        try
           aStream.Clear;
           Cds.SaveToStream(aStream,DataFormat);
        except
           ok:=false;
        end;
     end;
  Cds.Free;
  result:=ok;
end;

//
// Load data from a memorystream...
function TMyOrderList.LoadFromStream(aStream: TMemoryStream): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrder;
  ok: boolean;
begin
  self.Clear;
  Cds:=TClientDataset.Create(nil);
  try
     aStream.Position:=0;
     Cds.LoadFromStream(aStream);
     ok:=Cds.Active;
  except
     ok:=false;
  end;
  if not ok then
     begin
        cds.Free;
        result:=false;
        exit;
     end;
  cds.First;
  while not cds.Eof do
     begin
        TmpObj := TMyOrder.ReadFromCDS(Cds);
        Self.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
  result:=true;
end;

//
// Save data to a QBParcel...
function TMyOrderList.SaveToParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrder;
  i: integer;
  ok: boolean;
begin
  Cds:=TMyOrder.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['OrderId']:=TmpObj.f_OrderId;
           Cds.FieldValues['OrderDate']:=TmpObj.f_OrderDate;
           Cds.FieldValues['CustomerName']:=TmpObj.f_CustomerName;
           Cds.FieldValues['Saler']:=TmpObj.f_Saler;
           Cds.FieldValues['AllMoney']:=TmpObj.f_AllMoney;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        try
           aParcel.PutCDSGoods(GoodsName,Cds);
           ok:=true;
        except
           ok:=false;
        end;
     end;
  Cds.Free;
  result:=ok;
end;

//
// Load data from a QBparcel...
function TMyOrderList.LoadFromParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrder;
  ok: boolean;
begin
  self.Clear;
  Cds:=TClientDataset.Create(nil);
  try
     aParcel.GetCDSGoods(GoodsName,Cds);
     ok:=Cds.Active;
  except
     ok:=false;
  end;
  if not ok then
     begin
        cds.Free;
        result:=false;
        exit;
     end;
  cds.First;
  while not cds.Eof do
     begin
        TmpObj := TMyOrder.ReadFromCDS(Cds);
        Self.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
  result:=true;
end;

end.
