//
// ------------------------------------------------------------------------------------
//
// Entity_MyOrderDetail.pas -- This entity class unit for table "MyOrderDetail". 
//
//                          Generated by QuickBurro V4.0.0.0 Entity Classes Generator
//
//                          Generate time: 2011-04-17 23:34:04
//
//                          Copyright (C) Jopher Software Studio, 2006-2010 
//
// ------------------------------------------------------------------------------------
//

unit Entity_MyOrderDetail;

interface

uses
  SysUtils, Classes, db, DBClient, 
{$IFDEF UNICODE}
AnsiStrings,
{$ENDIF}
  DBAccessor, QBParcel;

type
  TMyOrderDetail = class(TPersistent)

  Private
    ff_OrderId: Integer;
    ff_GoodsId: Integer;
    ff_GoodsName: String;
    ff_Price: Double;
    ff_Number: Double;
    ff_Money: Double;

    class function CreateCds: TClientDataset;

  public
    Property f_OrderId: Integer read ff_OrderId write ff_OrderId;
    Property f_GoodsId: Integer read ff_GoodsId write ff_GoodsId;
    Property f_GoodsName: String read ff_GoodsName write ff_GoodsName;
    Property f_Price: Double read ff_Price write ff_Price;
    Property f_Number: Double read ff_Number write ff_Number;
    Property f_Money: Double read ff_Money write ff_Money;

    constructor Create;
    destructor Destroy; override;
    class function ReadFromCds(aCds: TClientDataset): TMyOrderDetail;
    function SaveToCds(Cds: TClientDataset): Boolean;
    class function ReadFromDB(DBA: TDBAccessor; Condition: String): TMyOrderDetail;
    function DeleteFromDB(DBA: TDBAccessor; Condition: String): boolean;
    function InsertToDB(DBA: TDBAccessor): boolean;
    function UpdateToDB(DBA: TDBAccessor; Condition: String): boolean;

  end;

  TMyOrderDetailList = class(TList)

  public    
    constructor Create;
    destructor Destroy; override;
    class function ReadFromDB(DBA: TDBAccessor; Condition: String = ''; OrderBy: String = ''): TMyOrderDetailList;
    class function ReadFromCDS(Cds: TClientDataset): TMyOrderDetailList;
    function SaveToCds(aCds: TClientDataset): boolean;
    function SaveToFile(FileName: String; DataFormat: TDataPacketFormat): boolean;
    function LoadFromFile(FileName: String): boolean;
    function SaveToStream(aStream: TMemoryStream; DataFormat: TDataPacketFormat): boolean;
    function LoadFromStream(aStream: TMemoryStream): boolean;
    function SaveToParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
    function LoadFromParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
    
  end;

implementation

{ TMyOrderDetail }

//
// Create client dataset for the table...
class function TMyOrderDetail.CreateCds: TClientDataset;
begin
  Result:=TClientDataset.Create(nil);
  with Result do
     begin
        with FieldDefs.AddFieldDef do
           begin
              Name:='OrderId';
              DataType:=ftInteger;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='GoodsId';
              DataType:=ftInteger;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='GoodsName';
              DataType:=ftString;
              Size:=32;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='Price';
              DataType:=ftFloat;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='Number';
              DataType:=ftFloat;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='Money';
              DataType:=ftFloat;
           end;
        CreateDataSet;
     end;
  Result.Open;
end;

//
// Create an instance...
constructor TMyOrderDetail.Create;
begin
  inherited;
  ff_OrderId:=0;
  ff_GoodsId:=0;
  ff_GoodsName:='';
  ff_Price:=0.0;
  ff_Number:=0.0;
  ff_Money:=0.0;
end;

//
// Destroy an instance...
destructor TMyOrderDetail.Destroy;
begin
  inherited;
end;

//
// Current Record to an object...
class function TMyOrderDetail.ReadFromCds(aCds: TClientDataset): TMyOrderDetail;
begin
  if (not aCds.active) or (aCds.RecordCount<=0) then
    begin
      Result:=nil;
      exit;
    end;
  Result := TMyOrderDetail.Create;
  with Result do
    begin
      f_OrderId := aCds.FieldByName('OrderId').AsInteger;
      f_GoodsId := aCds.FieldByName('GoodsId').AsInteger;
      f_GoodsName := Trim(aCds.FieldByName('GoodsName').AsString);
      f_Price := aCds.FieldByName('Price').AsFloat;
      f_Number := aCds.FieldByName('Number').AsFloat;
      f_Money := aCds.FieldByName('Money').AsFloat;
    end;
end;

//
// Object to Current Record...
function TMyOrderDetail.SaveToCds(Cds: TClientDataset): Boolean;
begin
   try
     Cds.edit;
     Cds.FieldValues['OrderId']:=ff_OrderId;
     Cds.FieldValues['GoodsId']:=ff_GoodsId;
     Cds.FieldValues['GoodsName']:=ff_GoodsName;
     Cds.FieldValues['Price']:=ff_Price;
     Cds.FieldValues['Number']:=ff_Number;
     Cds.FieldValues['Money']:=ff_Money;
     Cds.post;
     result:=true;
   except
     result:=false;
   end;
end;

//
// Export class function...
class function TMyOrderDetail.ReadFromDB(DBA: TDBAccessor; Condition: String): TMyOrderDetail;
var
  SqlCommand: String;
  Cds: TClientDataset;
begin
  Result := nil;
  Cds:=TClientDataset.Create(nil);
  SqlCommand := 'SELECT * FROM [MyOrderDetail] WHERE '+condition;
  if not DBA.ReadDataset(SqlCommand,Cds) then
     begin
       Cds.Free;
       exit;
     end;
  Result:=ReadFromCds(Cds);
  Cds.Free;
end;

//
// Insert to database method...
function TMyOrderDetail.InsertToDB(DBA: TDBAccessor): boolean;
var
  Cds: TClientDataset;
begin
  Cds:=TMyOrderDetail.CreateCds;
  try
     Cds.Append;
     Cds.FieldValues['OrderId']:=ff_OrderId;
     Cds.FieldValues['GoodsId']:=ff_GoodsId;
     Cds.FieldValues['GoodsName']:=ff_GoodsName;
     Cds.FieldValues['Price']:=ff_Price;
     Cds.FieldValues['Number']:=ff_Number;
     Cds.FieldValues['Money']:=ff_Money;
     Cds.Post;
  except
     Cds.Free;
     Result:=false;
     exit;
  end;
  Result:=DBA.AppendRecord('[MyOrderDetail]',Cds);
  Cds.Free;
end;

//
// Update to database method...
function TMyOrderDetail.UpdateToDB(DBA: TDBAccessor; Condition: String): boolean;
var
  Cds: TClientDataset;
begin
  Cds:=TMyOrderDetail.CreateCds;
  try
     Cds.Append;
     Cds.FieldValues['OrderId']:=ff_OrderId;
     Cds.FieldValues['GoodsId']:=ff_GoodsId;
     Cds.FieldValues['GoodsName']:=ff_GoodsName;
     Cds.FieldValues['Price']:=ff_Price;
     Cds.FieldValues['Number']:=ff_Number;
     Cds.FieldValues['Money']:=ff_Money;
     Cds.Post;
  except
     Cds.Free;
     Result:=false;
     exit;
  end;
  Result:=DBA.UpdateRecord('[MyOrderDetail]',Condition,Cds);
  Cds.Free;
end;

//
// Delete from database method...
function TMyOrderDetail.DeleteFromDB(DBA: TDBAccessor; Condition: String): boolean;
var
   SqlCommand,tmpstr: String;
begin
  SqlCommand:='DELETE FROM [MyOrderDetail] WHERE '+condition;
  result:=DBA.ExecuteSQL(SqlCommand,false,(not DBA.InTransaction),tmpstr);
end;


{ TMyOrderDetailList }

//
// Create an instance...
constructor TMyOrderDetailList.Create;
begin
  inherited Create;
end;

//
// Destroy a TMyOrderDetailList instance...
destructor TMyOrderDetailList.Destroy;
var
  I: Integer;
  Obj: TObject;
begin
  for I := 0 to Count - 1 do
     begin
        Obj := Items[I];
        Obj.Free;
     end;
  inherited;
end;

//
// Create a TMyOrderDetailList instance from remote table...
class function TMyOrderDetailList.ReadFromDB(DBA: TDBAccessor; Condition: String; Orderby: String): TMyOrderDetailList;
var
  SqlCommand: String;
  Cds: TClientDataset;
  TmpObj: TMyOrderDetail;
begin
  Result := TMyOrderDetailList.Create;
  Cds:=TClientDataset.Create(nil);
  if Condition='' then
     begin
        SqlCommand := 'SELECT '
                    +'[OrderId],'
                    +'[GoodsId],'
                    +'[GoodsName],'
                    +'[Price],'
                    +'[Number],'
                    +'[Money]'
                    +' FROM [MyOrderDetail]'
     end
  else
     begin
        SqlCommand := 'SELECT '
                    +'[OrderId],'
                    +'[GoodsId],'
                    +'[GoodsName],'
                    +'[Price],'
                    +'[Number],'
                    +'[Money]'
                    +' FROM [MyOrderDetail] WHERE '+Condition;
     end;
  if Orderby<>'' then
     SqlCommand:=SqlCommand+' ORDER BY '+Orderby;
  if not DBA.ReadDataset(SqlCommand,Cds) then
     begin
        Cds.Free;
        exit;
     end;
  Cds.First;
  while not Cds.Eof do
     begin
        TmpObj := TMyOrderDetail.ReadFromCDS(Cds);
        Result.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
end;

//
// Create a TMyOrderDetailList instance from CDS...
class function TMyOrderDetailList.ReadFromCDS(Cds: TClientDataset): TMyOrderDetailList;
var
  TmpObj: TMyOrderDetail;
begin
  Result := TMyOrderDetailList.Create;
  Cds.First;
  while not Cds.Eof do
     begin
        TmpObj := TMyOrderDetail.ReadFromCDS(Cds);
        Result.Add(TmpObj);
        Cds.Next;
     end;
end;

//
// Save to ClientDataset...
function TMyOrderDetailList.SaveToCds(aCds: TClientDataset): boolean;
var
  TmpObj: TMyOrderDetail;
  i: integer;
  ok: boolean;
  Cds: TClientDataset;
begin
  Cds:=TMyOrderDetail.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['OrderId']:=TmpObj.f_OrderId;
           Cds.FieldValues['GoodsId']:=TmpObj.f_GoodsId;
           Cds.FieldValues['GoodsName']:=TmpObj.f_GoodsName;
           Cds.FieldValues['Price']:=TmpObj.f_Price;
           Cds.FieldValues['Number']:=TmpObj.f_Number;
           Cds.FieldValues['Money']:=TmpObj.f_Money;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        aCds.data:=Cds.Data;
        Result:=true;
     end
  else
     Result:=false;
  Cds.Free; 
end;

//
// Save data to a file...
function TMyOrderDetailList.SaveToFile(FileName: String; DataFormat: TDataPacketFormat): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrderDetail;
  i: integer;
  ok: boolean;
begin
  Cds:=TMyOrderDetail.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['OrderId']:=TmpObj.f_OrderId;
           Cds.FieldValues['GoodsId']:=TmpObj.f_GoodsId;
           Cds.FieldValues['GoodsName']:=TmpObj.f_GoodsName;
           Cds.FieldValues['Price']:=TmpObj.f_Price;
           Cds.FieldValues['Number']:=TmpObj.f_Number;
           Cds.FieldValues['Money']:=TmpObj.f_Money;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        try
           Cds.SaveToFile(String(FileName),DataFormat);
        except
           ok:=false;
        end;
     end;
  Cds.Free;
  result:=ok;
end;

//
// Load data from a file...
function TMyOrderDetailList.LoadFromFile(FileName: String): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrderDetail;
  ok: boolean;
begin
  self.Clear;
  Cds:=TClientDataset.Create(nil);
  try
     Cds.LoadFromFile(String(FileName));
     ok:=Cds.Active;
  except
     ok:=false;
  end;
  if not ok then
     begin
        cds.Free;
        result:=false;
        exit;
     end;
  cds.First;
  while not cds.Eof do
     begin
        TmpObj := TMyOrderDetail.ReadFromCDS(Cds);
        Self.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
  result:=true;
end;

//
// Save data to a memorystream...
function TMyOrderDetailList.SaveToStream(aStream: TMemoryStream; DataFormat: TDataPacketFormat): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrderDetail;
  i: integer;
  ok: boolean;
begin
  Cds:=TMyOrderDetail.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['OrderId']:=TmpObj.f_OrderId;
           Cds.FieldValues['GoodsId']:=TmpObj.f_GoodsId;
           Cds.FieldValues['GoodsName']:=TmpObj.f_GoodsName;
           Cds.FieldValues['Price']:=TmpObj.f_Price;
           Cds.FieldValues['Number']:=TmpObj.f_Number;
           Cds.FieldValues['Money']:=TmpObj.f_Money;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        try
           aStream.Clear;
           Cds.SaveToStream(aStream,DataFormat);
        except
           ok:=false;
        end;
     end;
  Cds.Free;
  result:=ok;
end;

//
// Load data from a memorystream...
function TMyOrderDetailList.LoadFromStream(aStream: TMemoryStream): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrderDetail;
  ok: boolean;
begin
  self.Clear;
  Cds:=TClientDataset.Create(nil);
  try
     aStream.Position:=0;
     Cds.LoadFromStream(aStream);
     ok:=Cds.Active;
  except
     ok:=false;
  end;
  if not ok then
     begin
        cds.Free;
        result:=false;
        exit;
     end;
  cds.First;
  while not cds.Eof do
     begin
        TmpObj := TMyOrderDetail.ReadFromCDS(Cds);
        Self.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
  result:=true;
end;

//
// Save data to a QBParcel...
function TMyOrderDetailList.SaveToParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrderDetail;
  i: integer;
  ok: boolean;
begin
  Cds:=TMyOrderDetail.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['OrderId']:=TmpObj.f_OrderId;
           Cds.FieldValues['GoodsId']:=TmpObj.f_GoodsId;
           Cds.FieldValues['GoodsName']:=TmpObj.f_GoodsName;
           Cds.FieldValues['Price']:=TmpObj.f_Price;
           Cds.FieldValues['Number']:=TmpObj.f_Number;
           Cds.FieldValues['Money']:=TmpObj.f_Money;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        try
           aParcel.PutCDSGoods(GoodsName,Cds);
           ok:=true;
        except
           ok:=false;
        end;
     end;
  Cds.Free;
  result:=ok;
end;

//
// Load data from a QBparcel...
function TMyOrderDetailList.LoadFromParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
var
  Cds: TClientDataset;
  TmpObj: TMyOrderDetail;
  ok: boolean;
begin
  self.Clear;
  Cds:=TClientDataset.Create(nil);
  try
     aParcel.GetCDSGoods(GoodsName,Cds);
     ok:=Cds.Active;
  except
     ok:=false;
  end;
  if not ok then
     begin
        cds.Free;
        result:=false;
        exit;
     end;
  cds.First;
  while not cds.Eof do
     begin
        TmpObj := TMyOrderDetail.ReadFromCDS(Cds);
        Self.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
  result:=true;
end;

end.
