//
// ------------------------------------------------------------------------------------
//
// Entity_Customers.pas -- This entity class unit for table "Customers". 
//
//                          Generated by QuickBurro V4.0.0.0 Entity Classes Generator
//
//                          Generate time: 2011-04-17 20:59:18
//
//                          Copyright (C) Jopher Software Studio, 2006-2010 
//
// ------------------------------------------------------------------------------------
//

unit Entity_Customers;

interface

uses
  SysUtils, Classes, db, DBClient, 
{$IFDEF UNICODE}
AnsiStrings,
{$ENDIF}
  DBAccessor, QBParcel;

type
  TCustomers = class(TPersistent)

  Private
    ff_CustomerID: String;
    ff_CompanyName: String;
    ff_ContactName: String;
    ff_ContactTitle: String;
    ff_Address: String;
    ff_City: String;
    ff_Region: String;
    ff_PostalCode: String;
    ff_Country: String;
    ff_Phone: String;
    ff_Fax: String;

    class function CreateCds: TClientDataset;

  public
    Property f_CustomerID: String read ff_CustomerID write ff_CustomerID;
    Property f_CompanyName: String read ff_CompanyName write ff_CompanyName;
    Property f_ContactName: String read ff_ContactName write ff_ContactName;
    Property f_ContactTitle: String read ff_ContactTitle write ff_ContactTitle;
    Property f_Address: String read ff_Address write ff_Address;
    Property f_City: String read ff_City write ff_City;
    Property f_Region: String read ff_Region write ff_Region;
    Property f_PostalCode: String read ff_PostalCode write ff_PostalCode;
    Property f_Country: String read ff_Country write ff_Country;
    Property f_Phone: String read ff_Phone write ff_Phone;
    Property f_Fax: String read ff_Fax write ff_Fax;

    constructor Create;
    destructor Destroy; override;
    class function ReadFromCds(aCds: TClientDataset): TCustomers;
    function SaveToCds(Cds: TClientDataset): Boolean;
    class function ReadFromDB(DBA: TDBAccessor; Condition: String): TCustomers;
    function DeleteFromDB(DBA: TDBAccessor; Condition: String): boolean;
    function InsertToDB(DBA: TDBAccessor): boolean;
    function UpdateToDB(DBA: TDBAccessor; Condition: String): boolean;

  end;

  TCustomersList = class(TList)

  public    
    constructor Create;
    destructor Destroy; override;
    class function ReadFromDB(DBA: TDBAccessor; Condition: String = ''; OrderBy: String = ''): TCustomersList;
    class function ReadFromCDS(Cds: TClientDataset): TCustomersList;
    function SaveToCds(aCds: TClientDataset): boolean;
    function SaveToFile(FileName: String; DataFormat: TDataPacketFormat): boolean;
    function LoadFromFile(FileName: String): boolean;
    function SaveToStream(aStream: TMemoryStream; DataFormat: TDataPacketFormat): boolean;
    function LoadFromStream(aStream: TMemoryStream): boolean;
    function SaveToParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
    function LoadFromParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
    
  end;

implementation

{ TCustomers }

//
// Create client dataset for the table...
class function TCustomers.CreateCds: TClientDataset;
begin
  Result:=TClientDataset.Create(nil);
  with Result do
     begin
        with FieldDefs.AddFieldDef do
           begin
              Name:='CustomerID';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=5;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='CompanyName';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=40;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='ContactName';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=30;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='ContactTitle';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=30;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='Address';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=60;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='City';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=15;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='Region';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=15;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='PostalCode';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=10;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='Country';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=15;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='Phone';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=24;
           end;
        with FieldDefs.AddFieldDef do
           begin
              Name:='Fax';
              DataType:={$IFDEF UNICODE}ftWideString{$ELSE}ftString{$ENDIF};
              Size:=24;
           end;
        CreateDataSet;
     end;
  Result.Open;
end;

//
// Create an instance...
constructor TCustomers.Create;
begin
  inherited;
  ff_CustomerID:='';
  ff_CompanyName:='';
  ff_ContactName:='';
  ff_ContactTitle:='';
  ff_Address:='';
  ff_City:='';
  ff_Region:='';
  ff_PostalCode:='';
  ff_Country:='';
  ff_Phone:='';
  ff_Fax:='';
end;

//
// Destroy an instance...
destructor TCustomers.Destroy;
begin
  inherited;
end;

//
// Current Record to an object...
class function TCustomers.ReadFromCds(aCds: TClientDataset): TCustomers;
begin
  if (not aCds.active) or (aCds.RecordCount<=0) then
    begin
      Result:=nil;
      exit;
    end;
  Result := TCustomers.Create;
  with Result do
    begin
      f_CustomerID := Trim(aCds.FieldByName('CustomerID').AsString);
      f_CompanyName := Trim(aCds.FieldByName('CompanyName').AsString);
      f_ContactName := Trim(aCds.FieldByName('ContactName').AsString);
      f_ContactTitle := Trim(aCds.FieldByName('ContactTitle').AsString);
      f_Address := Trim(aCds.FieldByName('Address').AsString);
      f_City := Trim(aCds.FieldByName('City').AsString);
      f_Region := Trim(aCds.FieldByName('Region').AsString);
      f_PostalCode := Trim(aCds.FieldByName('PostalCode').AsString);
      f_Country := Trim(aCds.FieldByName('Country').AsString);
      f_Phone := Trim(aCds.FieldByName('Phone').AsString);
      f_Fax := Trim(aCds.FieldByName('Fax').AsString);
    end;
end;

//
// Object to Current Record...
function TCustomers.SaveToCds(Cds: TClientDataset): Boolean;
begin
   try
     Cds.edit;
     Cds.FieldValues['CustomerID']:=ff_CustomerID;
     Cds.FieldValues['CompanyName']:=ff_CompanyName;
     Cds.FieldValues['ContactName']:=ff_ContactName;
     Cds.FieldValues['ContactTitle']:=ff_ContactTitle;
     Cds.FieldValues['Address']:=ff_Address;
     Cds.FieldValues['City']:=ff_City;
     Cds.FieldValues['Region']:=ff_Region;
     Cds.FieldValues['PostalCode']:=ff_PostalCode;
     Cds.FieldValues['Country']:=ff_Country;
     Cds.FieldValues['Phone']:=ff_Phone;
     Cds.FieldValues['Fax']:=ff_Fax;
     Cds.post;
     result:=true;
   except
     result:=false;
   end;
end;

//
// Export class function...
class function TCustomers.ReadFromDB(DBA: TDBAccessor; Condition: String): TCustomers;
var
  SqlCommand: String;
  Cds: TClientDataset;
begin
  Result := nil;
  Cds:=TClientDataset.Create(nil);
  SqlCommand := 'SELECT * FROM [Customers] WHERE '+condition;
  if not DBA.ReadDataset(SqlCommand,Cds) then
     begin
       Cds.Free;
       exit;
     end;
  Result:=ReadFromCds(Cds);
  Cds.Free;
end;

//
// Insert to database method...
function TCustomers.InsertToDB(DBA: TDBAccessor): boolean;
var
  Cds: TClientDataset;
begin
  Cds:=TCustomers.CreateCds;
  try
     Cds.Append;
     Cds.FieldValues['CustomerID']:=ff_CustomerID;
     Cds.FieldValues['CompanyName']:=ff_CompanyName;
     Cds.FieldValues['ContactName']:=ff_ContactName;
     Cds.FieldValues['ContactTitle']:=ff_ContactTitle;
     Cds.FieldValues['Address']:=ff_Address;
     Cds.FieldValues['City']:=ff_City;
     Cds.FieldValues['Region']:=ff_Region;
     Cds.FieldValues['PostalCode']:=ff_PostalCode;
     Cds.FieldValues['Country']:=ff_Country;
     Cds.FieldValues['Phone']:=ff_Phone;
     Cds.FieldValues['Fax']:=ff_Fax;
     Cds.Post;
  except
     Cds.Free;
     Result:=false;
     exit;
  end;
  Result:=DBA.AppendRecord('[Customers]',Cds);
  Cds.Free;
end;

//
// Update to database method...
function TCustomers.UpdateToDB(DBA: TDBAccessor; Condition: String): boolean;
var
  Cds: TClientDataset;
begin
  Cds:=TCustomers.CreateCds;
  try
     Cds.Append;
     Cds.FieldValues['CustomerID']:=ff_CustomerID;
     Cds.FieldValues['CompanyName']:=ff_CompanyName;
     Cds.FieldValues['ContactName']:=ff_ContactName;
     Cds.FieldValues['ContactTitle']:=ff_ContactTitle;
     Cds.FieldValues['Address']:=ff_Address;
     Cds.FieldValues['City']:=ff_City;
     Cds.FieldValues['Region']:=ff_Region;
     Cds.FieldValues['PostalCode']:=ff_PostalCode;
     Cds.FieldValues['Country']:=ff_Country;
     Cds.FieldValues['Phone']:=ff_Phone;
     Cds.FieldValues['Fax']:=ff_Fax;
     Cds.Post;
  except
     Cds.Free;
     Result:=false;
     exit;
  end;
  Result:=DBA.UpdateRecord('[Customers]',Condition,Cds);
  Cds.Free;
end;

//
// Delete from database method...
function TCustomers.DeleteFromDB(DBA: TDBAccessor; Condition: String): boolean;
var
   SqlCommand,tmpstr: String;
begin
  SqlCommand:='DELETE FROM [Customers] WHERE '+condition;
  result:=DBA.ExecuteSQL(SqlCommand,false,(not DBA.InTransaction),tmpstr);
end;


{ TCustomersList }

//
// Create an instance...
constructor TCustomersList.Create;
begin
  inherited Create;
end;

//
// Destroy a TCustomersList instance...
destructor TCustomersList.Destroy;
var
  I: Integer;
  Obj: TObject;
begin
  for I := 0 to Count - 1 do
     begin
        Obj := Items[I];
        Obj.Free;
     end;
  inherited;
end;

//
// Create a TCustomersList instance from remote table...
class function TCustomersList.ReadFromDB(DBA: TDBAccessor; Condition: String; Orderby: String): TCustomersList;
var
  SqlCommand: String;
  Cds: TClientDataset;
  TmpObj: TCustomers;
begin
  Result := TCustomersList.Create;
  Cds:=TClientDataset.Create(nil);
  if Condition='' then
     begin
        SqlCommand := 'SELECT '
                    +'[CustomerID],'
                    +'[CompanyName],'
                    +'[ContactName],'
                    +'[ContactTitle],'
                    +'[Address],'
                    +'[City],'
                    +'[Region],'
                    +'[PostalCode],'
                    +'[Country],'
                    +'[Phone],'
                    +'[Fax]'
                    +' FROM [Customers]'
     end
  else
     begin
        SqlCommand := 'SELECT '
                    +'[CustomerID],'
                    +'[CompanyName],'
                    +'[ContactName],'
                    +'[ContactTitle],'
                    +'[Address],'
                    +'[City],'
                    +'[Region],'
                    +'[PostalCode],'
                    +'[Country],'
                    +'[Phone],'
                    +'[Fax]'
                    +' FROM [Customers] WHERE '+Condition;
     end;
  if Orderby<>'' then
     SqlCommand:=SqlCommand+' ORDER BY '+Orderby;
  if not DBA.ReadDataset(SqlCommand,Cds) then
     begin
        Cds.Free;
        exit;
     end;
  Cds.First;
  while not Cds.Eof do
     begin
        TmpObj := TCustomers.ReadFromCDS(Cds);
        Result.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
end;

//
// Create a TCustomersList instance from CDS...
class function TCustomersList.ReadFromCDS(Cds: TClientDataset): TCustomersList;
var
  TmpObj: TCustomers;
begin
  Result := TCustomersList.Create;
  Cds.First;
  while not Cds.Eof do
     begin
        TmpObj := TCustomers.ReadFromCDS(Cds);
        Result.Add(TmpObj);
        Cds.Next;
     end;
end;

//
// Save to ClientDataset...
function TCustomersList.SaveToCds(aCds: TClientDataset): boolean;
var
  TmpObj: TCustomers;
  i: integer;
  ok: boolean;
  Cds: TClientDataset;
begin
  Cds:=TCustomers.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['CustomerID']:=TmpObj.f_CustomerID;
           Cds.FieldValues['CompanyName']:=TmpObj.f_CompanyName;
           Cds.FieldValues['ContactName']:=TmpObj.f_ContactName;
           Cds.FieldValues['ContactTitle']:=TmpObj.f_ContactTitle;
           Cds.FieldValues['Address']:=TmpObj.f_Address;
           Cds.FieldValues['City']:=TmpObj.f_City;
           Cds.FieldValues['Region']:=TmpObj.f_Region;
           Cds.FieldValues['PostalCode']:=TmpObj.f_PostalCode;
           Cds.FieldValues['Country']:=TmpObj.f_Country;
           Cds.FieldValues['Phone']:=TmpObj.f_Phone;
           Cds.FieldValues['Fax']:=TmpObj.f_Fax;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        aCds.data:=Cds.Data;
        Result:=true;
     end
  else
     Result:=false;
  Cds.Free; 
end;

//
// Save data to a file...
function TCustomersList.SaveToFile(FileName: String; DataFormat: TDataPacketFormat): boolean;
var
  Cds: TClientDataset;
  TmpObj: TCustomers;
  i: integer;
  ok: boolean;
begin
  Cds:=TCustomers.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['CustomerID']:=TmpObj.f_CustomerID;
           Cds.FieldValues['CompanyName']:=TmpObj.f_CompanyName;
           Cds.FieldValues['ContactName']:=TmpObj.f_ContactName;
           Cds.FieldValues['ContactTitle']:=TmpObj.f_ContactTitle;
           Cds.FieldValues['Address']:=TmpObj.f_Address;
           Cds.FieldValues['City']:=TmpObj.f_City;
           Cds.FieldValues['Region']:=TmpObj.f_Region;
           Cds.FieldValues['PostalCode']:=TmpObj.f_PostalCode;
           Cds.FieldValues['Country']:=TmpObj.f_Country;
           Cds.FieldValues['Phone']:=TmpObj.f_Phone;
           Cds.FieldValues['Fax']:=TmpObj.f_Fax;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        try
           Cds.SaveToFile(String(FileName),DataFormat);
        except
           ok:=false;
        end;
     end;
  Cds.Free;
  result:=ok;
end;

//
// Load data from a file...
function TCustomersList.LoadFromFile(FileName: String): boolean;
var
  Cds: TClientDataset;
  TmpObj: TCustomers;
  ok: boolean;
begin
  self.Clear;
  Cds:=TClientDataset.Create(nil);
  try
     Cds.LoadFromFile(String(FileName));
     ok:=Cds.Active;
  except
     ok:=false;
  end;
  if not ok then
     begin
        cds.Free;
        result:=false;
        exit;
     end;
  cds.First;
  while not cds.Eof do
     begin
        TmpObj := TCustomers.ReadFromCDS(Cds);
        Self.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
  result:=true;
end;

//
// Save data to a memorystream...
function TCustomersList.SaveToStream(aStream: TMemoryStream; DataFormat: TDataPacketFormat): boolean;
var
  Cds: TClientDataset;
  TmpObj: TCustomers;
  i: integer;
  ok: boolean;
begin
  Cds:=TCustomers.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['CustomerID']:=TmpObj.f_CustomerID;
           Cds.FieldValues['CompanyName']:=TmpObj.f_CompanyName;
           Cds.FieldValues['ContactName']:=TmpObj.f_ContactName;
           Cds.FieldValues['ContactTitle']:=TmpObj.f_ContactTitle;
           Cds.FieldValues['Address']:=TmpObj.f_Address;
           Cds.FieldValues['City']:=TmpObj.f_City;
           Cds.FieldValues['Region']:=TmpObj.f_Region;
           Cds.FieldValues['PostalCode']:=TmpObj.f_PostalCode;
           Cds.FieldValues['Country']:=TmpObj.f_Country;
           Cds.FieldValues['Phone']:=TmpObj.f_Phone;
           Cds.FieldValues['Fax']:=TmpObj.f_Fax;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        try
           aStream.Clear;
           Cds.SaveToStream(aStream,DataFormat);
        except
           ok:=false;
        end;
     end;
  Cds.Free;
  result:=ok;
end;

//
// Load data from a memorystream...
function TCustomersList.LoadFromStream(aStream: TMemoryStream): boolean;
var
  Cds: TClientDataset;
  TmpObj: TCustomers;
  ok: boolean;
begin
  self.Clear;
  Cds:=TClientDataset.Create(nil);
  try
     aStream.Position:=0;
     Cds.LoadFromStream(aStream);
     ok:=Cds.Active;
  except
     ok:=false;
  end;
  if not ok then
     begin
        cds.Free;
        result:=false;
        exit;
     end;
  cds.First;
  while not cds.Eof do
     begin
        TmpObj := TCustomers.ReadFromCDS(Cds);
        Self.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
  result:=true;
end;

//
// Save data to a QBParcel...
function TCustomersList.SaveToParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
var
  Cds: TClientDataset;
  TmpObj: TCustomers;
  i: integer;
  ok: boolean;
begin
  Cds:=TCustomers.CreateCds;
  ok:=true;
  for i:=0 to Self.Count-1 do
     begin
        TmpObj:=Self.items[i];
        try
           Cds.Append;
           Cds.FieldValues['CustomerID']:=TmpObj.f_CustomerID;
           Cds.FieldValues['CompanyName']:=TmpObj.f_CompanyName;
           Cds.FieldValues['ContactName']:=TmpObj.f_ContactName;
           Cds.FieldValues['ContactTitle']:=TmpObj.f_ContactTitle;
           Cds.FieldValues['Address']:=TmpObj.f_Address;
           Cds.FieldValues['City']:=TmpObj.f_City;
           Cds.FieldValues['Region']:=TmpObj.f_Region;
           Cds.FieldValues['PostalCode']:=TmpObj.f_PostalCode;
           Cds.FieldValues['Country']:=TmpObj.f_Country;
           Cds.FieldValues['Phone']:=TmpObj.f_Phone;
           Cds.FieldValues['Fax']:=TmpObj.f_Fax;
           Cds.Post;
        except
           ok:=false;
        end;
        if not ok then
           break;
     end;
  if ok then
     begin
        try
           aParcel.PutCDSGoods(GoodsName,Cds);
           ok:=true;
        except
           ok:=false;
        end;
     end;
  Cds.Free;
  result:=ok;
end;

//
// Load data from a QBparcel...
function TCustomersList.LoadFromParcel(aParcel: TQBParcel; GoodsName: AnsiString): boolean;
var
  Cds: TClientDataset;
  TmpObj: TCustomers;
  ok: boolean;
begin
  self.Clear;
  Cds:=TClientDataset.Create(nil);
  try
     aParcel.GetCDSGoods(GoodsName,Cds);
     ok:=Cds.Active;
  except
     ok:=false;
  end;
  if not ok then
     begin
        cds.Free;
        result:=false;
        exit;
     end;
  cds.First;
  while not cds.Eof do
     begin
        TmpObj := TCustomers.ReadFromCDS(Cds);
        Self.Add(TmpObj);
        Cds.Next;
     end;
  Cds.Free;
  result:=true;
end;

end.
