//
//---------------------------------------------------------------
//                                                               
//                                                               
//    QuickBurro Middleware Application Development Package      
//                                                               
//    Version 4.0                                               
//    Update Date: 2011.4.18.                                    
//    Author: Jopher(W.G.Z.)                                     
//    QQ: 779545524                                              
//    Email: Jopher@189.cn  or wpy020327@163.com  
//    Homepage: http://www.jopher.net/               
//                                                               
//    Copyright(C) Jopher Software Studio. All rights reserved   
//                                                               
//                                                               
//---------------------------------------------------------------
//
unit DllSpread;

interface

uses
   windows, SysUtils, classes,
   {$IFDEF UNICODE}
   AnsiStrings,
   {$ENDIF}
   QBParcel;

function Str2Mem(Str: Ansistring): integer;
function Mem2Str(MemPtr: Integer): Ansistring;
function Parcel2Mem(Parcel: TQBParcel): integer;
function Mem2Parcel(MemPtr: Integer): TQBParcel;
function Stream2Mem(Stream: TMemoryStream): integer;
function Mem2Stream(MemPtr: Integer): TMemoryStream;
procedure FreeMemory(MemPtr: Integer);

implementation

function Str2Mem(Str: Ansistring): integer;
var
   j,k: integer;
   ptr: Pointer;
begin
   j:=length(str);
   k:=j+4+1;
   ptr:=GlobalAllocPtr(0,k);
   Result:=integer(ptr);
   move(j,ptr^,4);
   if j>0 then
      begin
         ptr:=pointer(integer(ptr)+4);
         move(str[1],ptr^,j);
      end;
end;

function Mem2Str(MemPtr: integer): Ansistring;
var
   ptr: pointer;
   j: integer;
begin
   ptr:=pointer(MemPtr);
   move(ptr^,j,4);
   if j<=0 then
      result:=''
   else
      begin
         setlength(result,j);
         ptr:=pointer(integer(ptr)+4);
         move(ptr^,result[1],j);
      end;
end;

function Parcel2Mem(Parcel: TQBParcel): integer;
var
   j: integer;
   Stream: TMemoryStream;
   ptr: Pointer;
begin
   Stream:=TMemoryStream.Create;
   try
      Parcel.SaveToStream(Stream);
      stream.Position:=0;
      j:=stream.Size;
      ptr:=GlobalAllocPtr(0,j+4+1);
      Result:=integer(ptr);
      move(j,ptr^,4);
      ptr:=pointer(integer(ptr)+4);
      Stream.ReadBuffer(ptr^,j);
   finally
      stream.Free;
   end;
end;

function Mem2Parcel(MemPtr: integer): TQBParcel;
var
   j: integer;
   stream: TMemoryStream;
   ptr: pointer;
begin
   ptr:=pointer(MemPtr);
   move(ptr^,j,4);
   ptr:=pointer(integer(ptr)+4);
   stream:=TMemoryStream.Create;
   try
      stream.WriteBuffer(ptr^,j);
      stream.Position:=0;
      result:=TQBParcel.Create;
      result.LoadFromStream(stream);
   finally
      stream.Free;
   end;
end;

function Stream2Mem(Stream: TMemoryStream): integer;
var
   j: integer;
   ptr: Pointer;
begin
   j:=stream.Size;
   ptr:=GlobalAllocPtr(0,j+4+1);
   Result:=integer(ptr);
   move(j,ptr^,4);
   ptr:=pointer(integer(ptr)+4);
   Stream.Position:=0;
   Stream.ReadBuffer(ptr^,j);
end;

function Mem2Stream(MemPtr: Integer): TMemoryStream;
var
   j: integer;
   ptr: pointer;
begin
   ptr:=pointer(MemPtr);
   move(ptr^,j,4);
   ptr:=pointer(integer(ptr)+4);
   Result:=TMemoryStream.Create;
   result.WriteBuffer(ptr^,j);
   result.Position:=0;
end;

procedure FreeMemory(MemPtr: integer);
begin
   GlobalFreePtr(pointer(MemPtr));
end;

end.
