//
//---------------------------------------------------------------
//                                                               
//                                                               
//    QuickBurro Middleware Application Development Package      
//                                                               
//    Version 4.0                                               
//    Update Date: 2011.4.18.                                    
//    Author: Jopher(W.G.Z.)                                     
//    QQ: 779545524                                              
//    Email: Jopher@189.cn  or wpy020327@163.com  
//    Homepage: http://www.jopher.net/               
//                                                               
//    Copyright(C) Jopher Software Studio. All rights reserved   
//                                                               
//                                                               
//---------------------------------------------------------------
//

unit QBMisc;

{$HINTS OFF}
{$WARNINGS OFF}

interface

uses
   windows, Classes, SysUtils, Registry, graphics, jpeg, OleCtrls, ShlObj,
   SHDocVw, MSHTML, ActiveX, ComObj, Forms, StdCtrls, mmSystem, ShellApi,
{$IFDEF UNICODE}
AnsiStrings,
{$ENDIF}
   Controls, MPlayer;

const
   HKLM_CURRENT_VERSION_WINDOWS = 'Software\Microsoft\Windows\CurrentVersion'; 
   csWndShowFlag: array[Boolean] of DWORD = (SW_HIDE, SW_RESTORE); 

   function Confirm(prompt: string; Title: string):boolean;
   procedure ShowMessage(Msg:string; Title: string);
   procedure ShowError(const Msg: String; Title: String); 
   procedure ShowWarning(const Msg: String; Title: String); 
   function RmbSmallTOBig(small: real): string;
   function DriveExists(DriveLetter: Char): boolean;
   function GetHeadPYs(const S: Ansistring; cVoid: AnsiChar): Ansistring;
   function ReplaceStr(S, source, target: string): string;
   function MaxMatchStr(DestStr: String; Strs: array of String): String;
   function NoSpaceStr(Text: String): String;
   function SpaceStr(Len: Integer): string;
   function StrRight(Str: string; Len: Integer): string;
   function StrLeft(Str: string; Len: Integer): string;
   procedure SwapStr(var s1, s2: string);
   function ReverseStr(Source: string): string;
   function Int2StrId(aIntValue: integer; StrLen: integer): string;
   function SystemUpTime: string;
   procedure BMPtoJPG(filename: string);
   procedure JPGtoBMP(filename: string);
   function SetPCSystemTime(tDati: TDateTime): Boolean;
   function GetFileVersion(FileName: string): string;
   procedure SetWebBrowserHtml(const WebBrowser: TWebBrowser; const Html: string);
   function GetWebBrowserHtml(const WebBrowser: TWebBrowser): string;
   function GetWebBrowserHtml1(const WebBrowser: TWebBrowser): string;
   function GetWebBrowserText(const WebBrowser: TWebBrowser): string;
   procedure ShowBlankPage(WebBrowser: TWebBrowser);
   function GetIEFavPath: string;
   function GetIEFavorites(const favpath: string): TStrings;
   function ReadRegistString(const RootKey: HKEY; const Key, Name, Def: string): string;
   function ReadRegistInteger(ARootKey: HKEY; Key,Name: String; DefaultValue: Integer=0): Integer;
   function ReadRegistBool(ARootKey: HKEY; Key,Name: String; DefaultValue: Boolean=False): Boolean;
   procedure WriteRegistString(ARootKey: HKEY; Key,Name,Value: String);
   procedure WriteRegistWord(ARootKey: HKEY; Key,Name: String; Value: Integer);
   procedure WriteRegistBool(ARootKey: HKEY; Key,Name: String; Value: Boolean);
   function GetWinTempDir: String;
   function GetWindowsDir: string;
   function GetSystemDir: String;
   function GetProgFilesDir: string;
   function GetTempFile(PathName,PrefixStr: String; UniqueID: Integer=0): String;
   procedure SetTaskBarVisible(Visible: Boolean); 
   procedure SetDesktopVisible(Visible: Boolean); 
   function IsWindows9598: Boolean; 
   function GetOSString: string;
   function GetComputeName : string;
   function GetLocalUserName: string;
   procedure Delay(const uDelay: DWORD);
   function SoundCardExists: Boolean; 
   function UrlEncode(const DecodedStr: AnsiString; Pluses: Boolean): AnsiString;
   function UrlDecode(const EncodedStr: AnsiString): AnsiString;
   function HexToInt(HexStr: AnsiString): Int64;
   function FileDate2DelphiDate(FileDate: _FileTime): TDateTime;
   function GetFileSize(const FileName: string): Longint;
   function GetFileCreateDate(aFileName: string): TDateTime;
   function GetFileModifiedDate(aFileName: string): TDateTime;
   Function FtToDt(AFT:_FILETIME): TDateTime;
   Function DtToFt(ADT:TDateTime): _FILETIME;
   Function ReadFileLWTime(AFile: String): TDateTime;
   procedure SetFileLWTime(AFile: String; ADateTime:TDateTime);
   function GetHardDiskPartitionType(const DriveLetter: AnsiChar): string;
   function GetCPUSpeed: Double;
   function IsAdmin: Boolean;
   function DeleteDirectory(const Source: string): boolean;
   {$IFNDEF VER130}
   function CreateShortcut(Exe: string; Lnk: string = ''; Dir: string = ''; ID: Integer = -1): Boolean;
   {$ENDIF}
   procedure ControlReboot(Enabled: boolean);
   function ChangeWallPaper(aFileName: string): Boolean;
   procedure SystemAbout(const sTitle, sContent: string);
   procedure HideFormOnTask;
   function GetFileIcon(const Filename: string; SmallIcon: Boolean): HICON;
   function GetCDROMNumber: string;
   procedure OpenCDROM;
   procedure CloseCDROM;
   function OpenSystemDialog(const iNumber: integer):Boolean;
   function ExecuteAndWait(FName, Params: String): boolean;
   function GetWinProductID(): string;
   function IsAudioCD(const Drive: AnsiChar): boolean;
   function PlayAudioCD(const Drive: AnsiChar): boolean;
   function DiskInDrive(Drive: Char): Boolean;
   {$IFNDEF VER130}
   function CopyDir(const sDirName, sToDirName: string): Boolean;
   {$ENDIF}
   procedure GetPortUsed(var stComList: TStrings);
   procedure ControlMediaAudio(const DeviceID: word; Enabled: boolean);
   procedure ShowControlHint(AControl: TControl);

implementation

function Confirm(prompt: string; Title: string): boolean;
begin
  Result := (MessageBox(GetActiveWindow, pchar(prompt),pchar(title),mb_ICONQuestion+mb_YesNo)=IDOK);
end;

procedure ShowMessage(Msg: string; Title: string);
begin
  MessageBox(GetActiveWindow, pchar(Msg), pchar(title), mb_ok+mb_ICONInformation);
end;

procedure ShowError(const Msg: String; Title: String); 
begin 
   MessageBox(GetActiveWindow, PChar(Msg), PChar(Title), MB_OK + MB_ICONERROR); 
end; 

procedure ShowWarning(const Msg: String; Title: String); 
begin 
   MessageBox(GetActiveWindow, PChar(Msg), PChar(Title), MB_OK + MB_ICONWARNING); 
end; 

function RmbSmallTOBig(small: real): string;
var
   SmallMonth,BigMonth: string;
   wei1,qianwei1: string[2];
   qianwei,dianweizhi,qian: integer;
begin
   qianwei:=-2;
   Smallmonth:=formatfloat('0.00',small);
   dianweizhi :=pos('.',Smallmonth);
   for qian:=length(Smallmonth) downto 1 do
      begin
         if qian<>dianweizhi then
            begin
               case strtoint(copy(Smallmonth,qian,1)) of
                  1:wei1:='Ҽ'; 
                  2:wei1:='';
                  3:wei1:=''; 
                  4:wei1:='';
                  5:wei1:=''; 
                  6:wei1:='½';
                  7:wei1:=''; 
                  8:wei1:='';
                  9:wei1:=''; 
                  0:wei1:='';
               end;
               case qianwei of
                 -3: qianwei1:='';
                 -2: qianwei1:='';
                 -1: qianwei1:='';
                  0 : qianwei1:='Ԫ';
                  1 : qianwei1:='ʰ';
                  2 :qianwei1:='';
                  3 :qianwei1:='ǧ';
                  4 :qianwei1:='';
                  5 :qianwei1:='ʰ';
                  6 :qianwei1:='';
                  7 :qianwei1:='ǧ';
                  8 :qianwei1:='';
                  9 :qianwei1:='ʮ';
                  10:qianwei1:='';
                  11:qianwei1:='ǧ';
               end;
               inc(qianwei);
               BigMonth :=string(wei1)+string(qianwei1)+BigMonth;
            end;
      end;
   Result:=BigMonth;
end;

function DriveExists(DriveLetter: Char): boolean;
var 
   i: integer;
begin
  if AnsiChar(DriveLetter) in ['A'..'Z'] then
     begin
        i:=ord(DriveLetter) or $20;
        move(i,DriveLetter,1);
     end;
  i := GetDriveType(pchar(DriveLetter));
  case i of
    DRIVE_REMOVABLE: result := true;
    DRIVE_FIXED: result := true;
    DRIVE_REMOTE: result := true;
    DRIVE_CDROM: result:=true;
    DRIVE_RAMDISK: result:=true;
    else 
       result := false;
  end;
end;

function GetHeadPYs(const S: Ansistring; cVoid: AnsiChar): Ansistring;
const csheads =  
  AnsiString('cjwgnspgcgne*y*btyyzdxykygt*jnnjqmbsgzscyjsyy*pgkbzgy*ywjkgkljywkpjqhy*w*d'
  +'zlsgmrypywwcckznkyygttnjjnykkzytcjnmcylqlypyqfqrpzslwbtgkjfyxjwzltbncxjjjj'
  +'txdttsqzycdxxhgck*phffss*ybgxlppbyll*hlxs*zm*jhsojnghdzqyklgjhsgqzhxqgkezz'
  +'wyscscjxyeyxadzpmdssmzjzqjyzc*j*wqjbyzpxgznzcpwhkxhqkmwfbpbydtjzzkqhylygxf'
  +'ptyjyyzpszlfchmqshgmxxsxj**dcsbbqbefsjyhxwgzkpylqbgldlcctnmayddkssngycsgxl'
  +'yzaybnptsdkdylhgymylcxpy*jndqjwxqxfyyfjlejpzrxccqwqqsbnkymgplbmjrqcflnymyq'
  +'msqyrbcjthztqfrxqhxmjjcjlxqgjmshzkbswyemyltxfsydswlycjqxsjnqbsctyhbftdcyzd'
  +'jwyghqfrxwckqkxebptlpxjzsrmebwhjlbjslyysmdxlclqkxlhxjrzjmfqhxhwywsbhtrxxgl'
  +'hqhfnm*ykldyxzpylgg*mtcfpajjzyljtyanjgbjplqgdzyqyaxbkysecjsznslyzhsxlzcghp'
  +'xzhznytdsbcjkdlzayfmydlebbgqyzkxgldndnyskjshdlyxbcghxypkdjmmzngmmclgwzszxz'
  +'jfznmlzzthcsydbdllscddnlkjykjsycjlkwhqasdknhcsganhdaashtcplcpqybsdmpjlpzjo'
  +'qlcdhjjysprchn*nnlhlyyqyhwzptczgwwmzffjqqqqyxaclbhkdjxdgmmydjxzllsygxgkjry'
  +'wzwyclzmssjzldbyd*fcxyhlxchyzjq**qagmnyxpfrkssbjlyxysyglnscmhzwwmnzjjlxxhc'
  +'hsy**ttxrycyxbyhcsmxjsznpwgpxxtaybgajcxly*dccwzocwkccsbnhcpdyz'
  +'nfcyytyckxkybsqkkytqqxfcwchcykelzqbsqyjqcclmthsywhmktlkjlycxwheqqhtqh*pq*q'
  +'scfymndmgbwhwlgsllysdlmlxpthmjhwljzyhzjxhtxjlhxrswlwzjcbxmhzqxsdzpmgfcsgls'
  +'xymjshxpjxwmyqksmyplrthbxftpmhyxlchlhlzylxgsssstclsldclrpbhzhxyyfhb*gdmycn'
  +'qqwlqhjj*ywjzyejjdhpblqxtqkwhlchqxagtlxljxmsl*htzkzjecxjcjnmfby*sfywybjzgn'
  +'ysdzsqyrsljpclpwxsdwejbjcbcnaytwgmpapclyqpclzxsbnmsggfnzjjbzsfzyndxhplqkzc'
  +'zwalsbccjx*yzgwkypsgxfzfcdkhjgxdlqfsgdslqwzkxtmhsbgzmjzrglyjbpmlmsxlzjqqhz'
  +'yjczydjwbmyklddpmjegxyhylxhlqyqhkycwcjmyyxnatjhyccxzpcqlbzwwytwbqcmlpmyrjc'
  +'ccxfpznzzljplxxyztzlgdldcklyrzzgqtgjhhgjljaxfgfjzslcfdqzlclgjdjcsnzlljpjqd'
  +'cclcjxmyzftsxgcgsbrzxjqqctzhgyqtjqqlzxjylylbcyamcstylpdjbyregklzyzhlyszqlz'
  +'nwczcllwjqjjjkdgjzolbbzppglghtgzxyghzmycnqsycyhbhgxkamtxyxnbskyzzgjzlqjdfc'
  +'jxdygjqjjpmgwgjjjpkqsbgbmmcjssclpqpdxcdyyky*cjddyygywrhjrtgznyqldkljszzgzq'
  +'zjgdykshpzmtlcpwnjafyzdjcnmwescyglbtzcgmssllyxqsxsbsjsbbsgghfjlypmzjnlyywd'
  +'qshzxtyywhmzyhywdbxbtlmsyyyfsxjc*dxxlhjhf*sxzqhfzmzcztqcxzxrttdjhnnyzqqmnq'
  +'dmmg*ydxmjgdhcdyzbffallztdltfxmxqzdngwqdbdczjdxbzgsqqddjcmbkzf'
  +'fxmkdmdsyyszcmljdsynsbrskmkmpcklgdbqtfzswtfgglyplljzhgj*gypzltcsmcnbtjbqfk'
  +'thbyzgkpbbymtdssxtbnpdkleycjnyddykzddhqhsdzsctarlltkzlgecllkjlqjaqnbdkkghp'
  +'jtzqksecshalqfmmgjnlyjbbtmlyzxdcjpldlpcqdhzycbzsczbzmsljflkrzjsnfrgjhxpdhy'
  +'jybzgdlqcsezgxlblgyxtwmabchecmwyjyzlljjyhlg*djlslygkdzpzxjyyzlwcxszfgwyydl'
  +'yhcljscmbjhblyzlycblydpdqysxqzbytdkyxjy*cnrjmpdjgklcljbctbjddbblblczqrppxj'
  +'cjlzcshltoljnmdddlngkaqhqhjgykheznmshrp*qqjchgmfprxhjgdychghlyrzqlcyqjnzsq'
  +'tkqjymszswlcfqqqxyfggyptqwlmcrnfkkfsyylqbmqammmyxctpshcptxxzzsmphpshmclmld'
  +'qfyqxszyydyjzzhqpdszglstjbckbxyqzjsgpsxqzqzrqtbdkyxzkhhgflbcsmdldgdzdblzyy'
  +'cxnncsybzbfglzzxswmsccmqnjqsbdqsjtxxmbltxzclzshzcxrqjgjylxzfjphymzqqydfqjj'
  +'lzznzjcdgzygctxmzysctlkphtxhtlbjxjlxscdqxcbbtjfqzfsltjbtkqbxxjjljchczdbzjd'
  +'czjdcprnpqcjpfczlclzxzdmxmphjsgzgszzqlylwtjpfsyasmcjbtzkycwmytcsjjljcqlwzm'
  +'albxyfbpnlsfhtgjwejjxxglljstgshjqlzfkcgnnnszfdeqfhbsaqtgylbxmmygszldydqmjj'
  +'rgbjtkgdhgkblqkbdmbylxwcxyttybkmrtjzxqjbhlmhmjjzmqasldcyxyqdlqcafywyxqhz');

  function GetHeadPY(w: Word): AnsiChar;
  var
    iSection,
    iPosition,
    iOffsetB: Integer;
  begin
    case w of
      $B0A1..$B0C4: Result := 'a';
      $B0C5..$B2C0: Result := 'b';
      $B2C1..$B4ED: Result := 'c';
      $B4EE..$B6E9: Result := 'd';
      $B6EA..$B7A1: Result := 'e';
      $B7A2..$B8c0: Result := 'f';
      $B8C1..$B9FD: Result := 'g';
      $B9FE..$BBF6: Result := 'h';
      $BBF7..$BFA5: Result := 'j';
      $BFA6..$C0AB: Result := 'k';
      $C0AC..$C2E7: Result := 'l';
      $C2E8..$C4C2: Result := 'm';
      $C4C3..$C5B5: Result := 'n';
      $C5B6..$C5BD: Result := 'o';
      $C5BE..$C6D9: Result := 'p';
      $C6DA..$C8BA: Result := 'q';
      $C8BB..$C8F5: Result := 'r';
      $C8F6..$CBF0: Result := 's';
      $CBFA..$CDD9: Result := 't';
      $CDDA..$CEF3: Result := 'w';
      $CEF4..$D188: Result := 'x';
      $D1B9..$D4D0: Result := 'y';
      $D4D1..$D7F9: Result := 'z';
      $D8A1..$F7FE: begin           
                       iSection  := (w shr 8) and $0FF - 160;
                       iPosition := w and $0FF - 160;
                       iOffsetB  := (iSection - 56) * 94 + iPosition; 
                       if (iOffsetB > 0) and (iOffsetB <= 3008) then 
                          begin
                             Result := csHeads[iOffsetB];
                             if Result = '*' then
                                Result := cVoid;
                          end 
                       else 
                          Result := cVoid;
                    end;
               else            
                  Result := cVoid;
    end;
  end;

var
  cHead: AnsiChar;
  i, k:  Integer;
begin
  Result := S;
  i := 1;
  k := 1;
  while i <= Length(S) do begin
    if (S[i] > #127) and (i < Length(S)) then begin
      cHead := GetHeadPY((Word(S[i]) shl 8) or (Word(S[i +1]) and $0FF));
      if cHead > #0 then begin
        Result[k] := cHead;
        Inc(k);
      end;
      Inc(i);
    end;
    Inc(i);
  end;
  Delete(Result, k, MaxInt);
end;

function ReplaceStr(S, source, target: string): string;
var 
   site, StrLen: integer;
begin
   while true do
      begin  
         site := pos(source, s);
         if site<=0 then
            break;
         StrLen := length(source);
         delete(s, site, StrLen);
         insert(target, s, site);
      end;
   result := s;
end;

function MaxMatchStr(DestStr: String; Strs: array of String): String;
var
  I:Integer;
begin
  Result:='';
  for I:=1 to Length(Strs) do
    if (Pos(Strs[I],DestStr)>0) and (Length(Strs[I])>Length(Result)) then
      Result:=Strs[I];
end;

function NoSpaceStr(Text: String): String;
var
  S: String;
  j: integer; 
begin
  S:=Text;
  j:=1;
  while j<=length(s) do
    begin
       if s[j]=' ' then
          Delete(S,j,1)
       else
          inc(j);
    end;
  Result:=S;
end;

function SpaceStr(Len: Integer): string;
begin
   SetLength(Result, Len);
   FillChar(PChar(Result)^, Len, ' ');
end; 

function StrRight(Str: string; Len: Integer): string;
begin 
   if Len >= Length(Str) then
      Result := Str 
   else 
      Result := Copy(Str, Length(Str) - Len + 1, Len); 
end; 

function StrLeft(Str: string; Len: Integer): string;
begin 
   if Len >= Length(Str) then 
      Result := Str 
   else 
      Result := Copy(Str, 1, Len); 
end; 

procedure SwapStr(var s1, s2: string);
var 
   tempstr: string;
begin 
   tempstr := s1;
   s1 := s2;
   s2 := tempstr;
end;

function ReverseStr(Source: string): string;
var
   i: integer;
begin
   result:='';
   for i:=length(source) downto 1 do
      result:=result+source[i];
end;

function Int2StrId(aIntValue: integer; StrLen: integer): string;
begin
   result:=inttostr(aIntValue);
   while length(result)<strlen do
      result:='0'+result;
end;

function SystemUpTime: string;
const
   ticksperday: integer = 1000 * 60 * 60 * 24;
   ticksperhour: integer = 1000 * 60 * 60;
   ticksperminute: integer = 1000 * 60;
   tickspersecond: integer = 1000;
var
   t: int64;
   d, h, m, s: integer;
begin
   t := int64(GetTickCount);
   d := t div ticksperday;
   dec(t, d * ticksperday);
   h := t div ticksperhour;
   dec(t, h * ticksperhour);
   m := t div ticksperminute;
   dec(t, m * ticksperminute);
   s := t div tickspersecond;
   Result := 'ʱ: ' + IntToStr(d) + '  ' + IntToStr(h) +
             ' Сʱ ' + IntToStr(m) + '  ' +   IntToStr(s) + ' ';
end;

procedure BMPtoJPG(filename: string);
Var
    J: TJpegImage;
    I:TBitmap;
    S: String;
begin
    s:=filename;
    J:=TJpegImage.Create;
    I:=TBitmap.Create;
    I.LoadFromFile(s);
    J.Assign(I);
    I.Free;

    s:=changefileext(s, '.jpg');
    J.SaveToFile(s);
    J.Free;
end;

procedure JPGtoBMP(filename: string);
Var
   J:TJpegImage;
   I:TBitmap;
   s: string;
begin
   s:=filename;
   I:=TBitmap.Create;
   J:=TJpegImage.Create;
   J.LoadFromFile(s);
   I.Assign(J);
   J.Free;

   s:=changefileext(s, '.bmp');
   I.SaveToFile(s);
   I.Free;
end;

function SetPCSystemTime(tDati: TDateTime): Boolean;
var
   tSetDati: TDateTime;
   vDatiBias: Variant;
   tTZI: TTimeZoneInformation;
   tST: TSystemTime;
begin
   GetTimeZoneInformation(tTZI);
   vDatiBias := tTZI.Bias/1440;
   tSetDati := tDati + vDatiBias;
   with tST do   begin
        wYear := StrToInt(FormatDateTime('yyyy', tSetDati));
        wMonth := StrToInt(FormatDateTime('mm', tSetDati));
        wDay := StrToInt(FormatDateTime('dd', tSetDati));
        wHour := StrToInt(FormatDateTime('hh', tSetDati));
        wMinute := StrToInt(FormatDateTime('nn', tSetDati));
        wSecond := StrToInt(FormatDateTime('ss', tSetDati));
        wMilliseconds := 0;
   end;
   SetPCSystemTime := SetSystemTime(tST);
end;

function WinExecAndWait32(FileName:String; Visibility: integer):integer;
var
  zAppName:array[0..512] of char;
  zCurDir:array[0..255] of char;
  WorkDir:String;
  StartupInfo:TStartupInfo;
  ProcessInfo:TProcessInformation;
  x: dword;
begin
  StrPCopy(zAppName,FileName);
  GetDir(0,WorkDir);
  StrPCopy(zCurDir,WorkDir);
  FillChar(StartupInfo,Sizeof(StartupInfo),#0);
  StartupInfo.cb := Sizeof(StartupInfo);

  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := Visibility;
  if not CreateProcess(nil,
    zAppName,                      
    nil,                           
    nil,                           
    false,                         
    CREATE_NEW_CONSOLE or          
    NORMAL_PRIORITY_CLASS,
    nil,                           
    nil,                           
    StartupInfo,                   
    ProcessInfo) then
    Result := -1 

  else
     begin
        WaitforSingleObject(ProcessInfo.hProcess,INFINITE);
        GetExitCodeProcess(ProcessInfo.hProcess,x);
        result:=x;
     end;
end;

function GetFileVersion(FileName: string): string;
type
    PVerInfo = ^TVS_FIXEDFILEINFO;
    TVS_FIXEDFILEINFO = record
      dwSignature: longint;
      dwStrucVersion: longint;
      dwFileVersionMS: longint;
      dwFileVersionLS: longint;
      dwFileFlagsMask: longint;
      dwFileFlags: longint;
      dwFileOS: longint;
      dwFileType: longint;
      dwFileSubtype: longint;
      dwFileDateMS: longint;
      dwFileDateLS: longint;
    end;
var
    ExeNames: array[0..255] of char;
    VerInfo: PVerInfo;
    Buf: pointer;
    Sz: word;
    L, Len: Cardinal;
begin
    StrPCopy(ExeNames, FileName);
    Sz := GetFileVersionInfoSize(ExeNames, L);
    if Sz=0 then
       begin
          Result:='';
          Exit;
       end;

    try
      GetMem(Buf, Sz);
      try
        GetFileVersionInfo(ExeNames, 0, Sz, Buf);
        if VerQueryValue(Buf, '\', Pointer(VerInfo), Len) then
           begin
             Result := IntToStr(HIWORD(VerInfo.dwFileVersionMS)) + '.' +
                       IntToStr(LOWORD(VerInfo.dwFileVersionMS)) + '.' +
                       IntToStr(HIWORD(VerInfo.dwFileVersionLS)) + '.' +
                       IntToStr(LOWORD(VerInfo.dwFileVersionLS));

           end
        else
           result:='';
      finally
         FreeMem(Buf);
      end;
    except
       Result := '';
    end;
end;

procedure SetWebBrowserHtml(const WebBrowser: TWebBrowser; const Html: string);
var
   Stream: IStream;
   hHTMLText: HGLOBAL;
   psi: IPersistStreamInit;
begin
   if not Assigned(WebBrowser.Document) then 
      Exit;

   hHTMLText := GlobalAlloc(GPTR, Length(Html) + 1);

   CopyMemory(Pointer(hHTMLText),
   PChar(Html), Length(Html));

   OleCheck(CreateStreamOnHGlobal(hHTMLText, True, Stream));
   try
      OleCheck(WebBrowser.Document.
      QueryInterface(IPersistStreamInit, psi));
      try
         OleCheck(psi.InitNew);
         OleCheck(psi.Load(Stream));
      finally
         psi := nil;
      end;
   finally
      Stream := nil;
   end;
end;

function GetWebBrowserHtml(const WebBrowser: TWebBrowser): string;
const
   BufSize = $10000;
var
   Size: Int64;
   Stream: IStream;
   hHTMLText: HGLOBAL;
   psi: IPersistStreamInit;
begin
   if not Assigned(WebBrowser.Document) then 
      Exit;
   OleCheck(WebBrowser.Document.QueryInterface(IPersistStreamInit, psi));
   try
      hHTMLText := GlobalAlloc(GPTR, BufSize);
      OleCheck(CreateStreamOnHGlobal(hHTMLText,True, Stream));
      try
         OleCheck(psi.Save(Stream, False));
         Size := StrLen(PChar(hHTMLText));
         SetLength(Result, Size);
         CopyMemory(PChar(Result), Pointer(hHTMLText),Size);
      finally
         Stream := nil;
      end;
   finally
      psi := nil;
   end;
end;

function GetWebBrowserHtml1(const WebBrowser: TWebBrowser): string;
var
   Doc: IHTMLDocument2;
begin
   Doc := WebBrowser.Document as IHTMLDocument2;
   result:=Doc.body.outerhtml;
end;

function GetWebBrowserText(const WebBrowser: TWebBrowser): string;
var
   Doc: IHTMLDocument2;
begin
   Doc := WebBrowser.Document as IHTMLDocument2;
   result:=Doc.body.outerText;
end;

procedure ShowBlankPage(WebBrowser: TWebBrowser);
var
   URL: OleVariant;
begin
   URL := 'about:blank';
   WebBrowser.Navigate2(URL);
end;

function GetIEFavPath: string;
var
  pidl: PItemIDList;
  FavPath: array[0..MAX_PATH] of char;
begin
  SHGetSpecialFolderLocation(GetActiveWindow, CSIDL_FAVORITES, pidl);
  SHGetPathFromIDList(pidl, favpath);
  result:=FavPath;
end;

function GetIEFavorites(const favpath: string): TStrings;
var
  searchrec:TSearchrec;
  str:TStrings;
  path,dir,filename: String;
  Buffer: array[0..2047] of Char;
  found:Integer;
begin
  str:=TStringList.Create;
  path:=FavPath+'\*.url';
  dir:=ExtractFilepath(path);
  found:=FindFirst(path,faAnyFile,searchrec);
  while found = 0 do
     begin
       SetString(filename, Buffer,
       GetPrivateProfileString('InternetShortcut',
       PChar('URL'), NIL, Buffer, SizeOf(Buffer),
       PChar(dir+searchrec.Name)));
       str.Add(filename);
       found := FindNext(searchrec);
     end;
  found:=FindFirst(dir+'\*.*',faAnyFile,searchrec);
  while found=0 do
     begin
       if ((searchrec.Attr and faDirectory) > 0) and (searchrec.Name[1]<>'.') then
          str.AddStrings(GetIEFavorites(dir+AnsiString('\'+searchrec.name)));
       found := FindNext(searchrec);
     end;
  FindClose(searchrec);
  Result:=str;
end;

function ReadRegistString(const RootKey: HKEY; const Key, Name, Def: string): string;
   function RelativeKey(const Key: string): PChar;
      begin
         Result := PChar(Key);
         if (Key <> '') and (Key[1] = '') then
            Inc(Result);
      end; 
var
   RegKey: HKEY; 
   Size: DWORD; 
   StrVal: string;
   RegKind: DWORD; 
begin 
   Result := Def;
   if RegOpenKeyEx(RootKey, RelativeKey(Key), 0, KEY_READ, RegKey) = ERROR_SUCCESS then 
      begin 
         RegKind := 0; 
         Size := 0; 
         if RegQueryValueEx(RegKey, PChar(Name), nil, @RegKind, nil, @Size) = ERROR_SUCCESS then
            begin 
               if RegKind in [REG_SZ, REG_EXPAND_SZ] then 
                  begin 
                     SetLength(StrVal, Size); 
                     if RegQueryValueEx(RegKey, PChar(Name), nil, @RegKind, PByte(StrVal), @Size) = ERROR_SUCCESS then
                        begin 
                           SetLength(StrVal, StrLen(PChar(StrVal)));
                           Result := StrVal; 
                        end; 
                  end;
            end; 
         RegCloseKey(RegKey); 
      end; 
end; 

function ReadRegistInteger(ARootKey: HKEY; Key,Name: String; DefaultValue: Integer=0): Integer;
begin
  with TRegistry.Create do
     try
        RootKey:=ARootKey;
        try
           OpenKey(Key,False);
           Result:=ReadInteger(Name);
        except
           result:=DefaultValue;
        end;
     finally
        Free;
     end;
end;

function ReadRegistBool(ARootKey: HKEY;Key,Name: String; DefaultValue: Boolean=False):Boolean;
begin
  with TRegistry.Create do
     try
        RootKey:=ARootKey;
        try
           OpenKey(Key,False);
           Result:=ReadBool(Name);
        except
           Result:=DefaultValue;
        end;
     finally
        Free;
     end;
end;

procedure WriteRegistString(ARootKey: HKEY; Key,Name,Value: String);
begin
  with TRegistry.Create do
     try
        RootKey:=ARootKey;
        OpenKey(Key,True);
        WriteString(Name,Value);
     finally
        Free;
     end;
end;

procedure WriteRegistWord(ARootKey: HKEY; Key,Name: String; Value: Integer);
begin
  with TRegistry.Create do
     try
        RootKey:=ARootKey;
        OpenKey(Key,True);
        WriteInteger(Name,Value);
     finally
        Free;
     end;
end;

procedure WriteRegistBool(ARootKey: HKEY;Key,Name: String; Value: Boolean);
begin
  with TRegistry.Create do
     try
        RootKey:=ARootKey;
        OpenKey(Key,True);
        WriteBool(Name,Value);
     finally
        Free;
     end;
end;

function GetWinTempDir: String;
var
   Path: PChar;
begin
  try
     Path:=StrAlloc(Max_Path+1);
     GetTempPath(Max_Path,Path);
     Result:=StrPas(Path);
     StrDispose(Path);
  except
     Result:='';
  end;
end;

function GetWindowsDir: string;
var
  Path:array[0..Max_Path] of Char;
begin
  try
     GetWindowsDirectory(Path,SizeOf(Path));
     Result:=StrPas(Path);
  except
     Result:='';
  end;
end; 

function GetSystemDir: String;
var
  Path:array[0..Max_Path] of Char;
begin
  try
     GetSystemDirectory(Path,SizeOf(Path));
     Result:=StrPas(Path);
  except
     Result:='';
  end;
end;

function GetProgFilesDir: string;
begin 
   Result := string(ReadRegistString(HKEY_LOCAL_MACHINE, HKLM_CURRENT_VERSION_WINDOWS, 'ProgramFilesDir', ''));
end; 
 
function GetTempFile(PathName,PrefixStr: String; UniqueID:Integer=0): String;
var
  FileName: array[0..2047] of Char;
begin
  if GetTempFileName(PChar(PathName),PChar(PrefixStr),UniqueID,@FileName)<>0 then
    Result:=FileName
  else
    Result:='';
end;

procedure SetTaskBarVisible(Visible: Boolean); 
var 
   wndHandle: THandle; 
begin 
   wndHandle := FindWindow('Shell_TrayWnd', nil); 
   ShowWindow(wndHandle, csWndShowFlag[Visible]); 
end; 

procedure SetDesktopVisible(Visible: Boolean); 
var 
   hDesktop: THandle; 
begin 
   hDesktop := FindWindow('Progman', nil); 
   ShowWindow(hDesktop, csWndShowFlag[Visible]); 
end; 

function IsWindows9598: Boolean; 
var 
   V: TOSVersionInfo; 
begin 
   V.dwOSVersionInfoSize := SizeOf(V); 
   Result := False; 
   if not GetVersionEx(V) then 
      Exit; 
   if V.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS then 
      Result := True; 
end; 

function GetOSString: string;
var 
   OSPlatform: Ansistring;
   BuildNumber: Integer; 
begin 
   Result := 'Unknown Windows Version';
   OSPlatform := 'Windows'; 
   BuildNumber := 0; 

   case Win32Platform of 
      VER_PLATFORM_WIN32_WINDOWS: 
         begin 
            BuildNumber := Win32BuildNumber and $0000FFFF; 
            case Win32MinorVersion of 
               0..9: 
                  begin 
                     if Trim(Win32CSDVersion) = 'B' then 
                        OSPlatform := 'Windows 95 OSR2' 
                     else 
                        OSPlatform := 'Windows 95'; 
                  end; 
               10..89: 
                  begin 
                     if Trim(Win32CSDVersion) = 'A' then 
                        OSPlatform := 'Windows 98' 
                     else 
                        OSPlatform := 'Windows 98 SE'; 
                  end; 
               90: 
                  OSPlatform := 'Windows Millennium'; 
            end; 
         end; 
      VER_PLATFORM_WIN32_NT: 
         begin 
            if Win32MajorVersion in [3, 4] then 
               OSPlatform := 'Windows NT' 
            else 
               if Win32MajorVersion = 5 then 
                  begin 
                     case Win32MinorVersion of 
                        0: OSPlatform := 'Windows 2000'; 
                        1: OSPlatform := 'Windows XP'; 
                     end; 
                  end; 
            BuildNumber := Win32BuildNumber; 
         end; 
      VER_PLATFORM_WIN32s: 
         begin 
            OSPlatform := 'Win32s'; 
            BuildNumber := Win32BuildNumber; 
         end; 
   end; 
   if (Win32Platform = VER_PLATFORM_WIN32_WINDOWS) or (Win32Platform = VER_PLATFORM_WIN32_NT) then 
      begin 
         if Trim(Win32CSDVersion) = '' then 
            Result := Format('%s %d.%d (Build %d)', [OSPlatform, Win32MajorVersion, Win32MinorVersion, BuildNumber])
         else 
            Result := Format('%s %d.%d (Build %d: %s)', [OSPlatform, Win32MajorVersion,Win32MinorVersion, BuildNumber, Win32CSDVersion]);
      end 
   else 
      Result := Format('%s %d.%d', [OSPlatform, Win32MajorVersion, Win32MinorVersion]);
end;

function GetComputeName : string;
var 
   dwBuff : DWORD; 
   CmpName : array [0..255] of Char;
begin
   Result := '';
   dwBuff := 256; 
   FillChar(CmpName, SizeOf(CmpName), 0); 
   if GetComputerName(CmpName, dwBuff) then 
      Result := CmpName;
end; 

function GetLocalUserName: string;
var 
   Count: DWORD; 
   CmpName : array [0..256] of Char;
begin
   Count := 256 + 1;
   if GetUserName(CmpName, Count) then
      Result := CmpName
   else
      Result := ''; 
end; 

procedure Delay(const uDelay: DWORD); 
var 
   n: DWORD; 
begin 
   n := GetTickCount; 
   while ((GetTickCount - n) <= uDelay) do
      Application.ProcessMessages;
end; 

function SoundCardExists: Boolean; 
begin 
   Result := WaveOutGetNumDevs > 0;
end; 

function UrlEncode(const DecodedStr: AnsiString; Pluses: Boolean): AnsiString;
var
   I: Integer;
begin
   Result:='';
   if Length(DecodedStr)>0 then
      for I:=1 to Length(DecodedStr) do
         begin
            if not (DecodedStr[I] in ['0'..'9','a'..'z','A'..'Z',' ']) then
               Result:=Result+'%'+AnsiString(IntToHex(Ord(DecodedStr[I]),2))
            else
               begin
                  if not (DecodedStr[I]=' ') then
                     Result:=Result+DecodedStr[I]
                  else
                     begin
                        if not Pluses then
                           Result:=Result+'%20'
                        else
                           Result:=Result+'+';
                     end;
               end;
        end;
end;

function UrlDecode(const EncodedStr: AnsiString): AnsiString;
var
   I,x: Integer;
   c: AnsiChar;
begin
   Result:='';
   if Length(EncodedStr)>0 then
      begin
         I:=1;
         while I<=Length(EncodedStr) do
            begin
               if EncodedStr[I]='%' then
                  begin
                     x:=HexToInt(EncodedStr[I+1]+EncodedStr[I+2]);
                     move(x,c,1);
                     Result:=Result+C;
                     I:=Succ(Succ(I));
                  end
               else
                  begin
                     if EncodedStr[I]='+' then
                        Result:=Result+' '
                     else
                        Result:=Result+EncodedStr[I];
                     I:=Succ(I);
                  end;
            end;
      end;
end;

function HexToInt(HexStr: AnsiString): Int64;
var
   RetVar: Int64;
   i: byte;
begin
   HexStr:=UpperCase(HexStr);
   if HexStr[length(HexStr)]='H' then
      Delete(HexStr,length(HexStr),1);
   RetVar:=0;
   for i:=1 to length(HexStr) do
      begin
         RetVar:=RetVar shl 4;
         if HexStr[i] in ['0'..'9'] then
            RetVar:=RetVar+(byte(HexStr[i])-48)
         else
            begin
               if HexStr[i] in ['A'..'F'] then
                  RetVar:=RetVar+(byte(HexStr[i])-55)
               else
                  begin
                     Retvar:=0;
                     break;
                  end;
            end;
      end;
   Result:=RetVar;
end;

function FileDate2DelphiDate(FileDate: _FileTime): TDateTime;
var
   Tct: _SystemTime;
   Temp: _FileTime;
begin
   FileTimeToLocalFileTime(FileDate,Temp);
   FileTimeToSystemTime(Temp,Tct);
   Result:=SystemTimeToDateTime(Tct);
end;

function GetFileSize(const FileName: string): Longint;
var
   SearchRec: TSearchRec;
begin
   if FindFirst(ExpandFileName(FileName), faAnyFile, SearchRec)=0 then
      Result:=SearchRec.Size
   else
      Result:=-1;
   FindClose(SearchRec);
end;

function GetFileCreateDate(aFileName: string): TDateTime;
var
   Tp: TSearchRec;
begin
   if FindFirst(aFileName,faAnyFile,Tp)=0 then
      Result:=FileDate2DelphiDate(Tp.FindData.ftCreationTime)
   else
      Result:=strtodate('1900-01-01');
end;

function GetFileModifiedDate(aFileName: string): TDateTime;
var
   Tp: TSearchRec;
begin
   if FindFirst(aFileName,faAnyFile,Tp)=0 then
      Result:=FileDate2DelphiDate(Tp.FindData.ftLastWriteTime)
   else
      Result:=strtodate('1900-01-01');
end;

Function FtToDt(AFT:_FILETIME): TDateTime;
Var
  LocalFT: _FILETIME;
  SysT: _SystemTime;
begin
  FileTimeToLocalFileTime(AFT, LocalFT);
  FileTimeToSystemTime(LocalFT, SysT);
  Result := SystemTimeToDateTime(SysT);
end;

Function DtToFt(ADT:TDateTime): _FILETIME;
Var
  SysT: _SystemTime;
  LocalFT: _FILETIME;
begin
  DateTimeToSystemTime(ADT, SysT);
  SystemTimeToFileTime(SysT, LocalFT);
  LocalFileTimeToFileTime(LocalFT, Result);
end;

Function ReadFileLWTime(AFile: String): TDateTime;
var
  hFileOld :THandle;
  LastWriteTime :_FileTime;
begin
  Result := 0;
  hFileOld :=CreateFile(Pchar(AFile),generic_read,file_share_read,nil, open_existing,FILE_ATTRIBUTE_NORMAL,Cardinal(nil));
  if (hFileOld=INVALID_HANDLE_VALUE) then
     exit;
  GetFileTime(hFileOld,nil,nil,@LastWriteTime);
  CloseHandle(hFileOld);
  Result := FtToDt(LastWriteTime);
end;

procedure SetFileLWTime(AFile: String; ADateTime:TDateTime);
Var
  hFileNew :THandle;
  LastWriteTime :_FileTime;
begin
  hFileNew :=createFile(PChar(AFile),generic_write,file_share_write,nil,
                        open_existing,FILE_ATTRIBUTE_NORMAL,Cardinal(nil));
  if (hFileNew=INVALID_HANDLE_VALUE) then
     exit;
  LastWriteTime := DtToFt(ADateTime);
  SetFileTime(hFileNew,nil,nil,@LastWriteTime);
  CloseHandle(hFileNew);
end;

function GetHardDiskPartitionType(const DriveLetter: AnsiChar): string;
var
  NotUsed: DWORD; 
  VolumeFlags: DWORD; 
  VolumeSerialNumber: DWORD; 
  PartitionType: array [0..32] of Char;
begin 
  GetVolumeInformation(PChar(DriveLetter + ':\'), nil, MAX_PATH, @VolumeSerialNumber, NotUsed, VolumeFlags, PartitionType, 32);
  Result := PartitionType;
end;

function GetCPUSpeed: Double;
const
  DelayTime = 500; 
var 
  TimerHi, TimerLo: DWORD; 
  PriorityClass, Priority: Integer; 
begin 
  PriorityClass := GetPriorityClass(GetCurrentProcess); 
  Priority      := GetThreadPriority(GetCurrentThread); 
  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS); 
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  Sleep(10);
  asm
    dw 310Fh 
    mov TimerLo, eax 
    mov TimerHi, edx 
  end; 
  Sleep(DelayTime); 
  asm 
    dw 310Fh 
    sub eax, TimerLo 
    sbb edx, TimerHi 
    mov TimerLo, eax 
    mov TimerHi, edx 
  end; 
  SetThreadPriority(GetCurrentThread, Priority); 
  SetPriorityClass(GetCurrentProcess, PriorityClass); 
  Result := TimerLo / (1000 * DelayTime); 
end;

const 
  SECURITY_NT_AUTHORITY: TSIDIdentifierAuthority = (Value: (0, 0, 0, 0, 0, 5));
  SECURITY_BUILTIN_DOMAIN_RID = $00000020; 
  DOMAIN_ALIAS_RID_ADMINS = $00000220; 

function IsAdmin: Boolean;
var 
  hAccessToken: THandle; 
  ptgGroups: PTokenGroups; 
  dwInfoBufferSize: DWORD; 
  psidAdministrators: PSID; 
  x: Integer; 
  bSuccess: BOOL; 
begin 
  Result   := False; 
  bSuccess := OpenThreadToken(GetCurrentThread, TOKEN_QUERY, True, 
    hAccessToken); 
  if not bSuccess then 
  begin 
    if GetLastError = ERROR_NO_TOKEN then 
      bSuccess := OpenProcessToken(GetCurrentProcess, TOKEN_QUERY, 
        hAccessToken); 
  end; 
  if bSuccess then 
  begin 
    GetMem(ptgGroups, 1024); 
    bSuccess := GetTokenInformation(hAccessToken, TokenGroups, 
      ptgGroups, 1024, dwInfoBufferSize); 
    CloseHandle(hAccessToken); 
    if bSuccess then 
    begin 
      AllocateAndInitializeSid(SECURITY_NT_AUTHORITY, 2, 
        SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS, 
        0, 0, 0, 0, 0, 0, psidAdministrators); 
      {$R-} 
      for x := 0 to ptgGroups.GroupCount - 1 do 
        if EqualSid(psidAdministrators, ptgGroups.Groups[x].Sid) then 
        begin 
          Result := True; 
          Break; 
        end; 
      {$R+} 
      FreeSid(psidAdministrators); 
    end; 
    FreeMem(ptgGroups); 
  end; 
end;

function DeleteDirectory(const Source: string): boolean;
var
   fo: TSHFILEOPSTRUCT;
begin
   FillChar(fo, SizeOf(fo), 0);
   with fo do
      begin
         Wnd := 0;
         wFunc := FO_Delete;
         pFrom := PChar(Source + #0);
         pTo := #0#0;
         fFlags := FOF_NOCONFIRMATION + FOF_SILENT;
      end;
   Result := (SHFileOperation(fo) = 0);
end;

{$IFNDEF VER130}
function CreateShortcut(Exe: string; Lnk: string = ''; Dir: string = ''; ID: Integer = -1):Boolean;
var
  IObj: IUnknown;
  ILnk: IShellLink;
  IPFile: IPersistFile;
  PIDL: PItemIDList;
  InFolder: array [0..MAX_PATH] of Char;
  LinkFileName: WideString;
begin
  Result := False;
  if not FileExists(Exe) then
     Exit;
  if Lnk = '' then
     Lnk := ChangeFileExt(ExtractFileName(Exe), AnsiString(''));

  IObj := CreateComObject(CLSID_ShellLink);
  ILnk := IObj as IShellLink;
  ILnk.SetPath(PChar(Exe));
  ILnk.SetWorkingDirectory(PChar(ExtractFilePath(Exe)));

  if (Dir = '') and (ID = -1) then
     ID := CSIDL_DESKTOP;
  if ID > -1 then
    begin
      SHGetSpecialFolderLocation(0, ID, PIDL);
      SHGetPathFromIDList(PIDL, InFolder);
      LinkFileName := Format('%s\%s.lnk', [InFolder, Lnk]);
    end
  else
    begin
      Dir := ExcludeTrailingPathDelimiter(Dir);
      if not DirectoryExists(Dir) then
         Exit;
      LinkFileName := Format('%s\%s.lnk', [Dir, Lnk]);
    end;

  IPFile := IObj as IPersistFile;
  if IPFile.Save(PWideChar(LinkFileName), False) = 0 then
     Result := True;
end;
{$ENDIF}

procedure ControlReboot(Enabled: boolean);
begin
   if Enabled then
      SystemParametersInfo(SPI_SCREENSAVERRUNNING, 0, nil, 0)
   else
      SystemParametersInfo(SPI_SCREENSAVERRUNNING, 1, nil, 0);
end;

function ChangeWallPaper(aFileName: string): Boolean;
begin
   Result:=SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, pChar(aFileName),SPIF_UPDATEINIFILE);
end;

procedure SystemAbout(const sTitle, sContent: string);
begin
   ShellAbout(Application.Handle, PChar(sTitle), PChar(sContent), Application.Icon.Handle);
end;

procedure HideFormOnTask;
begin
   SetWindowLong(Application.Handle,GWL_EXSTYLE,WS_EX_TOOLWINDOW);
end;

function GetFileIcon(const Filename: string; SmallIcon: Boolean): HICON;
var
  info: TSHFILEINFO;
  Flag: Integer;
begin
  if SmallIcon then
    Flag := (SHGFI_SMALLICON or SHGFI_ICON)
  else
    Flag := (SHGFI_LARGEICON or SHGFI_ICON);
  SHGetFileInfo(Pchar(Filename), 0, info, Sizeof(info), Flag);
  Result := info.hIcon;
end;

function GetCDROMNumber: string;
var
  mp: TMediaPlayer;
  msp: TMCI_INFO_PARMS;
  MediaString: array[0..255] of char;
  ret: longint;
begin
  mp := TMediaPlayer.Create(nil);
  try
    mp.Visible := false;
    mp.Parent := Application.MainForm;
    mp.Shareable := true;
    mp.DeviceType := dtCDAudio;
    mp.FileName := 'D:';
    mp.Open;
    Application.ProcessMessages;
    FillChar(MediaString, sizeof(MediaString), #0);
    FillChar(msp, sizeof(msp), #0);
    msp.lpstrReturn := @MediaString;
    msp.dwRetSize := 255;
    ret := mciSendCommand(Mp.DeviceId, MCI_INFO, MCI_INFO_MEDIA_IDENTITY, longint(@msp));
    if Ret <> 0 then
    begin
      MciGetErrorString(ret, @MediaString, sizeof(MediaString));
      Result := MediaString;
    end
    else
      Result := MediaString;
  finally
    mp.Close;
    Application.ProcessMessages;
    mp.free;
  end;
end;

procedure OpenCDROM;
begin
   mciSendString('Set cdaudio door open wait', nil, 0, Application.Handle);
end;

procedure CloseCDROM;
begin
  mciSendString('Set cdaudio door closed wait', nil, 0, Application.Handle);
end;

function OpenSystemDialog(const iNumber:integer):Boolean;
begin
  try
    case iNumber of
      1: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL InetCpl.cpl,,3',SW_SHOWNORMAL);
      2: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Intl.cpl,,4',SW_SHOWNORMAL);
      3: WinExec('RunDLL.exe Shell32.DLL,Control_RunDLL',SW_SHOWNORMAL);
      4: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL ODBCCP32.CPL',SW_SHOWNORMAL);
      5: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL BdeAdmin.CPL',SW_SHOWNORMAL);
      6: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL InetCpl.cpl,,0', SW_SHOWNORMAL);
      7: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL InetCpl.cpl,,1', SW_SHOWNORMAL);
      8: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL InetCpl.cpl,,2', SW_SHOWNORMAL);
      9: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL InetCpl.cpl,,4', SW_SHOWNORMAL);
      10: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL InetCpl.cpl,,5', SW_SHOWNORMAL);
      11: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Telephon.cpl', SW_SHOWNORMAL);
      12: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL PowerCfg.cpl', SW_SHOWNORMAL);
      13: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Modem.cpl', SW_SHOWNORMAL);
      14: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Mmsys.cpl,,0', SW_SHOWNORMAL);
      15: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Mmsys.cpl,,1', SW_SHOWNORMAL);
      16: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Mmsys.cpl,,2', SW_SHOWNORMAL);
      17: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Mmsys.cpl,,3', SW_SHOWNORMAL);
      18: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Mmsys.cpl,,4', SW_SHOWNORMAL);
      19: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL access.cpl,,1',SW_SHOWNORMAL);
      20: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL access.cpl,,2', SW_SHOWNORMAL);
      21: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL access.cpl,,3', SW_SHOWNORMAL);
      22: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL access.cpl,,4', SW_SHOWNORMAL);
      23: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL access.cpl,,5', SW_SHOWNORMAL);
      24: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Password.cpl', SW_SHOWNORMAL);
      25: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Intl.cpl,,0', SW_SHOWNORMAL);
      26: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Intl.cpl,,1', SW_SHOWNORMAL);
      27: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Intl.cpl,,2', SW_SHOWNORMAL);
      28: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Intl.cpl,,3', SW_SHOWNORMAL);
      29: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Intl.cpl,,4', SW_SHOWNORMAL);
      30: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL TimeDate.cpl,,0', SW_SHOWNORMAL);
      31: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL TimeDate.cpl,,1', SW_SHOWNORMAL);
      32: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Main.cpl', SW_SHOWNORMAL);
      33: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL AppWiz.cpl,,1', SW_SHOWNORMAL);
      34: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL AppWiz.cpl,,2', SW_SHOWNORMAL);
      35: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL AppWiz.cpl,,3', SW_SHOWNORMAL);
      36: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL NetCpl.cpl', SW_SHOWNORMAL);
      37: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL SysDm.cpl,,0', SW_SHOWNORMAL);
      38: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL SysDm.cpl,,1', SW_SHOWNORMAL);
      39: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL SysDm.cpl,,2', SW_SHOWNORMAL);
      40: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL SysDm.cpl,,3', SW_SHOWNORMAL);
      41: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL desk.cpl,,0', SW_SHOWNORMAL);
      42: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL desk.cpl,,1', SW_SHOWNORMAL);
      43: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL desk.cpl,,2', SW_SHOWNORMAL);
      44: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL desk.cpl,,3', SW_SHOWNORMAL);
      45: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Joy.cpl,,0', SW_SHOWNORMAL);
      46: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL Joy.cpl,,1', SW_SHOWNORMAL);
      47: WinExec('RunDLL32.exe Shell32.dll,Control_RunDLL StiCpl.cpl', SW_SHOWNORMAL);
    end;
    Result := true;
  except
    Result := false;
  end;
end;

function ExecuteAndWait(FName, Params: String): boolean;
var
  exInfo: TShellExecuteInfo;
  Ph: DWORD;
begin
  FillChar(exInfo, SizeOf(exInfo), 0);
  with exInfo do
     begin
       cbSize := SizeOf(exInfo);
       fMask := SEE_MASK_NOCLOSEPROCESS;
       Wnd := GetActiveWindow();
       ExInfo.lpVerb := 'open';
       ExInfo.lpParameters := PChar(Params);
       lpFile := PChar(FName);
       nShow := SW_HIDE;
     end;
  if ShellExecuteEx(@exInfo) then
     Ph := exInfo.HProcess
  else
     begin
        result:=false;
        Exit;
     end;
  while WaitForSingleObject(ExInfo.hProcess, 50) <> WAIT_OBJECT_0 do
     Application.ProcessMessages;
  CloseHandle(Ph);
  result:=true;
end;

function GetWinProductID(): string;
var
  reg: TRegistry;
begin
  Result := '';
  reg := TRegistry.Create;
  with reg do
  begin
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('Software\Microsoft\Windows\CurrentVersion', False);
    Result := ReadString('ProductID');
  end;
  reg.Free;
end;

function IsAudioCD(const Drive: AnsiChar): boolean;
var
  DrivePath: Ansistring;
  MaximumComponentLength: DWORD;
  FileSystemFlags: DWORD;
  VolumeName: Ansistring;
begin
  Result := false;
  DrivePath := Drive + AnsiString(':\');
  if GetDriveType(PChar(string(DrivePath))) <> DRIVE_CDROM then
     exit;
  SetLength(VolumeName, 64);
  GetVolumeInformation(PChar(string(DrivePath)),
    PChar(string(VolumeName)),
    Length(VolumeName),
    nil,
    MaximumComponentLength,
    FileSystemFlags,
    nil,
    0);
  if lStrCmp(PChar(string(VolumeName)),'Audio CD') = 0 then
     result := true;
end;

function PlayAudioCD(const Drive: AnsiChar): boolean;
var
  mp: TMediaPlayer;
begin
  Result := false;
  Application.ProcessMessages;
  if not IsAudioCD(Drive) then exit;
  mp := TMediaPlayer.Create(nil);
  mp.Visible := false;
  mp.Parent := Application.MainForm;
  mp.Shareable := true;
  mp.DeviceType := dtCDAudio;
  mp.FileName := Drive + ':';
  mp.Shareable := true;
  mp.Open;
  Application.ProcessMessages;
  mp.Play;
  Application.ProcessMessages;
  mp.Close;
  Application.ProcessMessages;
  mp.free;
  Result := true;
end;

function DiskInDrive(Drive: Char): Boolean;
var
  ErrorMode: word;
begin
  
  if Drive in ['a'..'z'] then Dec(Drive, $20);
  
  if not (Drive in ['A'..'Z']) then
    raise EConvertError.Create('Not a valid drive ID');
  
  ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
  try
    
    if DiskSize(Ord(AnsiChar(Drive)) - $40) = -1 then
      Result := False
    else
      Result := True;
  finally
    
    SetErrorMode(ErrorMode);
  end;
end;

{$IFNDEF VER130}
function CopyDir(const sDirName, sToDirName: string): Boolean;
   function DoCopyDir(const sDirName, sToDirName: string): Boolean;
   var
     hFindFile: Cardinal;
     t, tfile: string;
     sCurDir: string;
     FindFileData: WIN32_FIND_DATA;
   begin
     Result := false;
     sCurDir := GetCurrentDir;
     ChDir(sDirName);
     hFindFile := FindFirstFile('*.*', FindFileData);
     if hFindFile <> INVALID_HANDLE_VALUE then
       begin
         if not DirectoryExists(sToDirName) then
            ForceDirectories(sToDirName);
         repeat
           tfile := FindFileData.cFileName;
           if (tfile = '.') or (tfile = '..') then
              Continue;
           if FindFileData.dwFileAttributes = FILE_ATTRIBUTE_DIRECTORY then
             begin
               t := sToDirName + '\' + tfile;
               if not DirectoryExists(t) then
                  ForceDirectories(t);
               if sDirName[Length(sDirName)] <> '\' then
                 DoCopyDir(sDirName + '\' + tfile, t)
               else
                 DoCopyDir(sDirName + tfile, sToDirName + tfile);
             end
           else
             begin
               t := sToDirName + '\' + tFile;
               CopyFile(PChar(tfile), PChar(t), True);
             end;
         until FindNextFile(hFindFile, FindFileData) = false;
       end
     else
       begin
         ChDir(sCurDir);
         exit;
       end;
     ChDir(sCurDir);
     Result := true;
   end;
begin
  Result := false;
  if Length(sDirName) <= 0 then
     exit;
  Result := DoCopyDir(sDirName, sToDirName);
end;

{$ENDIF}

procedure GetPortUsed(var stComList: TStrings);
var
  reg: TRegistry;
  ts: TStrings;
  i: integer;
begin
  reg := TRegistry.Create;
  try
    reg.RootKey := HKEY_LOCAL_MACHINE;
    reg.OpenKey('hardware\devicemap\serialcomm',false);
    ts := TStringList.Create;
    try
      reg.GetValueNames(ts); //Ӽµ
      stComList := TStringList.Create;
      for i := 0 to ts.Count - 1 do
        stComList.Add(reg.ReadString(ts.Strings[i]));
    finally
      ts.Free;
    end;
  finally
    reg.CloseKey;
    reg.free;
  end;
end;

procedure ControlMediaAudio(const DeviceID: word; Enabled: boolean);
var
  SetParm: TMCI_SET_PARMS;
begin
  SetParm.dwAudio := MCI_SET_AUDIO_ALL;
  if Enabled then
     mciSendCommand(DeviceID, MCI_SET, MCI_SET_AUDIO or MCI_SET_ON, Longint(@SetParm))
  else
     mciSendCommand(DeviceID, MCI_SET, MCI_SET_AUDIO or MCI_SET_OFF, Longint(@SetParm));
end;

procedure ShowControlHint(AControl: TControl) ;
var
   pt: TPoint;
begin
   pt := AControl.ClientToScreen(Point(1,1)) ;
   SetCursorPos(pt.x, pt.y) ;
   Application.ActivateHint(pt) ;
end;

end.
