//
//---------------------------------------------------------------
//                                                               
//                                                               
//    QuickBurro Middleware Application Development Package      
//                                                               
//    Version 4.0                                               
//    Update Date: 2011.4.18.                                    
//    Author: Jopher(W.G.Z.)                                     
//    QQ: 779545524                                              
//    Email: Jopher@189.cn  or wpy020327@163.com  
//    Homepage: http://www.jopher.net/               
//                                                               
//    Copyright(C) Jopher Software Studio. All rights reserved   
//                                                               
//                                                               
//---------------------------------------------------------------
//
unit QBParcel;

interface

uses
   Windows, Messages, SysUtils, Classes, Controls, qbfish,
   {$IFDEF UNICODE}
   AnsiStrings,
   {$ENDIF}
   Provider,
   {$IFDEF VER130}
   DbClient;
   {$ELSE}
   DbClient,MidasLib;
   {$ENDIF}

const
    gtByte=1;                
    gtShortInt=2;            
    gtWord=3;                
    gtSmallInt=4;            
    gtLongWord=5;            
    gtInteger=6;             
    gtInt64=7;               
    gtBoolean=11;            
    gtByteBool=12;           
    gtWordBool=13;           
    gtLongBool=14;           
    gtSingle=21;             
    gtReal=23;               
    gtDouble=24;             
    gtComp=25;               
    gtCurrency=26;           
    gtExtended=27;           
    gtDateTime=28;           
    gtDate=29;               
    gtTime=30;               
    gtShortString=31;        
    gtAnsiString=32;         
    gtWideString=33;         
    gtString=34;             
    gtBinary=41;             
    gtCDS=41;                

const
    gdInput=1;
    gdOutput=2;
    gdInputOutput=3;

type
   TParcelHeadRecord=record
      GoodsName: Ansistring;
      GoodsDirection: byte;
      GoodsType: byte;
      OffsetAddress: longint;
      GoodsLength: longint;
end;

type
   TQBParcel=class

   Private
      fEncryptKey: AnsiString;
      fGoodsCount: longint;
      fParcelSize: longint;
      ParcelHead: array of TParcelHeadRecord;    
      ParcelBody: array of byte;                 
      LocalCodePage: Word;
      Fish: TQBFish;
      function GetGoodsIndex(GoodsName: Ansistring): integer;
      function AddGoodsIndex(): integer;
      procedure SetEncryptKey(aKey: AnsiString);

   Protected

   Public
      Constructor Create;                                                     
      Destructor Destroy; Override;                                           
      procedure Clear;
      procedure PutByteGoods(GoodsName: Ansistring; GoodsBody: Byte; GoodsDir: byte=1);
      procedure PutShortIntGoods(GoodsName: Ansistring; GoodsBody: ShortInt; GoodsDir: byte=1);
      procedure PutWordGoods(GoodsName: Ansistring; GoodsBody: Word; GoodsDir: byte=1);
      procedure PutSmallIntGoods(GoodsName: Ansistring; GoodsBody: SmallInt; GoodsDir: byte=1);
      procedure PutLongWordGoods(GoodsName: Ansistring; GoodsBody: LongWord; GoodsDir: byte=1);
      procedure PutIntegerGoods(GoodsName: Ansistring; GoodsBody: Integer; GoodsDir: byte=1);
      procedure PutInt64Goods(GoodsName: Ansistring; GoodsBody: Int64; GoodsDir: byte=1);
      procedure PutBooleanGoods(GoodsName: Ansistring; GoodsBody: Boolean; GoodsDir: byte=1);
      procedure PutByteBoolGoods(GoodsName: Ansistring; GoodsBody: ByteBool; GoodsDir: byte=1);
      procedure PutWordBoolGoods(GoodsName: Ansistring; GoodsBody: WordBool; GoodsDir: byte=1);
      procedure PutLongBoolGoods(GoodsName: Ansistring; GoodsBody: LongBool; GoodsDir: byte=1);
      procedure PutSingleGoods(GoodsName: Ansistring; GoodsBody: Single; GoodsDir: byte=1);
      procedure PutRealGoods(GoodsName: Ansistring; GoodsBody: Real; GoodsDir: byte=1);
      procedure PutDoubleGoods(GoodsName: Ansistring; GoodsBody: Double; GoodsDir: byte=1);
      procedure PutCompGoods(GoodsName: Ansistring; GoodsBody: Comp; GoodsDir: byte=1);
      procedure PutCurrencyGoods(GoodsName: Ansistring; GoodsBody: Currency; GoodsDir: byte=1);
      procedure PutExtendedGoods(GoodsName: Ansistring; GoodsBody: Extended; GoodsDir: byte=1);
      procedure PutDateTimeGoods(GoodsName: Ansistring; GoodsBody: TDateTime; GoodsDir: byte=1);
      procedure PutDateGoods(GoodsName: Ansistring; GoodsBody: TDate; GoodsDir: byte=1);
      procedure PutTimeGoods(GoodsName: Ansistring; GoodsBody: TTime; GoodsDir: byte=1);
      procedure PutShortStringGoods(GoodsName: Ansistring; GoodsBody: ShortString; GoodsDir: byte=1);
      procedure PutAnsiStringGoods(GoodsName: Ansistring; GoodsBody: AnsiString; GoodsDir: byte=1);
      procedure PutWideStringGoods(GoodsName: Ansistring; GoodsBody: WideString; GoodsDir: byte=1);
      procedure PutStringGoods(GoodsName: Ansistring; GoodsBody: String; GoodsDir: byte=1);
      procedure PutEncryptStringGoods(GoodsName: Ansistring; GoodsBody: AnsiString; GoodsDir: byte=1);
      procedure PutBinaryGoods(GoodsName: Ansistring; GoodsBody: Ansistring; GoodsDir: byte=1);
      function PutFileBlockGoods(GoodsName: Ansistring; FHandle: THandle; BlockSize: integer; GoodsDir: byte=1): boolean;
      procedure PutMemoryBlockGoods(GoodsName: Ansistring; GoodsBody: Pointer; BlockSize: integer; GoodsDir: byte=1);
      procedure PutStreamGoods(GoodsName: Ansistring; GoodsBody: TMemoryStream; GoodsDir: byte=1);
      procedure PutParcelGoods(GoodsName: Ansistring; GoodsBody: TQBParcel; GoodsDir: byte=1);
      procedure PutCDSGoods(GoodsName: Ansistring; GoodsBody: TClientDataset; GoodsDir: byte=1);
      function GetByteGoods(GoodsName: Ansistring): byte;
      function GetShortIntGoods(GoodsName: Ansistring): shortint;
      function GetWordGoods(GoodsName: Ansistring): word;
      function GetSmallIntGoods(GoodsName: Ansistring): smallint;
      function GetLongWordGoods(GoodsName: Ansistring): longword;
      function GetIntegerGoods(GoodsName: Ansistring): integer;
      function GetInt64Goods(GoodsName: Ansistring): int64;
      function GetBooleanGoods(GoodsName: Ansistring): boolean;
      function GetByteBoolGoods(GoodsName: Ansistring): bytebool;
      function GetWordBoolGoods(GoodsName: Ansistring): wordbool;
      function GetLongBoolGoods(GoodsName: Ansistring): longbool;
      function GetSingleGoods(GoodsName: Ansistring): single;
      function GetRealGoods(GoodsName: Ansistring): real;
      function GetDoubleGoods(GoodsName: Ansistring): double;
      function GetCompGoods(GoodsName: Ansistring): comp;
      function GetCurrencyGoods(GoodsName: Ansistring): currency;
      function GetExtendedGoods(GoodsName: Ansistring): extended;
      function GetDateTimeGoods(GoodsName: Ansistring): TDateTime;
      function GetDateGoods(GoodsName: Ansistring): TDate;
      function GetTimeGoods(GoodsName: Ansistring): TTime;
      function GetShortStringGoods(GoodsName: Ansistring): shortstring;
      function GetAnsiStringGoods(GoodsName: Ansistring): Ansistring;
      function GetWideStringGoods(GoodsName: Ansistring): Widestring;
      function GetStringGoods(GoodsName: Ansistring): string;
      function GetEncryptStringGoods(GoodsName: Ansistring): Ansistring;
      function GetBinaryGoods(GoodsName: Ansistring): Ansistring;
      function GetFileBlockGoods(GoodsName: AnsiString; fHandle: THandle): boolean;
      function GetMemoryBlockGoods(GoodsName: Ansistring): pointer;
      function GetStreamGoods(GoodsName: Ansistring; var aStream: TMemoryStream): boolean;
      function GetParcelGoods(GoodsName: Ansistring; var aParcel: TQBParcel): boolean;
      function GetCDSGoods(GoodsName: Ansistring; var aCds: tclientdataset): boolean;
      procedure RemoveGoods(GoodsName: AnsiString);
      function GoodsExists(GoodsName: Ansistring): Boolean;
      function GetGoodsName(GoodsIndex: integer): Ansistring;
      procedure SetGoodsDirection(GoodsName: Ansistring; GoodsDir: byte);
      function GetGoodsDirection(GoodsName: Ansistring): byte;
      function GetGoodsSize(GoodsName: Ansistring): Longint;
      function GetGoodsType(GoodsName: Ansistring): shortint;
      function LoadFromStream(aStream: TMemoryStream): boolean;
      function SaveToStream(var aStream: TMemoryStream): boolean;
      function DecryptFromStream(aStream: TMemoryStream): boolean;
      function EncryptToStream(var aStream: TMemoryStream): boolean;
      function LoadFromFile(FileName: String): boolean;
      function SaveToFile(FileName: String): boolean;
      function LoadFromString(aStr: Ansistring): boolean;
      function SaveToString(var aStr: Ansistring): boolean;
      function SaveToStringWithLength(var aStr: Ansistring): boolean;
      property EncryptKey: AnsiString read fEncryptKey write SetEncryptKey;
      property GoodsCount: integer read fGoodsCount;
      property ParcelSize: longint read fParcelSize;

end;

implementation

uses
   QBCommon;

function TQBParcel.GetGoodsIndex(GoodsName: Ansistring): integer;
var
   i: integer;
begin
   result:=-1;
   for i:=0 to fGoodsCount-1 do
      if StrIComp(PAnsiChar(ParcelHead[i].GoodsName),PAnsiChar(GoodsName))=0 then
         begin
            result:=i;
            break;
         end;
end;

function TQBParcel.AddGoodsIndex(): integer;
begin
   result:=fGoodsCount;
   inc(fGoodsCount);
   setlength(ParcelHead,fGoodsCount);
end;

procedure TQBParcel.SetEncryptKey(aKey: AnsiString);
begin
   if StrIComp(pAnsiChar(aKey),PAnsiChar(fEncryptKey))=0 then
      exit;
   fEncryptKey:=aKey;
   Fish.Free;
   Fish:=TQBFish.Create;
   Fish.InitialiseString(fEncryptKey);
end;

constructor TQBParcel.Create;
begin
   fGoodsCount:=0;
   setlength(ParcelHead,fGoodsCount);
   fParcelSize:=0;
   setlength(ParcelBody,0);
   LocalCodePage:=WinCodePage;
   fEncryptKey:='k2(o0_at~2%,l?kjw[0-xh7mk3vq&5zx';
   Fish:=TQBFish.Create;
   Fish.InitialiseString(fEncryptKey);
end;

destructor TQBParcel.Destroy;
begin
   fGoodsCount:=0;
   setlength(ParcelHead,fGoodsCount);
   fParcelSize:=0;
   setlength(ParcelBody,0);
   Fish.Free;
end;

procedure TQBParcel.Clear;
begin
   fGoodsCount:=0;
   setlength(ParcelHead,fGoodsCount);
   fParcelSize:=0;
   setlength(ParcelBody,0);
end;

procedure TQBParcel.PutByteGoods(GoodsName: Ansistring; GoodsBody: Byte; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtByte;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=1;                 
         fParcelSize:=fParcelSize+1;                   
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],1);  
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtByte then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],1);
      end;
end;

procedure TQBParcel.PutShortIntGoods(GoodsName: Ansistring; GoodsBody: ShortInt; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtShortInt;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=1;                     
         fParcelSize:=fParcelSize+1;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],1);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtShortInt then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],1);
      end;
end;

procedure TQBParcel.PutWordGoods(GoodsName: Ansistring; GoodsBody: Word; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtWord;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=2;                     
         fParcelSize:=fParcelSize+2;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],2);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtWord then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],2);
      end;
end;

procedure TQBParcel.PutSmallIntGoods(GoodsName: Ansistring; GoodsBody: SmallInt; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtSmallInt;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=2;                     
         fParcelSize:=fParcelSize+2;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],2);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtSmallInt then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],2);
      end;
end;

procedure TQBParcel.PutLongWordGoods(GoodsName: Ansistring; GoodsBody: LongWord; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtLongWord;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=4;                     
         fParcelSize:=fParcelSize+4;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],4);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtLongWord then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],4);
      end;
end;

procedure TQBParcel.PutIntegerGoods(GoodsName: Ansistring; GoodsBody: Integer; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtInteger;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=4;                     
         fParcelSize:=fParcelSize+4;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],4);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtInteger then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],4);
      end;
end;

procedure TQBParcel.PutInt64Goods(GoodsName: Ansistring; GoodsBody: Int64; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtInt64;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=8;                     
         fParcelSize:=fParcelSize+8;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],8);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtInt64 then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],8);
      end;
end;

procedure TQBParcel.PutBooleanGoods(GoodsName: Ansistring; GoodsBody: Boolean; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtBoolean;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=1;                     
         fParcelSize:=fParcelSize+1;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],1);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtBoolean then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],1);
      end;
end;

procedure TQBParcel.PutByteBoolGoods(GoodsName: Ansistring; GoodsBody: ByteBool; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtByteBool;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=1;                     
         fParcelSize:=fParcelSize+1;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],1);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtByteBool then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],1);
      end;
end;

procedure TQBParcel.PutWordBoolGoods(GoodsName: Ansistring; GoodsBody: WordBool; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtWordBool;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=2;                     
         fParcelSize:=fParcelSize+2;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],2);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtWordBool then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],2);
      end;
end;

procedure TQBParcel.PutLongBoolGoods(GoodsName: Ansistring; GoodsBody: LongBool; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtLongBool;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=4;                     
         fParcelSize:=fParcelSize+4;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],4);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtLongBool then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],4);
      end;
end;

procedure TQBParcel.PutSingleGoods(GoodsName: Ansistring; GoodsBody: Single; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtSingle;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=4;                     
         fParcelSize:=fParcelSize+4;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],4);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtSingle then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],4);
      end;
end;

procedure TQBParcel.PutRealGoods(GoodsName: Ansistring; GoodsBody: Real; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtReal;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=8;                     
         fParcelSize:=fParcelSize+8;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],8);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtReal then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],8);
      end;
end;

procedure TQBParcel.PutDoubleGoods(GoodsName: Ansistring; GoodsBody: Double; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtDouble;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=8;                     
         fParcelSize:=fParcelSize+8;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],8);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtDouble then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],8);
      end;
end;

procedure TQBParcel.PutCompGoods(GoodsName: Ansistring; GoodsBody: Comp; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtComp;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=8;                     
         fParcelSize:=fParcelSize+8;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],8);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtComp then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],8);
      end;
end;

procedure TQBParcel.PutCurrencyGoods(GoodsName: Ansistring; GoodsBody: Currency; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtCurrency;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=8;                     
         fParcelSize:=fParcelSize+8;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],8);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtCurrency then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],8);
      end;
end;

procedure TQBParcel.PutExtendedGoods(GoodsName: Ansistring; GoodsBody: Extended; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtExtended;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=10;                    
         fParcelSize:=fParcelSize+10;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],10);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtExtended then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],10);
      end;
end;

procedure TQBParcel.PutDateTimeGoods(GoodsName: Ansistring; GoodsBody: TDateTime; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtDateTime;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=8;                     
         fParcelSize:=fParcelSize+8;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],8);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtDateTime then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],8);
      end;
end;

procedure TQBParcel.PutDateGoods(GoodsName: Ansistring; GoodsBody: TDate; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtDate;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=8;                     
         fParcelSize:=fParcelSize+8;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],8);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtDate then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],8);
      end;
end;

procedure TQBParcel.PutTimeGoods(GoodsName: Ansistring; GoodsBody: TTime; GoodsDir: byte=1);
var
   j: integer;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtTime;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=8;                     
         fParcelSize:=fParcelSize+8;
         setlength(ParcelBody,fParcelSize);
         move(GoodsBody,ParcelBody[ParcelHead[j].OffsetAddress],8);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtTime then
            exit;
         move(GoodsBody,ParcelBody[ParcelHead[j].offsetaddress],8);
      end;
end;

procedure TQBParcel.PutShortStringGoods(GoodsName: Ansistring; GoodsBody: ShortString; GoodsDir: byte=1);
var
   i,j,k,l: integer;
   offsetaddr: longint;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtShortString;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=length(GoodsBody);        
         fParcelSize:=fParcelSize+length(GoodsBody);
         if length(GoodsBody)>0 then
            begin
               setlength(ParcelBody,fParcelSize);
               move(GoodsBody[1],ParcelBody[ParcelHead[j].OffsetAddress],length(GoodsBody));
            end;
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtShortString then
            exit;
         if ParcelHead[j].GoodsLength<>length(GoodsBody) then
            begin
               for i:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength to fParcelSize-1 do
                  ParcelBody[i-ParcelHead[j].GoodsLength]:=ParcelBody[i];
               fParcelSize:=fParcelSize-ParcelHead[j].GoodsLength;
               setlength(ParcelBody,fParcelSize);
               if length(GoodsBody)>0 then
                  begin
                     k:=fParcelSize;
                     l:=length(GoodsBody);
                     fParcelSize:=fParcelSize+l;
                     ParcelHead[j].GoodsLength:=l;
                     setlength(ParcelBody,fParcelSize);
                     for i:=k-1 downto ParcelHead[j].OffsetAddress do
                        ParcelBody[i+l]:=ParcelBody[i];
                     offsetaddr:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength;
                     for i:=j+1 to fGoodsCount-1 do
                        begin
                           ParcelHead[i].OffsetAddress:=OffsetAddr;
                           OffsetAddr:=OffsetAddr+ParcelHead[i].GoodsLength;
                        end;
                  end;
            end;
         if length(GoodsBody)>0 then
            move(GoodsBody[1],ParcelBody[ParcelHead[j].offsetaddress],length(GoodsBody))
      end;
end;

procedure TQBParcel.PutAnsiStringGoods(GoodsName: Ansistring; GoodsBody: AnsiString; GoodsDir: byte=1);
var
   i,j,k,l: integer;
   offsetaddr: longint;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtAnsiString;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=length(GoodsBody);        
         fParcelSize:=fParcelSize+length(GoodsBody);
         if length(GoodsBody)>0 then
            begin
               setlength(ParcelBody,fParcelSize);
               move(GoodsBody[1],ParcelBody[ParcelHead[j].OffsetAddress],length(GoodsBody));
            end;
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtAnsiString then
            exit;
         if ParcelHead[j].GoodsLength<>length(GoodsBody) then
            begin
               for i:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength to fParcelSize-1 do
                  ParcelBody[i-ParcelHead[j].GoodsLength]:=ParcelBody[i];
               fParcelSize:=fParcelSize-ParcelHead[j].GoodsLength;
               setlength(ParcelBody,fParcelSize);
               if length(GoodsBody)>0 then
                  begin
                     k:=fParcelSize;
                     l:=length(GoodsBody);
                     fParcelSize:=fParcelSize+l;
                     ParcelHead[j].GoodsLength:=l;
                     setlength(ParcelBody,fParcelSize);
                     for i:=k-1 downto ParcelHead[j].OffsetAddress do
                        ParcelBody[i+l]:=ParcelBody[i];
                     offsetaddr:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength;
                     for i:=j+1 to fGoodsCount-1 do
                        begin
                           ParcelHead[i].OffsetAddress:=OffsetAddr;
                           OffsetAddr:=OffsetAddr+ParcelHead[i].GoodsLength;
                        end;
                  end;
            end;
         if length(GoodsBody)>0 then
            move(GoodsBody[1],ParcelBody[ParcelHead[j].offsetaddress],length(GoodsBody))
      end;
end;

procedure TQBParcel.PutWideStringGoods(GoodsName: Ansistring; GoodsBody: WideString; GoodsDir: byte=1);
var
   i,j,k,l: integer;
   offsetaddr: longint;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   l:=length(GoodsBody)*Sizeof(WideChar);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtWideString;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=l;                                
         fParcelSize:=fParcelSize+l;
         if length(GoodsBody)>0 then
            begin
               setlength(ParcelBody,fParcelSize);
               move(GoodsBody[1],ParcelBody[ParcelHead[j].OffsetAddress],l);
            end;
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtWideString then
            exit;
         if ParcelHead[j].GoodsLength<>l then
            begin
               for i:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength to fParcelSize-1 do
                  ParcelBody[i-ParcelHead[j].GoodsLength]:=ParcelBody[i];
               fParcelSize:=fParcelSize-ParcelHead[j].GoodsLength;
               setlength(ParcelBody,fParcelSize);
               if l>0 then
                  begin
                     k:=fParcelSize;
                     fParcelSize:=fParcelSize+l;
                     ParcelHead[j].GoodsLength:=l;
                     setlength(ParcelBody,fParcelSize);
                     for i:=k-1 downto ParcelHead[j].OffsetAddress do
                        ParcelBody[i+l]:=ParcelBody[i];
                     offsetaddr:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength;
                     for i:=j+1 to fGoodsCount-1 do
                        begin
                           ParcelHead[i].OffsetAddress:=OffsetAddr;
                           OffsetAddr:=OffsetAddr+ParcelHead[i].GoodsLength;
                        end;
                  end;
            end;
         if l>0 then
            move(GoodsBody[1],ParcelBody[ParcelHead[j].offsetaddress],l);
      end;
end;

procedure TQBParcel.PutStringGoods(GoodsName: Ansistring; GoodsBody: String; GoodsDir: byte=1);
var
   tmpstr: Ansistring;
   i,j,k,l: integer;
   offsetaddr: longint;
begin
   if GoodsName='' then
      exit;
   tmpstr:=PackString(GoodsBody,LocalCodePage);
   j:=GetGoodsIndex(goodsname);
   l:=length(TmpStr);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtString;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=l;                        
         fParcelSize:=fParcelSize+l;
         setlength(ParcelBody,fParcelSize);
         move(TmpStr[1],ParcelBody[ParcelHead[j].OffsetAddress],l);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtString then
            exit;
         if ParcelHead[j].GoodsLength<>l then
            begin
               for i:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength to fParcelSize-1 do
                  ParcelBody[i-ParcelHead[j].GoodsLength]:=ParcelBody[i];
               fParcelSize:=fParcelSize-ParcelHead[j].GoodsLength;
               setlength(ParcelBody,fParcelSize);
               k:=fParcelSize;
               fParcelSize:=fParcelSize+l;
               ParcelHead[j].GoodsLength:=l;
               setlength(ParcelBody,fParcelSize);
               for i:=k-1 downto ParcelHead[j].OffsetAddress do
                  ParcelBody[i+l]:=ParcelBody[i];
               offsetaddr:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength;
               for i:=j+1 to fGoodsCount-1 do
                  begin
                     ParcelHead[i].OffsetAddress:=OffsetAddr;
                     OffsetAddr:=OffsetAddr+ParcelHead[i].GoodsLength;
                  end;
            end;
         move(TmpStr[1],ParcelBody[ParcelHead[j].offsetaddress],l)
      end;
end;

procedure TQBParcel.PutEncryptStringGoods(GoodsName: Ansistring; GoodsBody: AnsiString; GoodsDir: byte=1);
var
   tmpstr: AnsiString;
begin
   if GoodsBody='' then
      tmpstr:=''
   else
      fish.EncString(GoodsBody,tmpstr);
   PutAnsiStringGoods(GoodsName,tmpstr);
end;

procedure TQBParcel.PutBinaryGoods(GoodsName: Ansistring; GoodsBody: Ansistring; GoodsDir: byte=1);
var
   i,j,k,l: integer;
   offsetaddr: longint;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtBinary;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=Length(GoodsBody);
         fParcelSize:=fParcelSize+Length(GoodsBody);
         if Length(GoodsBody)>0 then
            begin
               setlength(ParcelBody,fParcelSize);
               move(GoodsBody[1],ParcelBody[ParcelHead[j].OffsetAddress],Length(GoodsBody));
            end;
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtBinary then
            exit;
         if ParcelHead[j].GoodsLength<>Length(GoodsBody) then
            begin
               for i:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength to fParcelSize-1 do
                  ParcelBody[i-ParcelHead[j].GoodsLength]:=ParcelBody[i];
               fParcelSize:=fParcelSize-ParcelHead[j].GoodsLength;
               setlength(ParcelBody,fParcelSize);
               if Length(GoodsBody)>0 then
                  begin
                     k:=fParcelSize;
                     l:=Length(GoodsBody);
                     fParcelSize:=fParcelSize+l;
                     ParcelHead[j].GoodsLength:=l;
                     setlength(ParcelBody,fParcelSize);
                     for i:=k-1 downto ParcelHead[j].OffsetAddress do
                        ParcelBody[i+l]:=ParcelBody[i];
                     offsetaddr:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength;
                     for i:=j+1 to fGoodsCount-1 do
                        begin
                           ParcelHead[i].OffsetAddress:=OffsetAddr;
                           OffsetAddr:=OffsetAddr+ParcelHead[i].GoodsLength;
                        end;
                  end;
            end;
         if Length(GoodsBody)>0 then
            move(GoodsBody[1],ParcelBody[ParcelHead[j].offsetaddress],Length(GoodsBody))
      end;
end;

function TQBParcel.PutFileBlockGoods(GoodsName: Ansistring; FHandle: THandle; BlockSize: integer; GoodsDir: byte=1): boolean;
var
   i,j,k,l: integer;
   offsetaddr: longint;
begin
   if GoodsName='' then
      begin
         result:=false;
         exit;
      end;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtBinary;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=BlockSize;
         fParcelSize:=fParcelSize+BlockSize;
         if BlockSize>0 then
            begin
               setlength(ParcelBody,fParcelSize);
               l:=FileRead(fHandle,ParcelBody[ParcelHead[j].OffsetAddress],BlockSize);
               result:=(l=BlockSize);
            end
         else
            result:=(BlockSize=0);
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtBinary then
            begin
               result:=false;
               exit;
            end;
         if ParcelHead[j].GoodsLength<>BlockSize then
            begin
               for i:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength to fParcelSize-1 do
                  ParcelBody[i-ParcelHead[j].GoodsLength]:=ParcelBody[i];
               fParcelSize:=fParcelSize-ParcelHead[j].GoodsLength;
               setlength(ParcelBody,fParcelSize);
               if BlockSize>0 then
                  begin
                     k:=fParcelSize;
                     fParcelSize:=fParcelSize+BlockSize;
                     ParcelHead[j].GoodsLength:=BlockSize;
                     setlength(ParcelBody,fParcelSize);
                     for i:=k-1 downto ParcelHead[j].OffsetAddress do
                        ParcelBody[i+BlockSize]:=ParcelBody[i];
                     offsetaddr:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength;
                     for i:=j+1 to fGoodsCount-1 do
                        begin
                           ParcelHead[i].OffsetAddress:=OffsetAddr;
                           OffsetAddr:=OffsetAddr+ParcelHead[i].GoodsLength;
                        end;
                  end;
            end;
         if BlockSize>0 then
            begin
               l:=FileRead(fHandle,ParcelBody[ParcelHead[j].OffsetAddress],BlockSize);
               result:=(l=BlockSize);
            end
         else
            result:=(blocksize=0);
      end;
end;

procedure TQBParcel.PutMemoryBlockGoods(GoodsName: Ansistring; GoodsBody: Pointer; BlockSize: integer; GoodsDir: byte=1);
var
   i,j,k: integer;
   offsetaddr: longint;
begin
   if GoodsName='' then
      exit;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtBinary;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=BlockSize;
         fParcelSize:=fParcelSize+BlockSize;
         if BlockSize>0 then
            begin
               setlength(ParcelBody,fParcelSize);
               move(GoodsBody^,ParcelBody[ParcelHead[j].OffsetAddress],BlockSize);
            end;
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtBinary then
            exit;
         if ParcelHead[j].GoodsLength<>BlockSize then
            begin
               for i:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength to fParcelSize-1 do
                  ParcelBody[i-ParcelHead[j].GoodsLength]:=ParcelBody[i];
               fParcelSize:=fParcelSize-ParcelHead[j].GoodsLength;
               setlength(ParcelBody,fParcelSize);
               if BlockSize>0 then
                  begin
                     k:=fParcelSize;
                     fParcelSize:=fParcelSize+BlockSize;
                     ParcelHead[j].GoodsLength:=BlockSize;
                     setlength(ParcelBody,fParcelSize);
                     for i:=k-1 downto ParcelHead[j].OffsetAddress do
                        ParcelBody[i+BlockSize]:=ParcelBody[i];
                     offsetaddr:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength;
                     for i:=j+1 to fGoodsCount-1 do
                        begin
                           ParcelHead[i].OffsetAddress:=OffsetAddr;
                           OffsetAddr:=OffsetAddr+ParcelHead[i].GoodsLength;
                        end;
                  end;
            end;
         if BlockSize>0 then
            move(GoodsBody^,ParcelBody[ParcelHead[j].offsetaddress],BlockSize)
      end;
end;

procedure TQBParcel.PutStreamGoods(GoodsName: Ansistring; GoodsBody: TMemoryStream; GoodsDir: byte=1);
var
   tmpstr: Ansistring;
begin
   if GoodsName='' then
      exit;
   if (GoodsBody=nil) or (GoodsBody.Size=0) then
      tmpstr:=''
   else
      begin
         setlength(tmpstr,GoodsBody.size);
         GoodsBody.position:=0;
         GoodsBody.ReadBuffer(TmpStr[1],GoodsBody.size);
         GoodsBody.Position:=0;
      end;
   PutBinaryGoods(GoodsName,tmpstr);
end;

procedure TQBParcel.PutParcelGoods(GoodsName: Ansistring; GoodsBody: TQBParcel; GoodsDir: byte=1);
var
   Stream: TMemoryStream;
begin
   Stream:=TMemoryStream.Create;
   try
      GoodsBody.SaveToStream(Stream);
      PutStreamGoods(GoodsName,Stream);
   finally
      Stream.free;
   end;
end;

procedure TQBParcel.PutCDSGoods(GoodsName: Ansistring; GoodsBody: TClientDataset; GoodsDir: byte=1);
var
   i,j,k,l: integer;
   offsetaddr,GoodsSize: longint;
   Stream: TMemoryStream;
begin
   if (GoodsName='') or (not assigned(GoodsBody)) or (not GoodsBody.active) then
      exit;
   Stream:=TMemoryStream.Create;
   GoodsBody.SaveToStream(Stream,dfBinary);
   GoodsSize:=Stream.Size;
   j:=GetGoodsIndex(goodsname);
   if j=-1 then
      begin
         j:=AddGoodsIndex;
         ParcelHead[j].GoodsName:=uppercase(goodsname);
         ParcelHead[j].GoodsDirection:=GoodsDir;
         ParcelHead[j].GoodsType:=gtCDS;
         ParcelHead[j].OffsetAddress:=fParcelSize;
         ParcelHead[j].GoodsLength:=GoodsSize;                
         fParcelSize:=fParcelSize+GoodsSize;
         setlength(ParcelBody,fParcelSize);
         Stream.Position:=0;
         Stream.ReadBuffer(ParcelBody[ParcelHead[j].OffsetAddress],GoodsSize);      
      end
   else
      begin
         if ParcelHead[j].GoodsType<>gtCDS then
            exit;
         if ParcelHead[j].GoodsLength<>GoodsSize then
            begin
               for i:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength to fParcelSize-1 do
                  ParcelBody[i-ParcelHead[j].GoodsLength]:=ParcelBody[i];
               fParcelSize:=fParcelSize-ParcelHead[j].GoodsLength;
               setlength(ParcelBody,fParcelSize);
               k:=fParcelSize;
               l:=GoodsSize;
               fParcelSize:=fParcelSize+l;
               ParcelHead[j].GoodsLength:=l;
               setlength(ParcelBody,fParcelSize);
               for i:=k-1 downto ParcelHead[j].OffsetAddress do
                  ParcelBody[i+l]:=ParcelBody[i];
               offsetaddr:=ParcelHead[j].OffsetAddress+ParcelHead[j].GoodsLength;
               for i:=j+1 to fGoodsCount-1 do
                  begin
                     ParcelHead[i].OffsetAddress:=OffsetAddr;
                     OffsetAddr:=OffsetAddr+ParcelHead[i].GoodsLength;
                  end;
            end;
         Stream.Position:=0;
         Stream.ReadBuffer(ParcelBody[ParcelHead[j].OffsetAddress],GoodsSize);      
      end;
   Stream.Free;
end;

function TQBParcel.GetByteGoods(GoodsName: Ansistring): byte;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,1);          
end;

function TQBParcel.GetShortIntGoods(GoodsName: Ansistring): shortint;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,1);          
end;

function TQBParcel.GetWordGoods(GoodsName: Ansistring): word;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,2);          
end;

function TQBParcel.GetSmallIntGoods(GoodsName: Ansistring): smallint;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,2);          
end;

function TQBParcel.GetLongWordGoods(GoodsName: Ansistring): longword;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,4);          
end;

function TQBParcel.GetIntegerGoods(GoodsName: Ansistring): integer;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,4);          
end;

function TQBParcel.GetInt64Goods(GoodsName: Ansistring): int64;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,8);          
end;

function TQBParcel.GetBooleanGoods(GoodsName: Ansistring): boolean;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,1);          
end;

function TQBParcel.GetByteBoolGoods(GoodsName: Ansistring): bytebool;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,1);          
end;

function TQBParcel.GetWordBoolGoods(GoodsName: Ansistring): wordbool;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,2);          
end;

function TQBParcel.GetLongBoolGoods(GoodsName: Ansistring): longbool;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,4);          
end;

function TQBParcel.GetSingleGoods(GoodsName: Ansistring): single;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,4);          
end;

function TQBParcel.GetRealGoods(GoodsName: Ansistring): real;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,8);          
end;

function TQBParcel.GetdoubleGoods(GoodsName: Ansistring): double;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,8);          
end;

function TQBParcel.GetCompGoods(GoodsName: Ansistring): comp;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,8);          
end;

function TQBParcel.GetCurrencyGoods(GoodsName: Ansistring): currency;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,8);          
end;

function TQBParcel.GetExtendedGoods(GoodsName: Ansistring): extended;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,10);         
end;

function TQBParcel.GetDateTimeGoods(GoodsName: Ansistring): TDateTime;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,8);         
end;

function TQBParcel.GetDateGoods(GoodsName: Ansistring): TDate;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,8);         
end;

function TQBParcel.GetTimeGoods(GoodsName: Ansistring): TTime;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   move(ParcelBody[offsetaddr],result,8);         
end;

function TQBParcel.GetShortStringGoods(GoodsName: Ansistring): shortstring;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   setlength(result,ParcelHead[j].GoodsLength);                        
   if ParcelHead[j].GoodsLength>0 then
      move(ParcelBody[offsetaddr],result[1],ParcelHead[j].GoodsLength);   
end;

function TQBParcel.GetAnsiStringGoods(GoodsName: Ansistring): Ansistring;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   setlength(result,ParcelHead[j].GoodsLength);                        
   if ParcelHead[j].GoodsLength>0 then
      move(ParcelBody[offsetaddr],result[1],ParcelHead[j].GoodsLength);   
end;

function TQBParcel.GetWideStringGoods(GoodsName: Ansistring): WideString;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   setlength(result,ParcelHead[j].GoodsLength div sizeof(WideChar));          
   if ParcelHead[j].GoodsLength>0 then
      move(ParcelBody[offsetaddr],result[1],ParcelHead[j].GoodsLength);   
end;

function TQBParcel.GetStringGoods(GoodsName: Ansistring): string;
var
   tmpstr: AnsiString;
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   setlength(tmpstr,ParcelHead[j].GoodsLength);
   if ParcelHead[j].GoodsLength>0 then
      begin
         move(ParcelBody[offsetaddr],tmpstr[1],ParcelHead[j].GoodsLength);
         Result:=UnpackString(tmpstr);
      end
   else
      Result:='';
end;

function TQBParcel.GetEncryptStringGoods(GoodsName: Ansistring): ansistring;
var
   tmpstr,tmpstr1: AnsiString;
begin
   tmpstr:=GetAnsiStringGoods(GoodsName);
   if tmpstr='' then
      result:=''
   else
      begin
         Fish.DecString(tmpstr,tmpstr1);
         result:=tmpstr1;
      end;
end;

function TQBParcel.GetBinaryGoods(GoodsName: Ansistring): Ansistring;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      exit;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   SetLength(result,ParcelHead[j].GoodsLength);
   if ParcelHead[j].GoodsLength>0 then
      move(ParcelBody[offsetaddr],result[1],ParcelHead[j].GoodsLength);
end;

function TQBParcel.GetFileBlockGoods(GoodsName: AnsiString; fHandle: THandle): boolean;
var
   j,k: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      begin
         result:=false;
         exit;
      end;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   if ParcelHead[j].GoodsLength>0 then
      begin
         k:=FileWrite(fHandle,ParcelBody[OffsetAddr],ParcelHead[j].GoodsLength);
         result:=(k=ParcelHead[j].GoodsLength);
      end
   else
      result:=true;
end;

function TQBParcel.GetMemoryBlockGoods(GoodsName: Ansistring): pointer;
var
   j: integer;
   OffsetAddr: longint;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<=-1 then
      begin
         result:=pointer(0);
         exit;
      end;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   if ParcelHead[j].GoodsLength>0 then
      begin
         GetMem(Result,ParcelHead[j].GoodsLength);       
         move(ParcelBody[offsetaddr],result^,ParcelHead[j].GoodsLength);
      end
   else
      result:=pointer(0);
end;

function TQBParcel.GetStreamGoods(GoodsName: Ansistring; var aStream: TMemoryStream): boolean;
var
   tmpstr: Ansistring;
begin
   if aStream=nil then
      begin
         Result:=false;
         exit;
      end;
   tmpstr:='';
   tmpstr:=GetBinaryGoods(GoodsName);
   aStream.clear;
   if tmpstr<>'' then
      begin
         aStream.writebuffer(tmpstr[1],length(tmpstr));
         aStream.position:=0;
      end;
   result:=true;
end;

function TQBParcel.GetParcelGoods(GoodsName: Ansistring; var aParcel: TQBParcel): boolean;
var
   Stream: TMemoryStream;
begin
   if aParcel=nil then
      begin
         Result:=false;
         exit;
      end;
   Stream:=TMemoryStream.Create;
   try
      GetStreamGoods(GoodsName,Stream);
      aParcel.clear;
      aParcel.LoadFromStream(Stream);
      result:=true;
   except
      result:=false;
   end;
   Stream.free;
end;

function TQBParcel.GetCDSGoods(GoodsName: Ansistring; var aCds: tclientdataset): boolean;
var
   j: integer;
   OffsetAddr: longint;
   Stream: TMemoryStream;
begin
   j:=GetGoodsIndex(GoodsName);
   if (j<=-1) or (aCds=nil) then
      begin
         result:=false;
         exit;
      end;
   aCds.close;
   offsetaddr:=ParcelHead[j].OffsetAddress;
   Stream:=TMemoryStream.Create;
   Stream.WriteBuffer(ParcelBody[offsetaddr],ParcelHead[j].GoodsLength);   
   Stream.Position:=0;
   aCds.LoadFromStream(Stream);
   Stream.Free;
   Result:=true;
end;

procedure TQBParcel.RemoveGoods(GoodsName: AnsiString);
var
   i,j,k: integer;
begin
   j:=GetGoodsIndex(GoodsName);
   if j=-1 then
      exit;
   k:=ParcelHead[j].GoodsLength;
   if j<(fGoodsCount-1) then
      move(ParcelBody[ParcelHead[j].OffsetAddress+k],ParcelBody[ParcelHead[j].OffsetAddress],fParcelSize-ParcelHead[j].OffsetAddress-k);
   fParcelSize:=fParcelSize-k;
   SetLength(ParcelBody,fParcelSize);
   for i := j+1 to fGoodsCount - 1 do
      ParcelHead[i].OffsetAddress:=ParcelHead[i].OffsetAddress-k;
   for i:= j to fGoodsCount - 2 do
      ParcelHead[i]:=ParcelHead[i+1];
   Dec(fGoodsCount);
   SetLength(ParcelHead,fGoodsCount);
end;

function TQBParcel.GetGoodsName(GoodsIndex: integer): Ansistring;
begin
   if (GoodsIndex<0) or (GoodsIndex>=fGoodsCount) then
      begin
         Result:='';
         exit;
      end;
   Result:=ParcelHead[GoodsIndex].GoodsName;
end;

procedure TQBParcel.SetGoodsDirection(GoodsName: Ansistring; GoodsDir: byte);
var
   j: integer;
begin
   j:=GetGoodsIndex(GoodsName);
   if j<>-1 then
      ParcelHead[j].GoodsDirection:=GoodsDir;
end;

function TQBParcel.GetGoodsDirection(GoodsName: Ansistring): byte;
var
   j: integer;
begin
   j:=GetGoodsIndex(GoodsName);
   if j=-1 then
      result:=0
   else
      result:=ParcelHead[j].GoodsDirection;
end;

function TQBParcel.GetGoodsSize(GoodsName: Ansistring): Longint;
var
   j: integer;
begin
   j:=GetGoodsIndex(GoodsName);
   if j=-1 then
      result:=-1
   else
      result:=ParcelHead[j].GoodsLength;
end;

function TQBParcel.GetGoodsType(GoodsName: Ansistring): shortint;
var
   j: integer;
begin
   j:=GetGoodsIndex(GoodsName);
   if j=-1 then
      result:=-1
   else
      result:=ParcelHead[j].GoodsType;
end;

function TQBParcel.GoodsExists(GoodsName: Ansistring): Boolean;
begin
   result:=(GetGoodsIndex(GoodsName)<>-1);
end;

function TQBParcel.LoadFromStream(aStream: TMemoryStream): boolean;
var
   tmpstr,GoodsName: Ansistring;
   i: integer;
   LastBytes: longint;
begin
   if (not assigned(aStream)) or (aStream.Size-aStream.Position<8) then
      begin
         clear;
         Result:=false;
         exit;
      end;
   setlength(tmpstr,8);
   aStream.ReadBuffer(tmpstr[1],8);
   move(tmpstr[1],fGoodsCount,4);
   move(tmpstr[5],fParcelSize,4);
   if (fGoodsCount<=0) or (fParcelSize<0) then
      begin
         Clear;
         Result:=false;
         exit;
      end;
   LastBytes:=aStream.Size-aStream.Position;
   if fGoodsCount*40+fParcelSize>LastBytes then
      begin
         clear;
         Result:=false;
         exit;
      end;
   setlength(tmpstr,40);
   setlength(ParcelHead,fGoodsCount);
   for i:=0 to fGoodsCount-1 do
      begin
         aStream.ReadBuffer(tmpstr[1],40);
         setlength(GoodsName,30);
         move(tmpstr[1],GoodsName[1],30);
         ParcelHead[i].GoodsName:=trim(GoodsName);             
         move(tmpstr[31],ParcelHead[i].GoodsDirection,1);      
         move(tmpstr[32],ParcelHead[i].GoodsType,1);           
         move(tmpstr[33],ParcelHead[i].OffsetAddress,4);       
         move(tmpstr[37],ParcelHead[i].GoodsLength,4);         
      end;
   setlength(ParcelBody,fParcelSize);
   if fParcelSize>0 then
      aStream.ReadBuffer(ParcelBody[0],fParcelSize);
   result:=true;
end;

function TQBParcel.SaveToStream(var aStream: TMemoryStream): boolean;
var
   i: integer;
   tmpstr: Ansistring;
   IndexBuff: Ansistring;
begin
   aStream.clear;
   setlength(tmpstr,8);               
   move(fGoodsCount,tmpstr[1],4);     
   move(fParcelSize,tmpstr[5],4);     
   aStream.WriteBuffer(tmpstr[1],8);  
   setlength(indexBuff,40);
   for i:=0 to fGoodsCount-1 do
      begin
         tmpstr:=copy(ParcelHead[i].GoodsName,1,30);
         while length(tmpstr)<30 do
            tmpstr:=tmpstr+' ';
         move(tmpstr[1],IndexBuff[1],30);                         
         move(ParcelHead[i].GoodsDirection,IndexBuff[31],1);      
         move(ParcelHead[i].GoodsType,IndexBuff[32],1);           
         move(parcelhead[i].offsetaddress,indexbuff[33],4);       
         move(parcelhead[i].goodslength,indexbuff[37],4);         
         aStream.WriteBuffer(IndexBuff[1],40);
      end;
   if fParcelSize>0 then
      aStream.WriteBuffer(ParcelBody[0],fParcelSize);
   Result:=true;
end;

function TQBParcel.DecryptFromStream(aStream: TMemoryStream): boolean;
var
   tmpStream: TMemoryStream;
begin
   tmpStream:=TMemoryStream.Create;
   try
      Fish.DecStream(aStream,tmpStream);
      tmpStream.Position:=0;
      result:=LoadFromStream(tmpStream);
   except
      result:=false;
   end;
   tmpStream.Free;
end;

function TQBParcel.EncryptToStream(var aStream: TMemoryStream): boolean;
var
   tmpStream: TMemoryStream;
begin
   tmpStream:=TMemoryStream.Create;
   try
      result:=SaveToStream(tmpStream);
      if result then
         begin
            tmpStream.Position:=0;
            Fish.EncStream(tmpStream,aStream);
         end;
   except
      result:=false;
   end;
   tmpStream.Free;
end;

function TQBParcel.LoadFromFile(FileName: string): boolean;
var
   aStream: TMemoryStream;
begin
   Result:=false;
   if not fileexists(filename) then
      exit;
   aStream:=TMemoryStream.Create;
   try
      aStream.LoadFromFile(filename);
      aStream.Position:=0;
      result:=LoadFromStream(aStream);
   finally
      aStream.Free;
   end;
end;

function TQBParcel.SaveToFile(FileName: string): boolean;
var
   aStream: TMemoryStream;
begin
   aStream:=TMemoryStream.Create;
   try
      if SaveToStream(aStream) then
         begin
            aStream.Position:=0;
            aStream.SaveToFile(FileName);
            result:=true;
         end
      else
         result:=false;
   finally
      aStream.Free;
   end;
end;

function TQBParcel.LoadFromString(aStr: Ansistring): boolean;
var
   stream: TMemoryStream;
begin
   if length(aStr)<8 then
      begin
         result:=false;
         exit;
      end;
   Stream:=TMemoryStream.Create;
   stream.WriteBuffer(aStr[1],length(aStr));
   Stream.Position:=0;
   result:=LoadFromStream(Stream);
   Stream.Free;
end;

function TQBParcel.SaveToString(var aStr: Ansistring): boolean;
var
   stream: TMemoryStream;
begin
   Stream:=TMemoryStream.Create;
   result:=SaveToStream(Stream);
   if result then
      begin
         setlength(aStr,Stream.size);
         Stream.Position:=0;
         Stream.ReadBuffer(aStr[1],Stream.Size);
      end
   else
      aStr:='';
   Stream.Free;
end;

function TQBParcel.SaveToStringWithLength(var aStr: Ansistring): boolean;
var
   stream: TMemoryStream;
   LenStr: AnsiString;
   j: integer;
begin
   Stream:=TMemoryStream.Create;
   result:=SaveToStream(Stream);
   if result then
      begin
         LenStr:=AnsiString(inttostr(Stream.Size))+#13;
         j:=length(LenStr);
         setlength(aStr,j+Stream.size);
         move(LenStr[1],aStr[1],j);
         Stream.Position:=0;
         Stream.ReadBuffer(aStr[j+1],Stream.Size);
      end
   else
      aStr:='';
   Stream.Free;
end;

end.

