//
//---------------------------------------------------------------
//                                                               
//                                                               
//    QuickBurro Middleware Application Development Package      
//                                                               
//    Version 4.00                                               
//    Update Date: 2011.4.                                    
//    Author: Jopher(W.G.Z.)                                     
//    QQ: 779545524                                              
//    Email: Jopher@189.cn  or wpy020327@163.com                 
//                                                               
//    Copyright(C) Jopher Software Studio. All rights reserved   
//                                                               
//                                                               
//---------------------------------------------------------------
//
unit QBProgress;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, jpeg;

type
  TQBFormProgress = class(TForm)
    Image1: TImage;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    ProgressBar1: TProgressBar;
  private
    
  public
    
  end;

function CreateProgress(Prompt: string; Max: integer): TQBFormProgress;
procedure IncProgress(aPrgForm: TQBFormProgress);
procedure CloseProgress(aPrgForm: TQBFormProgress);

var
  FormProgress: TQBFormProgress;

implementation

{$R *.dfm}

function CreateProgress(Prompt: string; Max: integer): TQBFormProgress;
begin
   if max=0 then
      begin
         result:=nil;
         exit;
      end;
   Result:=TQBFormProgress.Create(nil);
   with result do
      begin
         progressbar1.Max:=max;
         progressbar1.Position:=0;
         label1.Caption:=prompt;
         label2.Caption:='0%';
      end;
   result.Show;
   application.ProcessMessages;
end;

procedure IncProgress(aPrgForm: TQBFormProgress);
begin
   if aPrgForm=nil then
      exit;
   with aPrgForm do
      begin
         if progressbar1.Position<progressbar1.Max then
            progressbar1.Position:=progressbar1.Position+1;
         label2.Caption:=inttostr(round((progressbar1.Position/progressbar1.max)*100+0.5))+'%';
      end;
   application.ProcessMessages;
end;

procedure CloseProgress(aPrgForm: TQBFormProgress);
begin
   if aPrgForm=nil then
      exit;
   aPrgForm.Close;
   aPrgForm.Free;
end;

end.
