//
//---------------------------------------------------------------
//                                                               
//                                                               
//    QuickBurro Middleware Application Development Package      
//                                                               
//    Version 4.0                                               
//    Update Date: 2011.4.18.                                    
//    Author: Jopher(W.G.Z.)                                     
//    QQ: 779545524                                              
//    Email: Jopher@189.cn  or wpy020327@163.com  
//    Homepage: http://www.jopher.net/               
//                                                               
//    Copyright(C) Jopher Software Studio. All rights reserved   
//                                                               
//                                                               
//---------------------------------------------------------------
//
unit RemoteSysInfo;

interface

uses
  Windows, Messages, SysUtils, Classes,
{$IFDEF UNICODE}
AnsiStrings,
{$ENDIF}
  UserConnection, QBParcel, Dbclient, TaskCommon, QBZlibExGz;

type
   TMouseInfo=record
      Buttons: integer;
      CursorScheme: String;
      CursorSchemes: String;
      DoubleClickHeight: integer;
      DoubleClickTime: integer;
      DoubleClickWidth: integer;
      Exist: boolean;
      HasWheel: boolean;
      SnapToDefault: boolean;
      Speed: integer;
      SwapButtons: boolean;
   end;
   TKeyboardInfo=record
      CapsLock: boolean;
      CaretBlinkTime: integer;
      Delay: integer;
      FunctionKeys: integer;
      Layout: String;
      NumLock: boolean;
      ScrollLock: boolean;
      Speed: integer;
      SubTypeId: integer;
      TypeId: integer;
      TypeString: String;
   end;
   TDriveRecord=record
      BytesPerSector: integer;
      DiskFree: integer;
      DiskSize: integer;
      DriveChar: String;
      DriveType: String;
      FileSystem: String;
      MaximumLength: integer;
      SectorsPerCluster: integer;
      SerialNumber: String;
      VolumeLabel: String;
   end;
   TDrivesInfo=record
      Count: integer;
      DriveList: array of TDriveRecord;
   end;
   TDisplayInfo=record
      BitsPerPixel: integer;
      Colors: integer;
      Frequency: integer;
      Height: integer;
      Interlaced: boolean;
      Monochrome: boolean;
      Plus_Available: boolean;
      Plus_DragFullWindows: boolean;
      Plus_FontSmoothing: boolean;
      Plus_WindowAnimation: boolean;
      ScreenSaver_Active: boolean;
      ScreenSaver_Delay: integer;
      ScreenSaver_Running: boolean;
      ScreenSaver_ScreenSaver: String;
      ScreenSaver_Secure: boolean;
      WallPaper_Filename: String;
      WallPaper_Pattern: String;
      WallPaper_Strech: boolean;
      WallPaper_Tile: boolean;
      Width: integer;
   end;
   TLocaleInfo=Record
      AfternoonSymbol: String;
      CalendarType: String;
      ClockMode: String;
      Country: String;
      CountryCode: String;
      CountrySymbol: String;
      CurrencyDecimalSeparator: String;
      CurrencyDigits: String;
      CurrencyGrouping: String;
      CurrencyGroupingSign: String;
      CurrencySymbol: String;
      DateSeparator: String;
      DecimalSeparator: String;
      Digits: String;
      FirstDayofWeek: String;
      FirstWeekOfYear: String;
      Grouping: String;
      InternationalCurrencySymbol: String;
      Language: String;
      LanguageEnglish: String;
      LanguageSymbol: String;
      ListSeparator: String;
      LongDateFormat: String;
      LongDateOrder: String;
      Measurement: String;
      MorningSymbol: String;
      NegativeCurrencyFormat: String;
      NegativeFormat: String;
      NegativeSign: String;
      PositiveCurrencyFormat: String;
      PositiveSign: String;
      ShortDateFormat: String;
      ShortDateOrder: String;
      ShowLeadingZero: String;
      ThousandSeparator: String;
      TimeFormat: String;
      TimeSeparator: String;
      YearDigits: String;
   end;
   TMemoryInfo=Record
      AllocationGranularity: integer;
      AvailablePageFile: integer;
      AvailablePhysicalMemory: integer;
      AvailableVirtual: integer;
      MaxAppAddress: integer;
      MemoryFormat: String;
      MemoryLoad: integer;
      MinAppAddress: integer;
      PageSize: integer;
      TotalPageFile: integer;
      TotalPhysicalMemory: integer;
      TotalVirtual: integer;
   end;
   TPowerInfo=Record
      ACLineStatus: String;
      BatteryFlags: String;
      BatteryFullLifeTime: integer;
      BatteryLifePercent: integer;
      BatteryLifeTime: integer;
   end;
   TWindowsInfo=Record
      BuildNumber: integer;
      CSDVersion: String;
      Environment: String;
      InstallDate: TDateTime;
      LastBoot: TDateTime;
      MajorVersion: integer;
      MinorVersion: integer;
      PlatformId: integer;
      ProductFullName: String;
      ProductId: String;
      ProductName: String;
      ProductSuite: String;
      ProductType: String;
      RegisteredCompany: String;
      RegisteredOwner: String;
      ServicePackMajor: integer;
      ServicePackMinor: integer;
      SystemDir: String;
      SystemFolders: String;
      TempDir: String;
      UpTimeString: String;
      VersionName: String;
      WindowsDir: String;
   end;
   TPrinterRecord=Record
      Collate: boolean;
      Comment: String;
      Copies: integer;
      CustomXRes: integer;
      CustomYRes: integer;
      DataType: String;
      DeviceName: String;
      Driver: String;
      DriverVersion: integer;
      Duplex: String;
      Location: String;
      Monochrome: boolean;
      Orientation: String;
      PaperLength: integer;
      PaperSize: String;
      PaperWidth: integer;
      Port: String;
      PrintProcessor: String;
      PrintProcessorParams: String;
      Quality: String;
      Scale: integer;
      SepFile: String;
      Server: String;
      StartTime: integer;
      TrueTypeOption: String;
      UntilTime: integer;
   end;
   TPrintersInfo=Record
      Count: integer;
      PrinterList: array of TPrinterRecord;
   end;
   TProcessorInfo=Record
      AMD3DNow: boolean;
      APIC: boolean;
      CMP_XCHG_8B: boolean;
      Cond_MOVE_Instruct: boolean;
      Count: integer;
      CPUId: string;
      CPUName: String;
      CPUVendor: String;
      DebuggingExtensions: Boolean;
      ExistCPUInfo: boolean;
      Family: integer;
      FPCond_MOVE_Instruct: Boolean;
      FPU: boolean;
      GlobalPaging: boolean;
      IDString: String;
      K86_ModelSpecificRegisters: boolean;
      MachineCheckException: boolean;
      MemoryTypeRangeRegisters: boolean;
      MMX: boolean;
      Model: integer;
      PageSizeExtensions: boolean;
      Stepping: integer;
      SYSCALLandSYSRET: boolean;
      TimeStampCounter: boolean;
      VirtualModelExtensions: boolean;
   end;
   TUninstallRecord=Record
      HelpLink: String;
      ProgramName: String;
      Publisher: String;
      PublisherURL: String;
      RegCompany: String;
      RegOwner: String;
      UninstallPath: String;
      UpdateInfoURL: String;
      Version: String;
   end;
   TUninstallsInfo=Record
      Count: integer;
      UninstallList: array of TUninstallRecord;
   end;
   TFontRecord=Record
      FontType: String;
      FullName: String;
      LogCharSet: String;
      LogClipPrecision: integer;
      LogEscapement: integer;
      LogFaceName: String;
      LogFamily: integer;
      LogHeight: integer;
      LogItalic: boolean;
      LogOrientation: integer;
      LogOutPrecision: integer;
      LogPitch: String;
      LogQuality: integer;
      LogStikeOut: boolean;
      LogUnderline: boolean;
      LogWeight: integer;
      LogWidth: integer;
      Script: String;
      Style: String;
      tmAscent: integer;
      tmAveCharWidth: integer;
      tmAvgWidth: String;
      tmBreakChar: String;
      tmCellHeight: integer;
      tmCharSet: String;
      tmDefaultChar: String;
      tmDescent: integer;
      tmDigitizedAspectX: integer;
      tmDigitizedAspectY: integer;
      tmExternalLeading: integer;
      tmFamily: integer;
      tmFirstChar: String;
      tmFlags: String;
      tmHeight: integer;
      tmInternalLeading: integer;
      tmItalic: boolean;
      tmLastChar: String;
      tmMaxCharWidth: integer;
      tmOverhang: integer;
      tmPitch: String;
      tmSizeEM: integer;
      tmStikeOut: boolean;
      tmUnderline: boolean;
      tmWeight: integer;
   end;
   TFontsInfo=Record
      Count: integer;
      FontList: array of TFontRecord;
   end;
   TFileAssociateRecord=Record
      ActionFile: String;
      ActionName: String;
      DefaultIconStr: String;
      Description: String;
      Ext: String;
   end;
   TFileAssociatesInfo=Record
      Count: integer;
      AssocList: array of TFileAssociateRecord;
   end;
   TInternetInfo=Record
      Browser: String;
      Calendar: String;
      Contacts: String;
      EMailClient: String;
      Homepage: String;
      HtmlEditor: String;
      InetCall: String;
      InetTempMaxSize: integer;
      InetTempPath: String;
      NewsClient: String;
   end;

type
  TRemoteSysInfo = class(TComponent)
  private
     fUserConn: TUserConnection;                
     fTaskTimeout: integer;                     
     fDllPassword: AnsiString;                  
     fTargetNodeId: AnsiString;
     RequestBody: AnsiString;
     ResponseBody: AnsiString;
     procedure SetConnection(Conn: TUserConnection);
     procedure SetTaskTimeout(seconds: integer);
     procedure SetDllPassword(Password: AnsiString);
     procedure SetTargetNodeId(aNodeId: AnsiString);
     function BinaryRPC(aPluginId: AnsiString; aPluginPassword: AnsiString; InParcel: TQBParcel; OutParcel: TQBParcel): boolean;

  protected
     procedure Notification(AComponent: TComponent;Operation: TOperation); override;

  public
     Constructor Create(AOwner: TComponent); override;           
     Destructor Destroy(); override;                             
     function GetMouseInfo(var aMouseInfo: TMouseInfo): boolean;
     function GetKeyboardInfo(var aKeyboardInfo: TKeyboardInfo): boolean;
     function GetDrivesInfo(var aDrivesInfo: TDrivesInfo): boolean;
     function GetDisplayInfo(var aDisplayInfo: TDisplayInfo): boolean;
     function GetLocaleInfo(var aLocaleInfo: TLocaleInfo): boolean;
     function GetMemoryInfo(var aMemoryInfo: TMemoryInfo): boolean;
     function GetPowerInfo(var aPowerInfo: TPowerInfo): boolean;
     function GetWindowsInfo(var aWindowsInfo: TWindowsInfo): boolean;
     function GetPrintersInfo(var aPrintersInfo: TPrintersInfo): boolean;
     function GetProcessorInfo(var aProcessorInfo: TProcessorInfo): boolean;
     function GetUninstallsInfo(var aUninstallsInfo: TUninstallsInfo): boolean;
     function GetFontsInfo(var aFontsInfo: TFontsInfo): boolean;
     function GetFileAssociatesInfo(var aFileAssociatesInfo: TFileAssociatesInfo): boolean;
     function GetInternetInfo(var aInternetInfo: TInternetInfo): boolean;

  published
     property UserConn: TUserConnection read fUserConn write SetConnection;
     property TaskTimeout: integer read fTaskTimeout write SetTaskTimeout;          
     property DllPassword: AnsiString read fDllPassword write SetDllPassword;       
     property TargetNodeId: AnsiString read fTargetNodeId write SetTargetNodeId;

  end;

procedure Register;

implementation

procedure Register;
begin
   RegisterComponents('QuickBurro Standard', [TRemoteSysInfo]);
end;

constructor TRemoteSysInfo.Create(AOwner: TComponent);
begin
   inherited;
   fUserConn:=nil;
   fTaskTimeout:=10;                  
   fTargetNodeId:='';
end;

destructor TRemoteSysInfo.Destroy;
begin
   inherited;
end;

procedure TRemoteSysInfo.SetConnection(Conn: TUserConnection);
begin
   if assigned(fUserConn) and (fUserConn=Conn) then
      exit;
   fUserConn:=Conn;
   fUserConn.FreeNotification(self);
end;

procedure TRemoteSysInfo.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if (Operation = opRemove) and (AComponent = fUserConn) then
    fUserConn := nil;
end;

procedure TRemoteSysInfo.SetTaskTimeout(seconds: integer);
begin
   if fTaskTimeout=Seconds then
      exit;
   if (seconds<1) or (seconds>300) then
      begin
         messagebox(GetActiveWindow,'Invalid value! (Must be 1-300 seconds)','Invalid',0);
         exit;
      end;
   fTaskTimeout:=seconds;
end;

procedure TRemoteSysInfo.SetDllPassword(Password: AnsiString);
begin
   if fDllPassword=trim(password) then
      exit;
   fDllPassword:=password;
end;

procedure TRemoteSysInfo.SetTargetNodeId(aNodeId: AnsiString);
begin
   if StrIComp(PAnsiChar(aNodeId),PAnsiChar(fTargetNodeId))=0 then
      exit;
   fTargetNodeId:=aNodeId;
end;

function TRemoteSysInfo.BinaryRPC(aPluginId: AnsiString; aPluginPassword: AnsiString; InParcel: TQBParcel; OutParcel: TQBParcel): boolean;
var
   Parcel: TQBParcel;
   Stream,Stream1: TMemoryStream;
   ok: boolean;
   errcode,errtext: string;
begin
   if (trim(fTargetNodeId)='') or (fUserConn=nil) or (not fUserConn.UserLogin) then
      begin
         result:=false;
         exit;
      end;
   Stream:=TMemoryStream.Create;
   Stream1:=TMemoryStream.Create;
   try
      ok:=InParcel.SaveToStream(Stream);
      if ok then
         begin
            Stream.Position:=0;
            GZCompressStream(Stream,Stream1);
            ok:=(Stream1.size>0);
         end;
   except
      ok:=false;
   end;
   if not ok then
      begin
         Stream.Free;
         Stream1.Free;
         result:=false;
         exit;
      end;
   Stream1.Position:=0;
   Parcel:=TQBParcel.Create;
   Parcel.EncryptKey:=fUserConn.TransferKey;
   Parcel.PutEncryptStringGoods('SystemFlag','Task_Request');
   Parcel.PutEncryptStringGoods('RequestUserId',fUserConn.UserId+'@'+fUserConn.UserNodeId);
   if StrIComp(PAnsiChar(fUserConn.UserNodeId),PAnsiChar(fTargetNodeId))=0 then
      Parcel.PutInt64Goods('SessionId',fUserConn.SessionId)
   else
      Parcel.PutInt64Goods('SessionId',fUserConn.PublicSessionId);
   Parcel.PutIntegerGoods('TaskId',53);
   Parcel.PutEncryptStringGoods('PluginId',aPluginId);
   Parcel.PutEncryptStringGoods('PluginPassword',aPluginPassword);
   Parcel.PutStreamGoods('InParcelStream',Stream1);
   Parcel.SaveToStringWithLength(RequestBody);
   Parcel.Free;
   result:=RemoteExecute(fUserConn,fTargetNodeId,RequestBody,fTaskTimeout,ResponseBody);
   if result then
      begin
         Parcel:=TQBParcel.Create;
         Parcel.EncryptKey:=fUserConn.TransferKey;
         Parcel.LoadFromString(ResponseBody);
         result:=(Parcel.GoodsCount>0);
         if result then
            begin
               result:=Parcel.GetBooleanGoods('ProcessResult');
               if result then
                  begin
                     if Parcel.GoodsExists('OutParcelStream') then
                        begin
                           Stream.Clear;
                           Stream1.Clear;
                           try
                              Parcel.GetStreamGoods('OutParcelStream',Stream);
                              GZDecompressStream(Stream,Stream1);
                              Stream1.Position:=0;
                              OutParcel.Clear;
                              result:=OutParcel.LoadFromStream(Stream1);
                           except
                              result:=false;
                           end;
                        end
                     else
                        Result:=true;
                  end;
            end;
         Parcel.Free;
      end;
   Stream.Free;
   Stream1.Free;
end;

function TRemoteSysInfo.GetMouseInfo(var aMouseInfo: TMouseInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',1);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aMouseInfo.Buttons:=OutParcel.GetIntegerGoods('Buttons');
         aMouseInfo.CursorScheme:=OutParcel.GetStringGoods('CursorScheme');
         aMouseInfo.CursorSchemes:=OutParcel.GetStringGoods('CursorSchemes');
         aMouseInfo.DoubleClickHeight:=OutParcel.GetIntegerGoods('DoubleClickHeight');
         aMouseInfo.DoubleClickTime:=OutParcel.GetIntegerGoods('DoubleClickTime');
         aMouseInfo.DoubleClickWidth:=OutParcel.GetIntegerGoods('DoubleClickWidth');
         aMouseInfo.Exist:=OutParcel.GetBooleanGoods('Exist');
         aMouseInfo.HasWheel:=OutParcel.GetBooleanGoods('HasWheel');
         aMouseInfo.SnapToDefault:=OutParcel.GetBooleanGoods('SnapToDefault');
         aMouseInfo.Speed:=OutParcel.GetIntegerGoods('Speed');
         aMouseInfo.SwapButtons:=OutParcel.GetBooleanGoods('SwapButtons');
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetKeyboardInfo(var aKeyboardInfo: TKeyboardInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',2);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aKeyboardInfo.CapsLock:=OutParcel.GetBooleanGoods('CapsLock');
         aKeyboardInfo.CaretBlinkTime:=OutParcel.GetintegerGoods('CaretBlinkTime');
         aKeyboardInfo.Delay:=OutParcel.GetintegerGoods('Delay');
         aKeyboardInfo.FunctionKeys:=OutParcel.GetintegerGoods('FunctionKeys');
         aKeyboardInfo.Layout:=OutParcel.GetStringGoods('Layout');
         aKeyboardInfo.NumLock:=OutParcel.GetbooleanGoods('NumLock');
         aKeyboardInfo.ScrollLock:=OutParcel.GetbooleanGoods('ScrollLock');
         aKeyboardInfo.Speed:=OutParcel.GetintegerGoods('Speed');
         aKeyboardInfo.SubTypeId:=OutParcel.GetintegerGoods('SubTypeId');
         aKeyboardInfo.TypeId:=OutParcel.GetintegerGoods('TypeId');
         aKeyboardInfo.TypeString:=OutParcel.GetStringGoods('TypeString');
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetDrivesInfo(var aDrivesInfo: TDrivesInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
   Cds: TClientDataset;
   ok: boolean;
   i: integer;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',3);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aDrivesInfo.Count:=OutParcel.GetIntegerGoods('Count');
         setlength(aDrivesInfo.DriveList,aDrivesInfo.Count);
         if aDrivesInfo.Count>0 then
            begin
               Cds:=TClientDataset.create(nil);
               try
                  if OutParcel.GetCDSGoods('DriveList',Cds) then
                     begin
                        i:=0;
                        cds.First;
                        while not cds.Eof do
                           begin
                              aDrivesInfo.DriveList[i].BytesPerSector:=Cds.fieldbyname('BytesPerSector').AsInteger;
                              aDrivesInfo.DriveList[i].DiskFree:=Cds.fieldbyname('DiskFree').AsInteger;
                              aDrivesInfo.DriveList[i].DiskSize:=Cds.fieldbyname('DiskSize').AsInteger;
                              aDrivesInfo.DriveList[i].DriveChar:=trim(Cds.fieldbyname('DriveChar').AsString);
                              aDrivesInfo.DriveList[i].DriveType:=trim(Cds.fieldbyname('DriveType').AsString);
                              aDrivesInfo.DriveList[i].FileSystem:=trim(Cds.fieldbyname('FileSystem').AsString);
                              aDrivesInfo.DriveList[i].MaximumLength:=Cds.Fieldbyname('MaximumLength').AsInteger;
                              aDrivesInfo.DriveList[i].SectorsPerCluster:=Cds.Fieldbyname('SectorsPerCluster').AsInteger;
                              aDrivesInfo.DriveList[i].SerialNumber:=trim(Cds.fieldbyname('SerialNumber').AsString);
                              aDrivesInfo.DriveList[i].VolumeLabel:=trim(Cds.fieldbyname('VolumeLabel').AsString);
                              Cds.Next;
                              inc(i);
                           end;
                        ok:=true;
                     end
                  else
                     ok:=false;
               finally
                  cds.free;
               end;
               result:=ok;
            end;
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetDisplayInfo(var aDisplayInfo: TDisplayInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',4);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aDisplayInfo.BitsPerPixel:=OutParcel.GetIntegerGoods('BitsPerPixel');
         aDisplayInfo.Colors:=OutParcel.GetintegerGoods('Colors');
         aDisplayInfo.Frequency:=OutParcel.GetintegerGoods('Frequency');
         aDisplayInfo.Height:=OutParcel.GetintegerGoods('Height');
         aDisplayInfo.Interlaced:=OutParcel.GetbooleanGoods('Interlaced');
         aDisplayInfo.Monochrome:=OutParcel.GetbooleanGoods('Monochrome');
         aDisplayInfo.Plus_Available:=OutParcel.GetbooleanGoods('Plus_Available');
         aDisplayInfo.Plus_DragFullWindows:=OutParcel.GetbooleanGoods('Plus_DragFullWindows');
         aDisplayInfo.Plus_FontSmoothing:=OutParcel.GetbooleanGoods('Plus_FontSmoothing');
         aDisplayInfo.Plus_WindowAnimation:=OutParcel.GetbooleanGoods('Plus_WindowAnimation');
         aDisplayInfo.ScreenSaver_Active:=OutParcel.GetbooleanGoods('ScreenSaver_Active');
         aDisplayInfo.ScreenSaver_Delay:=OutParcel.GetintegerGoods('ScreenSaver_Delay');
         aDisplayInfo.ScreenSaver_Running:=OutParcel.GetbooleanGoods('ScreenSaver_Running');
         aDisplayInfo.ScreenSaver_ScreenSaver:=OutParcel.GetStringGoods('ScreenSaver_ScreenSaver');
         aDisplayInfo.ScreenSaver_Secure:=OutParcel.GetbooleanGoods('ScreenSaver_Secure');
         aDisplayInfo.WallPaper_Filename:=OutParcel.GetStringGoods('WallPaper_Filename');
         aDisplayInfo.WallPaper_Pattern:=OutParcel.GetStringGoods('WallPaper_Pattern');
         aDisplayInfo.WallPaper_Strech:=OutParcel.GetbooleanGoods('WallPaper_Strech');
         aDisplayInfo.WallPaper_Tile:=OutParcel.GetbooleanGoods('WallPaper_Tile');
         aDisplayInfo.Width:=OutParcel.GetintegerGoods('Width');
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetLocaleInfo(var aLocaleInfo: TLocaleInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',5);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aLocaleInfo.AfternoonSymbol:=OutParcel.GetStringGoods('AfternoonSymbol');
         aLocaleInfo.CalendarType:=OutParcel.GetStringGoods('CalendarType');
         aLocaleInfo.ClockMode:=OutParcel.GetStringGoods('ClockMode');
         aLocaleInfo.Country:=OutParcel.GetStringGoods('Country');
         aLocaleInfo.CountryCode:=OutParcel.GetStringGoods('CountryCode');
         aLocaleInfo.CountrySymbol:=OutParcel.GetStringGoods('CountrySymbol');
         aLocaleInfo.CurrencyDecimalSeparator:=OutParcel.GetStringGoods('CurrencyDecimalSeparator');
         aLocaleInfo.CurrencyDigits:=OutParcel.GetStringGoods('CurrencyDigits');
         aLocaleInfo.CurrencyGrouping:=OutParcel.GetStringGoods('CurrencyGrouping');
         aLocaleInfo.CurrencyGroupingSign:=OutParcel.GetStringGoods('CurrencyGroupingSign');
         aLocaleInfo.CurrencySymbol:=OutParcel.GetStringGoods('CurrencySymbol');
         aLocaleInfo.DateSeparator:=OutParcel.GetStringGoods('DateSeparator');
         aLocaleInfo.DecimalSeparator:=OutParcel.GetStringGoods('DecimalSeparator');
         aLocaleInfo.Digits:=OutParcel.GetStringGoods('Digits');
         aLocaleInfo.FirstDayofWeek:=OutParcel.GetStringGoods('FirstDayofWeek');
         aLocaleInfo.FirstWeekOfYear:=OutParcel.GetStringGoods('FirstWeekOfYear');
         aLocaleInfo.Grouping:=OutParcel.GetStringGoods('Grouping');
         aLocaleInfo.InternationalCurrencySymbol:=OutParcel.GetStringGoods('InternationalCurrencySymbol');
         aLocaleInfo.Language:=OutParcel.GetStringGoods('Language');
         aLocaleInfo.LanguageEnglish:=OutParcel.GetStringGoods('LanguageEnglish');
         aLocaleInfo.LanguageSymbol:=OutParcel.GetStringGoods('LanguageSymbol');
         aLocaleInfo.ListSeparator:=OutParcel.GetStringGoods('ListSeparator');
         aLocaleInfo.LongDateFormat:=OutParcel.GetStringGoods('LongDateFormat');
         aLocaleInfo.LongDateOrder:=OutParcel.GetStringGoods('LongDateOrder');
         aLocaleInfo.Measurement:=OutParcel.GetStringGoods('Measurement');
         aLocaleInfo.MorningSymbol:=OutParcel.GetStringGoods('MorningSymbol');
         aLocaleInfo.NegativeCurrencyFormat:=OutParcel.GetStringGoods('NegativeCurrencyFormat');
         aLocaleInfo.NegativeFormat:=OutParcel.GetStringGoods('NegativeFormat');
         aLocaleInfo.NegativeSign:=OutParcel.GetStringGoods('NegativeSign');
         aLocaleInfo.PositiveCurrencyFormat:=OutParcel.GetStringGoods('PositiveCurrencyFormat');
         aLocaleInfo.PositiveSign:=OutParcel.GetStringGoods('PositiveSign');
         aLocaleInfo.ShortDateFormat:=OutParcel.GetStringGoods('ShortDateFormat');
         aLocaleInfo.ShortDateOrder:=OutParcel.GetStringGoods('ShortDateOrder');
         aLocaleInfo.ShowLeadingZero:=OutParcel.GetStringGoods('ShowLeadingZero');
         aLocaleInfo.ThousandSeparator:=OutParcel.GetStringGoods('ThousandSeparator');
         aLocaleInfo.TimeFormat:=OutParcel.GetStringGoods('TimeFormat');
         aLocaleInfo.TimeSeparator:=OutParcel.GetStringGoods('TimeSeparator');
         aLocaleInfo.YearDigits:=OutParcel.GetStringGoods('YearDigits');
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetMemoryInfo(var aMemoryInfo: TMemoryInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',6);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aMemoryInfo.AllocationGranularity:=OutParcel.GetintegerGoods('AllocationGranularity');
         aMemoryInfo.AvailablePageFile:=OutParcel.GetintegerGoods('AvailablePageFile');
         aMemoryInfo.AvailablePhysicalMemory:=OutParcel.GetintegerGoods('AvailablePhysicalMemory');
         aMemoryInfo.AvailableVirtual:=OutParcel.GetintegerGoods('AvailableVirtual');
         aMemoryInfo.MaxAppAddress:=OutParcel.GetintegerGoods('MaxAppAddress');
         aMemoryInfo.MemoryFormat:=OutParcel.GetStringGoods('MemoryFormat');
         aMemoryInfo.MemoryLoad:=OutParcel.GetintegerGoods('MemoryLoad');
         aMemoryInfo.MinAppAddress:=OutParcel.GetintegerGoods('MinAppAddress');
         aMemoryInfo.PageSize:=OutParcel.GetintegerGoods('PageSize');
         aMemoryInfo.TotalPageFile:=OutParcel.GetintegerGoods('TotalPageFile');
         aMemoryInfo.TotalPhysicalMemory:=OutParcel.GetintegerGoods('TotalPhysicalMemory');
         aMemoryInfo.TotalVirtual:=OutParcel.GetintegerGoods('TotalVirtual');
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetPowerInfo(var aPowerInfo: TPowerInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',7);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aPowerInfo.ACLineStatus:=OutParcel.GetStringGoods('ACLineStatus');
         aPowerInfo.BatteryFlags:=OutParcel.GetStringGoods('BatteryFlags');
         aPowerInfo.BatteryFullLifeTime:=OutParcel.GetintegerGoods('BatteryFullLifeTime');
         aPowerInfo.BatteryLifePercent:=OutParcel.GetintegerGoods('BatteryLifePercent');
         aPowerInfo.BatteryLifeTime:=OutParcel.GetintegerGoods('BatteryLifeTime');
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetWindowsInfo(var aWindowsInfo: TWindowsInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',8);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aWindowsInfo.BuildNumber:=OutParcel.GetintegerGoods('BuildNumber');
         aWindowsInfo.CSDVersion:=OutParcel.GetStringGoods('CSDVersion');
         aWindowsInfo.Environment:=OutParcel.GetStringGoods('Environment');
         aWindowsInfo.InstallDate:=OutParcel.GetDateTimeGoods('InstallDate');
         aWindowsInfo.LastBoot:=OutParcel.GetDateTimeGoods('LastBoot');
         aWindowsInfo.MajorVersion:=OutParcel.GetintegerGoods('MajorVersion');
         aWindowsInfo.MinorVersion:=OutParcel.GetintegerGoods('MinorVersion');
         aWindowsInfo.PlatformId:=OutParcel.GetintegerGoods('PlatformId');
         aWindowsInfo.ProductFullName:=OutParcel.GetStringGoods('ProductFullName');
         aWindowsInfo.ProductId:=OutParcel.GetStringGoods('ProductId');
         aWindowsInfo.ProductName:=OutParcel.GetStringGoods('ProductName');
         aWindowsInfo.ProductSuite:=OutParcel.GetStringGoods('ProductSuite');
         aWindowsInfo.ProductType:=OutParcel.GetStringGoods('ProductType');
         aWindowsInfo.RegisteredCompany:=OutParcel.GetStringGoods('RegisteredCompany');
         aWindowsInfo.RegisteredOwner:=OutParcel.GetStringGoods('RegisteredOwner');
         aWindowsInfo.ServicePackMajor:=OutParcel.GetintegerGoods('ServicePackMajor');
         aWindowsInfo.ServicePackMinor:=OutParcel.GetintegerGoods('ServicePackMinor');
         aWindowsInfo.SystemDir:=OutParcel.GetStringGoods('SystemDir');
         aWindowsInfo.SystemFolders:=OutParcel.GetStringGoods('SystemFolders');
         aWindowsInfo.TempDir:=OutParcel.GetStringGoods('TempDir');
         aWindowsInfo.UpTimeString:=OutParcel.GetStringGoods('UpTimeString');
         aWindowsInfo.VersionName:=OutParcel.GetStringGoods('VersionName');
         aWindowsInfo.WindowsDir:=OutParcel.GetStringGoods('WindowsDir');
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetPrintersInfo(var aPrintersInfo: TPrintersInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
   Cds: TClientDataset;
   i: integer;
   ok: boolean;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',9);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aPrintersInfo.Count:=OutParcel.GetIntegerGoods('Count');
         setlength(aPrintersInfo.PrinterList,aPrintersInfo.Count);
         if aPrintersInfo.Count>0 then
            begin
               Cds:=TClientDataset.create(nil);
               try
                  if OutParcel.GetCDSGoods('PrinterList',Cds) then
                     begin
                        i:=0;
                        cds.First;
                        while not cds.Eof do
                           begin
                              aPrintersInfo.PrinterList[i].Collate:=Cds.FieldByName('Collate').AsBoolean;
                              aPrintersInfo.PrinterList[i].Comment:=trim(Cds.FieldByName('Comment').AsString);
                              aPrintersInfo.PrinterList[i].Copies:=Cds.FieldByName('Copies').AsInteger;
                              aPrintersInfo.PrinterList[i].CustomXRes:=Cds.FieldByName('CustomXRes').AsInteger;
                              aPrintersInfo.PrinterList[i].CustomYRes:=Cds.FieldByName('CustomYRes').AsInteger;
                              aPrintersInfo.PrinterList[i].DataType:=trim(Cds.FieldByName('DataType').AsString);
                              aPrintersInfo.PrinterList[i].DeviceName:=trim(Cds.FieldByName('DeviceName').AsString);
                              aPrintersInfo.PrinterList[i].Driver:=trim(Cds.FieldByName('Driver').AsString);
                              aPrintersInfo.PrinterList[i].DriverVersion:=Cds.FieldByName('DriverVersion').AsInteger;
                              aPrintersInfo.PrinterList[i].Duplex:=trim(Cds.FieldByName('Duplex').AsString);
                              aPrintersInfo.PrinterList[i].Location:=trim(Cds.FieldByName('Location').AsString);
                              aPrintersInfo.PrinterList[i].Monochrome:=Cds.FieldByName('Monochrome').AsBoolean;
                              aPrintersInfo.PrinterList[i].Orientation:=trim(Cds.FieldByName('Orientation').AsString);
                              aPrintersInfo.PrinterList[i].PaperLength:=Cds.FieldByName('PaperLength').AsInteger;
                              aPrintersInfo.PrinterList[i].PaperSize:=trim(Cds.FieldByName('PaperSize').AsString);
                              aPrintersInfo.PrinterList[i].PaperWidth:=Cds.FieldByName('PaperWidth').AsInteger;
                              aPrintersInfo.PrinterList[i].Port:=trim(Cds.FieldByName('Port').AsString);
                              aPrintersInfo.PrinterList[i].PrintProcessor:=trim(Cds.FieldByName('PrintProcessor').AsString);
                              aPrintersInfo.PrinterList[i].PrintProcessorParams:=trim(Cds.FieldByName('PrintProcessorParams').AsString);
                              aPrintersInfo.PrinterList[i].Quality:=trim(Cds.FieldByName('Quality').AsString);
                              aPrintersInfo.PrinterList[i].Scale:=Cds.FieldByName('Scale').AsInteger;
                              aPrintersInfo.PrinterList[i].SepFile:=trim(Cds.FieldByName('SepFile').AsString);
                              aPrintersInfo.PrinterList[i].Server:=trim(Cds.FieldByName('Server').AsString);
                              aPrintersInfo.PrinterList[i].StartTime:=Cds.FieldByName('StartTime').AsInteger;
                              aPrintersInfo.PrinterList[i].TrueTypeOption:=trim(Cds.FieldByName('TrueTypeOption').AsString);
                              aPrintersInfo.PrinterList[i].UntilTime:=Cds.FieldByName('UntilTime').AsInteger;
                              Cds.Next;
                              inc(i);
                           end;
                        ok:=true;
                     end
                  else
                     ok:=false;
               finally
                  cds.free;
               end;
               result:=ok;
            end;
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetProcessorInfo(var aProcessorInfo: TProcessorInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',10);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aProcessorInfo.AMD3DNow:=OutParcel.GetbooleanGoods('AMD3DNow');
         aProcessorInfo.APIC:=OutParcel.GetbooleanGoods('APIC');
         aProcessorInfo.CMP_XCHG_8B:=OutParcel.GetbooleanGoods('CMP_XCHG_8B');
         aProcessorInfo.Cond_MOVE_Instruct:=OutParcel.GetbooleanGoods('Cond_MOVE_Instruct');
         aProcessorInfo.Count:=OutParcel.GetintegerGoods('Count');
         aProcessorInfo.CPUId:=OutParcel.GetStringGoods('CPUID');
         aProcessorInfo.CPUName:=OutParcel.GetStringGoods('CPUName');
         aProcessorInfo.CPUVendor:=OutParcel.GetStringGoods('CPUVendor');
         aProcessorInfo.DebuggingExtensions:=OutParcel.GetBooleanGoods('DebuggingExtensions');
         aProcessorInfo.ExistCPUInfo:=OutParcel.GetbooleanGoods('ExistCPUInfo');
         aProcessorInfo.Family:=OutParcel.GetintegerGoods('Family');
         aProcessorInfo.FPCond_MOVE_Instruct:=OutParcel.GetBooleanGoods('FPCond_MOVE_Instruct');
         aProcessorInfo.FPU:=OutParcel.GetbooleanGoods('FPU');
         aProcessorInfo.GlobalPaging:=OutParcel.GetbooleanGoods('GlobalPaging');
         aProcessorInfo.IDString:=OutParcel.GetStringGoods('IDString');
         aProcessorInfo.K86_ModelSpecificRegisters:=OutParcel.GetbooleanGoods('K86_ModelSpecificRegisters');
         aProcessorInfo.MachineCheckException:=OutParcel.GetbooleanGoods('MachineCheckException');
         aProcessorInfo.MemoryTypeRangeRegisters:=OutParcel.GetbooleanGoods('MemoryTypeRangeRegisters');
         aProcessorInfo.MMX:=OutParcel.GetbooleanGoods('MMX');
         aProcessorInfo.Model:=OutParcel.GetintegerGoods('Model');
         aProcessorInfo.PageSizeExtensions:=OutParcel.GetbooleanGoods('PageSizeExtensions');
         aProcessorInfo.Stepping:=OutParcel.GetintegerGoods('Stepping');
         aProcessorInfo.SYSCALLandSYSRET:=OutParcel.GetbooleanGoods('SYSCALLandSYSRET');
         aProcessorInfo.TimeStampCounter:=OutParcel.GetbooleanGoods('TimeStampCounter');
         aProcessorInfo.VirtualModelExtensions:=OutParcel.GetbooleanGoods('VirtualModelExtensions');
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetUninstallsInfo(var aUninstallsInfo: TUninstallsInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
   Cds: TClientDataset;
   i: integer;
   ok: boolean;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',11);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aUninstallsInfo.Count:=OutParcel.GetIntegerGoods('Count');
         setlength(aUninstallsInfo.UninstallList,aUninstallsInfo.Count);
         if aUninstallsInfo.Count>0 then
            begin
               Cds:=TClientDataset.create(nil);
               try
                  if OutParcel.GetCDSGoods('UninstallList',Cds) then
                     begin
                        i:=0;
                        cds.First;
                        while not cds.Eof do
                           begin
                              aUninstallsInfo.UninstallList[i].HelpLink:=String(trim(Cds.FieldByname('HelpLink').asstring));
                              aUninstallsInfo.UninstallList[i].ProgramName:=String(trim(Cds.FieldByname('ProgramName').asstring));
                              aUninstallsInfo.UninstallList[i].Publisher:=String(trim(Cds.FieldByname('Publisher').asstring));
                              aUninstallsInfo.UninstallList[i].PublisherURL:=String(trim(Cds.FieldByname('PublisherURL').asstring));
                              aUninstallsInfo.UninstallList[i].RegCompany:=String(trim(Cds.FieldByname('RegCompany').asstring));
                              aUninstallsInfo.UninstallList[i].RegOwner:=String(trim(Cds.FieldByname('RegOwner').asstring));
                              aUninstallsInfo.UninstallList[i].UninstallPath:=String(trim(Cds.FieldByname('UninstallPath').asstring));
                              aUninstallsInfo.UninstallList[i].UpdateInfoURL:=String(trim(Cds.FieldByname('UpdateInfoURL').asstring));
                              aUninstallsInfo.UninstallList[i].Version:=String(trim(Cds.FieldByname('Version').asstring));
                              Cds.Next;
                              inc(i);
                           end;
                        ok:=true;
                     end
                  else
                     ok:=false;
               finally
                  cds.free;
               end;
               result:=ok;
            end;
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetFontsInfo(var aFontsInfo: TFontsInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
   Cds: TClientDataset;
   i: integer;
   ok: boolean;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',12);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aFontsInfo.Count:=OutParcel.GetIntegerGoods('Count');
         setlength(aFontsInfo.FontList,aFontsInfo.Count);
         if aFontsInfo.Count>0 then
            begin
               Cds:=TClientDataset.create(nil);
               try
                  if OutParcel.GetCDSGoods('FontList',Cds) then
                     begin
                        i:=0;
                        cds.First;
                        while not cds.Eof do
                           begin
                              aFontsInfo.FontList[i].FontType:=String(trim(Cds.Fieldbyname('FontType').AsString));
                              aFontsInfo.FontList[i].FullName:=String(trim(Cds.Fieldbyname('FullName').AsString));
                              aFontsInfo.FontList[i].LogCharSet:=String(trim(Cds.Fieldbyname('LogCharSet').AsString));
                              aFontsInfo.FontList[i].LogClipPrecision:=Cds.Fieldbyname('LogClipPrecision').asinteger;
                              aFontsInfo.FontList[i].LogEscapement:=Cds.Fieldbyname('LogEscapement').asinteger;
                              aFontsInfo.FontList[i].LogFaceName:=String(trim(Cds.Fieldbyname('LogFaceName').AsString));
                              aFontsInfo.FontList[i].LogFamily:=Cds.Fieldbyname('LogFamily').asinteger;
                              aFontsInfo.FontList[i].LogHeight:=Cds.Fieldbyname('LogHeight').asinteger;
                              aFontsInfo.FontList[i].LogItalic:=Cds.Fieldbyname('LogItalic').asBoolean;
                              aFontsInfo.FontList[i].LogOrientation:=Cds.Fieldbyname('LogOrientation').asInteger;
                              aFontsInfo.FontList[i].LogOutPrecision:=Cds.Fieldbyname('LogOutPrecision').asInteger;
                              aFontsInfo.FontList[i].LogPitch:=String(trim(Cds.Fieldbyname('LogPitch').AsString));
                              aFontsInfo.FontList[i].LogQuality:=Cds.Fieldbyname('LogQuality').asInteger;
                              aFontsInfo.FontList[i].LogStikeOut:=Cds.Fieldbyname('LogStikeOut').asBoolean;
                              aFontsInfo.FontList[i].LogUnderline:=Cds.Fieldbyname('LogUnderline').asBoolean;
                              aFontsInfo.FontList[i].LogWeight:=Cds.Fieldbyname('LogWeight').asInteger;
                              aFontsInfo.FontList[i].LogWidth:=Cds.Fieldbyname('LogWidth').asInteger;
                              aFontsInfo.FontList[i].Script:=String(trim(Cds.Fieldbyname('Script').AsString));
                              aFontsInfo.FontList[i].Style:=String(trim(Cds.Fieldbyname('Style').AsString));
                              aFontsInfo.FontList[i].tmAscent:=Cds.Fieldbyname('tmAscent').asInteger;
                              aFontsInfo.FontList[i].tmAveCharWidth:=Cds.Fieldbyname('tmAveCharWidth').asInteger;
                              aFontsInfo.FontList[i].tmAvgWidth:=String(trim(Cds.Fieldbyname('tmAvgWidth').AsString));
                              aFontsInfo.FontList[i].tmBreakChar:=String(trim(Cds.Fieldbyname('tmBreakChar').AsString));
                              aFontsInfo.FontList[i].tmCellHeight:=Cds.Fieldbyname('tmCellHeight').asInteger;
                              aFontsInfo.FontList[i].tmCharSet:=String(trim(Cds.Fieldbyname('tmCharSet').AsString));
                              aFontsInfo.FontList[i].tmDefaultChar:=String(trim(Cds.Fieldbyname('tmDefaultChar').AsString));
                              aFontsInfo.FontList[i].tmDescent:=Cds.Fieldbyname('tmDescent').asInteger;
                              aFontsInfo.FontList[i].tmDigitizedAspectX:=Cds.Fieldbyname('tmDigitizedAspectX').asInteger;
                              aFontsInfo.FontList[i].tmDigitizedAspectY:=Cds.Fieldbyname('tmDigitizedAspectY').asInteger;
                              aFontsInfo.FontList[i].tmExternalLeading:=Cds.Fieldbyname('tmExternalLeading').asInteger;
                              aFontsInfo.FontList[i].tmFamily:=Cds.Fieldbyname('tmFamily').asInteger;
                              aFontsInfo.FontList[i].tmFirstChar:=String(trim(Cds.Fieldbyname('tmFirstChar').AsString));
                              aFontsInfo.FontList[i].tmFlags:=String(trim(Cds.Fieldbyname('tmFlags').AsString));
                              aFontsInfo.FontList[i].tmHeight:=Cds.Fieldbyname('tmHeight').asInteger;
                              aFontsInfo.FontList[i].tmInternalLeading:=Cds.Fieldbyname('tmInternalLeading').asInteger;
                              aFontsInfo.FontList[i].tmItalic:=Cds.Fieldbyname('tmItalic').asBoolean;
                              aFontsInfo.FontList[i].tmLastChar:=String(trim(Cds.Fieldbyname('tmLastChar').AsString));
                              aFontsInfo.FontList[i].tmMaxCharWidth:=Cds.Fieldbyname('tmMaxCharWidth').AsInteger;
                              aFontsInfo.FontList[i].tmOverhang:=Cds.Fieldbyname('tmOverhang').AsInteger;
                              aFontsInfo.FontList[i].tmPitch:=String(trim(Cds.Fieldbyname('tmPitch').AsString));
                              aFontsInfo.FontList[i].tmSizeEM:=Cds.Fieldbyname('tmSizeEM').AsInteger;
                              aFontsInfo.FontList[i].tmStikeOut:=Cds.Fieldbyname('tmStikeOut').asBoolean;
                              aFontsInfo.FontList[i].tmUnderline:=Cds.Fieldbyname('tmUnderline').asBoolean;
                              aFontsInfo.FontList[i].tmWeight:=Cds.Fieldbyname('tmWeight').AsInteger;
                              Cds.Next;
                              inc(i);
                           end;
                        ok:=true;
                     end
                  else
                     ok:=false;
               finally
                  cds.free;
               end;
               result:=ok;
            end;
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetFileAssociatesInfo(var aFileAssociatesInfo: TFileAssociatesInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
   Cds: TClientDataset;
   i: integer;
   ok: boolean;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',13);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aFileAssociatesInfo.Count:=OutParcel.GetIntegerGoods('Count');
         setlength(aFileAssociatesInfo.AssocList,aFileAssociatesInfo.Count);
         if aFileAssociatesInfo.Count>0 then
            begin
               Cds:=TClientDataset.create(nil);
               try
                  if OutParcel.GetCDSGoods('AssocList',Cds) then
                     begin
                        i:=0;
                        cds.First;
                        while not cds.Eof do
                           begin
                              aFileAssociatesInfo.AssocList[i].ActionFile:=String(trim(Cds.FieldByname('ActionFile').asstring));
                              aFileAssociatesInfo.AssocList[i].ActionName:=String(trim(Cds.FieldByname('ActionName').asstring));
                              aFileAssociatesInfo.AssocList[i].DefaultIconStr:=String(trim(Cds.FieldByname('DefaultIconStr').asstring));
                              aFileAssociatesInfo.AssocList[i].Description:=String(trim(Cds.FieldByname('Description').asstring));
                              aFileAssociatesInfo.AssocList[i].Ext:=String(trim(Cds.FieldByname('Ext').asstring));
                              Cds.Next;
                              inc(i);
                           end;
                        ok:=true;
                     end
                  else
                     ok:=false;
               finally
                  cds.free;
               end;
               result:=ok;
            end;
      end;
   InParcel.Free;
   OutParcel.Free;
end;

function TRemoteSysInfo.GetInternetInfo(var aInternetInfo: TInternetInfo): boolean;
var
   InParcel,OutParcel: TQBParcel;
begin
   InParcel:=TQBParcel.Create;
   InParcel.PutStringGoods('ModuleType','Public');
   InParcel.PutStringGoods('ModuleName','RemoteSysInfo');
   InParcel.PutIntegerGoods('FunctionId',14);
   OutParcel:=TQBParcel.Create;
   result:=BinaryRPC('remotesysinfo',fdllpassword,InParcel,OutParcel);
   if result then
      begin
         aInternetInfo.Browser:=OutParcel.GetStringGoods('Browser');
         aInternetInfo.Calendar:=OutParcel.GetStringGoods('Calendar');
         aInternetInfo.Contacts:=OutParcel.GetStringGoods('Contacts');
         aInternetInfo.EMailClient:=OutParcel.GetStringGoods('EMailClient');
         aInternetInfo.Homepage:=OutParcel.GetStringGoods('Homepage');
         aInternetInfo.HtmlEditor:=OutParcel.GetStringGoods('HtmlEditor');
         aInternetInfo.InetCall:=OutParcel.GetStringGoods('InetCall');
         aInternetInfo.InetTempMaxSize:=OutParcel.GetintegerGoods('InetTempMaxSize');
         aInternetInfo.InetTempPath:=OutParcel.GetStringGoods('InetTempPath');
         aInternetInfo.NewsClient:=OutParcel.GetStringGoods('NewsClient');
      end;
   InParcel.Free;
   OutParcel.Free;
end;

end.
