//
//---------------------------------------------------------------
//                                                               
//                                                               
//    QuickBurro Middleware Application Development Package      
//                                                               
//    Version 4.0                                               
//    Update Date: 2011.4.18.                                    
//    Author: Jopher(W.G.Z.)                                     
//    QQ: 779545524                                              
//    Email: Jopher@189.cn  or wpy020327@163.com  
//    Homepage: http://www.jopher.net/               
//                                                               
//    Copyright(C) Jopher Software Studio. All rights reserved   
//                                                               
//                                                               
//---------------------------------------------------------------
//
unit SoftWarrant;

interface

uses
   Windows, SysUtils, Classes,
{$IFDEF UNICODE}
AnsiStrings,
{$ENDIF}
   QBMisc;

type
   TMachineCode = function (VaryKey: pAnsichar; SectionLen: integer; var MachineCode: pAnsichar): boolean; stdcall;
   TRegisteCode = function (VaryKey: pAnsichar; EncryptKey: pAnsichar; aDomain: pAnsichar; SectionLen: integer; var RegCode: pAnsichar): boolean; stdcall;
   TConvertCode = function (VaryKey: pAnsichar; EncryptKey: pAnsichar; aDomain: pAnsichar; aMachCode: pAnsichar; var RegCode: pAnsichar): boolean; stdcall;
   TAuthorizedEvent = procedure (Sender: TObject) of object;
   TUnauthorizedEvent = procedure (Sender: TObject) of object;

type
   TSoftWarrant=class(TComponent)
   private
      fSectionLength: integer;
      fVaryKey: Ansistring;
      fEncryptKey: Ansistring;
      fBindDomain: Ansistring;
      fUserRegCode: Ansistring;
      fOnAuthorized: TAuthorizedEvent;
      fOnUnauthorized: TUnauthorizedEvent;
      ModuleHandle: dword;
      _GetMachineCode: TMachineCode;
      _GetRegisteCode: TRegisteCode;
      _MCodeToRCode: TConvertCode;
      procedure SetSectionLength(SectionLen: integer);
      procedure SetVaryKey(key: Ansistring);
      procedure SetEncryptKey(key: Ansistring);
      procedure SetUserRegCode(RegCode: Ansistring);
   protected

   public
      constructor Create(AOwner: TComponent); override;
      destructor Destroy(); override;
      function GetMachineCode(): Ansistring;
      function GetRegisteCode(): Ansistring;
      function MachCodeToRegCode(MachCode: Ansistring): Ansistring;
      procedure StartAuthorize;

   published
      property SectionLength: integer read fSectionLength write SetSectionLength;
      property VaryKey: Ansistring read fVaryKey write SetVaryKey;
      property EncryptKey: Ansistring read fEncryptKey write SetEncryptKey;
      property BindDomain: Ansistring read fBindDomain write fBindDomain;
      property UserRegCode: Ansistring read fUserRegCode write SetUserRegCode;
      property OnAuthorized: TAuthorizedEvent read fOnAuthorized write fOnAuthorized;
      property OnUnauthorized: TUnauthorizedEvent read fOnUnauthorized write fOnUnauthorized;

end;

procedure Register;

implementation

{$R softwarrant.res}

procedure Register;
begin
  RegisterComponents('QuickBurro Basic', [TSoftWarrant]);
end;

constructor TSoftWarrant.Create(AOwner: TComponent);
var
   RStream: TResourceStream;
   TmpDir: string;
   TmpData: Ansistring;
   Stream: TMemoryStream;
   i,DataSize: integer;
   x: Pointer;
begin
   inherited;
   fSectionLength:=5;
   fVaryKey:='THIS1IS2A3VARY4KEYHAHA';
   fEncryptKey:='OH9MY8GUD7HA6HA5YEAH4O';
   fBindDomain:='';
   fUserRegCode:='';
   try
      RStream:= TResourceStream.Create(hInstance,'RegCore', 'Binary');
   except
      raise exception.Create('Resource file error1!');
      exit;
   end;
   try
      RStream.position:=0;
      DataSize:=RStream.size;
      setlength(TmpData,DataSize);
      RStream.ReadBuffer(TmpData[1],DataSize);
   finally
      RStream.free;
   end;
   for i:=1 to DataSize do
      TmpData[i]:=Ansichar(ord(TmpData[i]) xor (i mod 128));
   TmpDir:=QBMisc.GetSystemDir;
   if copy(tmpdir,length(tmpdir),1)<>'\' then
      tmpdir:=tmpdir+'\';
   Stream:=TMemoryStream.Create;
   Stream.Write(tmpData[1],length(tmpData));
   Stream.Position:=0;
   if fileexists(tmpdir+'qbindent.dll') then
      deletefile(tmpdir+'qbindent.dll');
   if not fileexists(tmpdir+'qbindent.dll') then
      Stream.SaveToFile(tmpdir+'qbindent.dll');
   ModuleHandle:=LoadLibrary(pchar(tmpdir+'qbindent.dll'));
   Stream.Free;
   if ModuleHandle=0 then
      begin
         raise exception.Create('Resource file error2!');
         exit;
      end;
   x:=GetProcAddress(ModuleHandle,'EnvironMark');
   if x=nil then
      begin
         FreeLibrary(ModuleHandle);
         raise exception.Create('Resource file error3!');
         exit;
      end;
   _GetMachineCode:=TMachineCode(x);
   x:=GetProcAddress(ModuleHandle,'WarrantMark');
   if x=nil then
      begin
         FreeLibrary(ModuleHandle);
         raise exception.Create('Resource file error4!');
         exit;
      end;
   _GetRegisteCode:=TRegisteCode(x);
   x:=GetProcAddress(ModuleHandle,'ConvertMark');
   if x=nil then
      begin
         FreeLibrary(ModuleHandle);
         raise exception.Create('Resource file error5!');
         exit;
      end;
   _MCodeToRCode:=TConvertCode(x);
end;

destructor TSoftWarrant.Destroy();
begin
   FreeLibrary(ModuleHandle);
   inherited;
end;

procedure TSoftWarrant.SetSectionLength(SectionLen: integer);
begin
   if (SectionLen<4) or (SectionLen>6) then
      begin
         messagebox(GetActiveWindow,'Invalid section length value! (Must be one of 4,5,6)','Invalid',0);
         exit;
      end;
   fSectionLength:=SectionLen;
end;

procedure TSoftWarrant.SetVaryKey(key: Ansistring);
begin
   if fVaryKey=key then
      exit;
   fVaryKey:=key;
end;

procedure TSoftWarrant.SetEncryptKey(key: Ansistring);
begin
   if fEncryptKey=key then
      exit;
   fEncryptKey:=key;
end;

procedure TSoftWarrant.SetUserRegCode(RegCode: Ansistring);
begin
   if fUserRegCode=RegCode then
      exit;
   fUserRegCode:=RegCode;
end;

function TSoftWarrant.GetMachineCode(): Ansistring;
var
   code: pAnsichar;
   bsize: integer;
begin
   if fSectionLength=4 then
      bsize:=19
   else
      begin
         if fSectionLength=5 then
            bsize:=23
         else
            bsize:=27;
      end;
   code:=allocmem(bsize);
   if not _GetMachineCode(pAnsichar(fVaryKey), fSectionLength, code) then
      result:=''
   else
      begin
         SetLength(Result,bsize);
         move(Code^,Result[1],bsize);
      end;
   freemem(code);
end;

function TSoftWarrant.GetRegisteCode(): Ansistring;
var
   code: pAnsichar;
   bsize: integer;
begin
   if fSectionLength=4 then
      bsize:=19
   else
      begin
         if fSectionLength=5 then
            bsize:=23
         else
            bsize:=27;
      end;
   code:=allocmem(bsize);
   if not _GetRegisteCode(pAnsichar(fVaryKey),pAnsichar(fEncryptKey), pAnsichar(fBindDomain), fSectionLength, code) then
      result:=''
   else
      begin
         SetLength(Result,bsize);
         move(Code^,Result[1],bsize);
      end;
   freemem(code);
end;

function TSoftWarrant.MachCodeToRegCode(MachCode: Ansistring): Ansistring;
var
   code: pAnsichar;
   bsize: integer;
begin
   bsize:=length(MachCode);
   code:=allocmem(bsize);
   if not _MCodeToRCode(pAnsichar(fVaryKey),pAnsichar(fEncryptKey), pAnsichar(fBindDomain), pAnsichar(MachCode), code) then
      result:=''
   else
      begin
         SetLength(Result,bsize);
         move(Code^,Result[1],bsize);
      end;
   freemem(code);
end;

procedure TSoftWarrant.StartAuthorize;
var
   tmpstr: Ansistring;
begin
   tmpstr:=GetRegisteCode;
   if tmpstr=fUserRegCode then
      begin
         if assigned(fOnAuthorized) then
            fOnAuthorized(self);
      end
   else
      begin
         if assigned(fOnUnauthorized) then
            fOnUnauthorized(self);
      end;
end;

end.
