//
//---------------------------------------------------------------
//                                                               
//                                                               
//    QuickBurro Middleware Application Development Package      
//                                                               
//    Version 4.0                                               
//    Update Date: 2011.4.18.                                    
//    Author: Jopher(W.G.Z.)                                     
//    QQ: 779545524                                              
//    Email: Jopher@189.cn  or wpy020327@163.com  
//    Homepage: http://www.jopher.net/               
//                                                               
//    Copyright(C) Jopher Software Studio. All rights reserved   
//                                                               
//                                                               
//---------------------------------------------------------------
//
unit TransactionHeartbeat;

{$HINTS OFF}
{$WARNINGS OFF}

interface

uses
   windows, Messages, SysUtils, Classes, Forms, QBParcel, TaskCommon;

type
   TTransactionHeartbeatThread=class(TThread)
   private
      MainObj: TComponent;
      HeartbeatInterval: integer;
      LastDateTime: TDateTime;
      RequestBody,ResponseBody: AnsiString;

   protected
      procedure Execute; override;

   public
      Constructor Create(ParentObj: TComponent; SuspendedOnCreate: boolean); Overload;
      Destructor Destroy; Override;

   end;

implementation

uses DbAccessor;

Constructor TTransactionHeartbeatThread.Create(ParentObj: TComponent; SuspendedOnCreate: boolean);
begin
   Inherited Create(SuspendedOnCreate);
   freeOnTerminate:=true;
   MainObj:=ParentObj;
   HeartbeatInterval:=120;
   LastDateTime:=now;
end;

Destructor TTransactionHeartbeatThread.Destroy;
begin
   Inherited Destroy;
end;

procedure TTransactionHeartbeatThread.Execute;
var
   MainAccess: TDbAccessor;
   Parcel: TQBParcel;
   ok: boolean;
begin
   MainAccess:=(MainObj as TDbAccessor);
   while not terminated do
      begin
         LastDateTime:=now;
         while (not terminated) and (round((now-lastdatetime)*24*60*60)<HeartbeatInterval) do
            sleep(500);
         if not terminated then
            begin
               Parcel:=TQBParcel.Create;
               Parcel.EncryptKey:=MainAccess.UserConnection.TransferKey;
               Parcel.PutEncryptStringGoods('SystemFlag','Message_Request');
               Parcel.PutInt64Goods('SessionId',MainAccess.UserConnection.PublicSessionId);
               Parcel.PutIntegerGoods('RequestId',10);
               Parcel.PutInt64Goods('TransSessionId',MainAccess.DbTransSessionId);
               Parcel.SaveToStringWithLength(RequestBody);
               Parcel.Free;
               ok:=RemoteMsgExecute(MainAccess.UserConnection,MainAccess.TargetNodeId,RequestBody,MainAccess.TaskTimeout,ResponseBody);
               if ok then
                  begin
                     Parcel:=TQBParcel.Create;
                     Parcel.EncryptKey:=MainAccess.UserConnection.TransferKey;
                     Parcel.LoadFromString(ResponseBody);
                     if Parcel.GoodsCount>0 then
                        begin
                           if not Parcel.GetBooleanGoods('ProcessResult') then
                              begin
                                 Parcel.Free;
                                 synchronize(self.Suspend);
                              end
                           else
                              Parcel.Free;
                        end
                     else
                        begin
                           Parcel.Free;
                           synchronize(self.Suspend);
                        end;
                  end
               else
                  synchronize(self.Suspend);
            end;
      end;
end;

end.
