//
//---------------------------------------------------------------
//                                                               
//                                                               
//    QuickBurro Middleware Application Development Package      
//                                                               
//    Version 4.0                                               
//    Update Date: 2011.4.18.                                    
//    Author: Jopher(W.G.Z.)                                     
//    QQ: 779545524                                              
//    Email: Jopher@189.cn  or wpy020327@163.com  
//    Homepage: http://www.jopher.net/               
//                                                               
//    Copyright(C) Jopher Software Studio. All rights reserved   
//                                                               
//                                                               
//---------------------------------------------------------------
//
unit UserRequest;

{$HINTS OFF}
{$WARNINGS OFF}

interface
   uses windows, Messages, SysUtils, Classes, BurroSocket, QBParcel;

type
   TSendRequestThread=class(TThread)
   private
      Socket: TBClientWinSocket;
      RequestParcel: TQBParcel;
      MainObj: TComponent;

   protected
      procedure Execute; override;
      function SendRequest: boolean;

   public
      Constructor Create(ParentObj: TComponent; SuspendedOnCreate: boolean); Overload;
      Destructor Destroy; Override;

   end;

implementation

uses UserConnection;

Constructor TSendRequestThread.Create(ParentObj: TComponent; SuspendedOnCreate: boolean);
begin
   Inherited Create(SuspendedOnCreate);
   freeOnTerminate:=true;
   MainObj:=ParentObj;
end;

Destructor TSendRequestThread.Destroy;
begin
   Inherited Destroy;
end;

procedure TSendRequestThread.Execute;
var
   MainConnection: TUserConnection;
begin
   MainConnection:=(MainObj as TUserConnection);
   while not terminated do
      begin
         RequestParcel:=MainConnection.PopRequest;
         if RequestParcel=nil then
            begin
               Synchronize(self.Suspend);
               continue;
            end;
         Socket:=MainConnection.UserSocket.Socket;
         SendRequest;
         RequestParcel.Free;
      end;
end;

function TSendRequestThread.SendRequest: boolean;
var
   AllLength,BlockSize: integer;
   Ptr,bytes: integer;
   RequestBody: AnsiString;
begin
   RequestParcel.SavetoStringWithLength(RequestBody);
   AllLength:=length(RequestBody);
   ptr:=1;
   while (not terminated) and Socket.Connected and (ptr<=AllLength) do
      begin
         if AllLength-Ptr>65536 then
            BlockSize:=65536
         else
            BlockSize:=(AllLength-Ptr)+1;
         try
            bytes:=socket.SendBuf(RequestBody[ptr],BlockSize);
         except
            bytes:=-1;
         end;
         if bytes<0 then
            break;
         if bytes>0 then
            ptr:=ptr+bytes;
         sleep(1);
      end;
   result:=(ptr>AllLength);
end;

end.
